<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	
require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

$for = $_REQUEST['for'];
$in = "*";
$format = "xml";

$includerelated = 0;

if (isset($_REQUEST['related']))
{
	$includerelated = $_REQUEST['related'];
}

$in = $_REQUEST['in'];
$forlist = explode('|',$_REQUEST['for']);

if ($in == "*")
{
	return false;
}

$inlist = "";
foreach($forlist as $f)
{
	if ($inlist != "")
	{
		$inlist .= ",";
	}
	$inlist .= $db->quote($f);
}

//echo "SELECT name,id,value FROM assetvalues JOIN assets ON (assetvalues.assetid = assets.id) WHERE (propertyid=".$in." AND LOWER(value) IN (".$inlist.") )";

echo '<results>';
	
$query = $db->query("SELECT name,id,value FROM assetvalues JOIN assets ON (assetvalues.assetid = assets.id) WHERE (propertyid=".$in." AND LOWER(value) IN (".$inlist.") )");
		
while($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	echo '<result id="'.$row['id'].'" name="'.$row['name'].'" value="'.$row['value'].'"';
	if ($includerelated != 0)
	{
		echo '>';
		
		//OK - check out what items this is related to...
		include($sitefolder.'/cache/relationships/'.$row['id'].'.inc');
		if (isset($asset[$row['id']]['relationships'][$includerelated]))
		{
			foreach($asset[$row['id']]['relationships'][$includerelated] as $r)
			{
				echo "\r\n".'    <';
				if ($r['upstream'] == true) 
					echo 'parent';
				else
					echo 'child';
				
				include($sitefolder.'/cache/relationships/'.$r['target'].'.inc');
				
				echo ' id="'.$r['target'].'" name="'.$asset[$r['target']]['name'].'"/>';
			}
		}
		echo '</result>';
	}
	else
		echo '/>';
}	
		
echo '</results>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>