<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	
require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

if (!isset($_REQUEST['origin']))
{
	exit;
}

if (!isset($_REQUEST['name']))
{
	exit;
}

if (!isset($_REQUEST['desc']))
{
	exit;
}

if (!isset($_REQUEST['relationship']))
{
	exit;
}

$format = "xml";
$name = $_REQUEST['name'];
$desc = $_REQUEST['desc'];
$origin = $_REQUEST['origin'];
$rel = $_REQUEST['relationship'];

$origin = filter_var($origin,FILTER_VALIDATE_INT);
if ($origin === FALSE) exit;

$rel = filter_var($rel,FILTER_VALIDATE_INT);
if ($rel === FALSE) exit;

$tagwith = array();
if (isset($_REQUEST['tagwith']))
{
	$tagwith = explode(',',$_REQUEST['tagwith']);
}

function AssignTags($tagas,$id)
{
	global $db;
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/closuretables.php');	
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/cacheobject.php');		

	foreach($tagas as $itm)
	{
		$db->query('INSERT INTO assetrelationships (childasset,parentasset,relationship) VALUES ('.$id.','.$itm.',3)');
	}
	
	$db->query('DELETE FROM assetrelclosures WHERE relationship=3 AND childasset='.$itemid);
				
	RebuildObjectClosureTable($id,3);
	RebuildObjectCacheByID($id);	
	
	return true;
}

echo '<response>';

require($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');

if ($origin != "")
{		
	$newid = CreateAssetAfter($name,$desc,$origin,$rel);
																				
	if ($rel != 3)
	{
		AssignTags($tagwith, $newid);
	}
}
	
echo '   <success id="'.$newid.'"/>';

		
echo '</response>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>