<?php
/**
 * Used to query only the dynamic elements of an object
 *
 * Unlike 'dynamic', which only queries dynamic properties, this also
 *   refreshes isolation status
 *
 * This is usually used to refresh data on an object that has already been
 *   loaded with /api/getall
 *
 * @author Steven Harding
 */
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
	require_once('../assets/ui/displayfunctions.php');
	require_once('../assets/dynamicdata.php');	
	
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	$itemid = $_REQUEST['asset'];	
	
	echo '<dataupdates>';	
	echo '  <isolation>';
	require('getisostatus.php');
	echo '</isolation>';

	//OK - fetch the data we need...
	$query = $db->query('SELECT propertyid FROM datalinks WHERE assetid='.$_REQUEST['asset']);

	$dynamicdata = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$dynamicdata[] = $row['propertyid'];
	}
	
//	require_once('../datalink/fetch.php');
	
	//OK - load details of this property and the property value...
	//$query = $db->query('SELECT typename, options, value,name FROM properties JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE properties.id='.$_REQUEST['property'].' AND assetvalues.assetid='.$_REQUEST['asset']);	
	
	$query = $db->query('SELECT properties.id,typename, options, value, name 
FROM properties JOIN assetproperties ON ( assetproperties.propertyid = properties.id ) LEFT OUTER JOIN assetvalues ON ( assetvalues.propertyid = properties.id ) WHERE assetproperties.assetid='.$_REQUEST['asset']);	

	$properties = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if (!in_array($row['id'],$dynamicdata)) continue;
		$info = array();
		$info['basevalue'] = $row['value'];
		$info['options'] = $row['options'];
		$info['module'] = $row['typename'];
		$info['propname'] = $row['name'];
		$properties[$row['id']] = $info;		
	}
	
	$value = array();	
	
	foreach($properties as $k => $prop)
	{
		$bits = explode('|',$prop['basevalue']);
		
		$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($prop['module']).'.php';
		if (file_exists($modulefile))
		{
			//Import module...
			include ($modulefile);
					
			for($x=0;$x<count($inputs);$x++)
			{
				if ((!isset($bits[$x])) || ($bits[$x] == "")) 
				{
					//echo 'Value Not Set...';
					if (isset($inputs[$x]['default']))
						$value[$inputs[$x]['name']] = LinkedData($_REQUEST['asset'],$k,$inputs[$x]['name'],$inputs[$x]['default']);
					else
						$value[$inputs[$x]['name']] = LinkedData($_REQUEST['asset'],$k,$inputs[$x]['name'],'');				
					continue;
				}
				$value[$inputs[$x]['name']] = LinkedData($_REQUEST['asset'],$k,$inputs[$x]['name'],$bits[$x]);
			}
		}
		
		//OK - let's output these...
		
		$nm = str_replace(")","",str_replace("(","_",str_replace(" ","",$prop['propname'])));
		if (!file_exists($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($prop['module']).'.php'))
		{
			$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($prop['module']).'.php';
			
			echo '<'.$nm.' type="'.$prop['module'].'" name="'.ucwords($prop['propname']).'">';
	
			if (file_exists($modulefile))
			{
				require($modulefile);
				if (count($inputs) == 1)
				{
					echo $value[$inputs[0]['name']];		
				}
				else
				{					
						for($x=0;$x<count($inputs);$x++)
						{
							$n = str_replace(")","",str_replace("(","_",str_replace(" ","",$inputs[$x]['name'])));							
							echo '<'.$n.'>'.$value[$inputs[$x]['name']].'</'.$n.'>';						
						}
					
				}
			}
			else
			{
				echo implode('|',$value);	
			}
			echo '</'.$nm.'>';		
		}
		else		
		{
			$value = '';
			$name = $prop['propname'];
			$media = false;
			$propid = $k;			
						
			require($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($prop['module']).'.php');						
		}	
	}
	UpdateLinkedData();
		
	
	echo '</dataupdates>';
	//include($_SERVER['DOCUMENT_ROOT'].'/modules/'.strtolower($module).'.php');

?>