<?php
/**
 * Driver Function - Get driver details
 * 
 * During initialisation, this function is called to determine what
 *    sources need to be launched by each driver.
 *
 * Individual sources then get their own information from 'sourcedata'
 *
 * @author Steven Harding
 */	
 

	
	if (!isset($_REQUEST['port'])) exit;

	$port = filter_var($_REQUEST['port'],FILTER_VALIDATE_INT);
	if ($port === FALSE) exit;
			
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	echo '<driverdata>';	
	
	$conhost = "";
	$conport = $ini['services']['dataport'];
	if (isset($ini['services']['datahost']))
	{
		$conhost = $ini['services']['datahost'];
	}
	
	//OK - fetch the data we need...
	$query = $db->query('SELECT assetid,datadriver.address, datadriver.mode,datadriver.driver,subport,reqport,profiles.address as caddress, datasources.profile FROM datadriver JOIN datasources ON (datadriver.port = datasources.gatewayport AND datasources.mode = datadriver.mode) JOIN profiles ON (profiles.id = datasources.profile) WHERE datadriver.port = '.$port);
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		echo '     <source id="'.htmlspecialchars($row['assetid']).'" address="'.htmlspecialchars($row['address']).'" mode="'.$row['mode'].'" profile="'.$row['profile'].'" driver="'.$row['driver'].'" host="'.$row['caddress'].'" subport="'.$row['subport'].'"';
		echo '/>';
	}	
	
	//echo '  </sources>';
	
	echo '</driverdata>';
?>