<?php
/**
 * Used to query only the dynamic elements of an object
 *
 * This is usually used to refresh data on an object that has already been
 *   loaded with /api/getall
 *
 * Note that this doesn't include isolation or zero-energy status - to
 *    update these as well, 'dataupdate' should be used instead
 *
 * @author Steven Harding
 */	
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
	require_once('../assets/ui/displayfunctions.php');
	
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	echo '<assetdata>';	

	//OK - fetch the data we need...
	$query = $db->query('SELECT propertyid,sourceid,node,address,transform FROM datalinks WHERE assetid='.$_REQUEST['asset'].' AND propertyid='.$_REQUEST['property']);

	$dynamicdata = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$dynamicdata[] = $row;
	}
	
	require_once('../datalink/fetch.php');
	
	//OK - load details of this property and the property value...
	//$query = $db->query('SELECT typename, options, value,name FROM properties JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE properties.id='.$_REQUEST['property'].' AND assetvalues.assetid='.$_REQUEST['asset']);	
	
	$query = $db->query('SELECT typename, options, value,name 
FROM properties JOIN assetproperties ON ( assetproperties.propertyid = properties.id ) LEFT OUTER JOIN assetvalues ON ( assetvalues.propertyid = properties.id ) WHERE properties.id = '.$_REQUEST['property'].' AND assetproperties.assetid='.$_REQUEST['asset']);	

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$basevalue = $row['value'];
		$options = $row['options'];
		$module = $row['typename'];
		$propname = $row['name'];
	}
	else
	{
		$basevalue = '';
		$options = '';		
	}
	
	$value = array();
	$bits = explode('|',$basevalue);
	
	$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($module).'.php';
	if (file_exists($modulefile))
	{
		//Import module...
		include ($modulefile);
				
		for($x=0;$x<count($inputs);$x++)
		{
			if ((!isset($bits[$x])) || ($bits[$x] == "")) 
			{
				//echo 'Value Not Set...';
				if (isset($inputs[$x]['default']))
					$value[$inputs[$x]['name']] = $inputs[$x]['default'];
				else
					$value[$inputs[$x]['name']] = '';				
				continue;
			}
			$value[$inputs[$x]['name']] = $bits[$x];
		}
	}
	
	foreach($dynamicdata as $dd)
	{		
		$val = DynamicDataFetch($dd);
		$value[$dd['node']] = $val;
	}
	
	
	
	$nm = str_replace(")","",str_replace("(","_",str_replace(" ","",$propname)));
		if (!file_exists($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($module).'.php'))
		{
			$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($module).'.php';
			
			echo '<'.$nm.' type="'.$module.'" name="'.ucwords($propname).'">';
	
			if (file_exists($modulefile))
			{
				require($modulefile);
				if (count($inputs) == 1)
				{
					echo $value[$inputs[0]['name']];		
				}
				else
				{					
						for($x=0;$x<count($inputs);$x++)
						{
							$n = str_replace(")","",str_replace("(","_",str_replace(" ","",$inputs[$x]['name'])));							
							echo '<'.$n.'>'.$value[$inputs[$x]['name']].'</'.$n.'>';						
						}
					
				}
			}
			else
			{
				echo $value;	
			}
			echo '</'.$nm.'>';		
		}
		else		
		{
			$value = '';
			$name = $propname;
			$media = false;
			$propid = $_REQUEST['property'];			
						
			require($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($module).'.php');						
		}		
	
	echo '</assetdata>';
	//include($_SERVER['DOCUMENT_ROOT'].'/modules/'.strtolower($module).'.php');

?>