<?php
/**
 * Gets all attributes of a specific object
 *
 * This gets all information about an asset in XML or JSON form.
 *
 * The object can be found using the following parameters...
 *
 *   asset - The internal ARDI asset ID
 *   artag - The Augmented Reality tag of the object
 *
 * @author Steven Harding
 */	
	
	require_once($installfolder.'/include/dynamicdata.php');
	
	require_once('apiauth.inc');
	
	$assetlist = array();
	
	$itemid = 0;
	$params = false;
    if(isset($_REQUEST['artag']))
	{
		//Looking up asset via Augmented Reality tag....	
		$params = true;		

		$query = $db->query("SELECT properties.name,assetvalues.value, assetproperties.assetid FROM properties JOIN assetproperties ON (assetproperties.propertyid = properties.id) JOIN assetvalues ON (assetproperties.propertyid = assetvalues.propertyid AND assetvalues.assetid = assetproperties.assetid ) WHERE typename='ARTAG' AND assetvalues.value LIKE '".$_REQUEST['artag']."'");
		if ($query != FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$assetlist[] = $row['assetid'];
				//$itemid = $row['assetid'];
			}
		}
		
		if (count($assetlist) == 0)
		{
			$query = $db->query("SELECT assetvalues.assetid,assetvalues.value FROM properties JOIN assetvalues ON (properties.id = assetvalues.propertyid ) WHERE typename='ARTAG' AND assetvalues.value='".$_REQUEST['artag']."'");
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$assetlist[] = $row['assetid'];
				//$itemid = $row['assetid'];
			}	
		}
	}
	
	if(isset($_REQUEST['asset']))
	{
		//Looking up asset via Asset ID
			
		//$itemid = $_REQUEST['asset'];		
		$params = true;
		$assetlist[] = $_REQUEST['asset'];
	}
	
	if (count($assetlist) == 0) 
	{
		if ($params == false)
			APIError(401, "Missing Parameter");
		else
			APIError(201, "Not Found");
	}
	
	ob_start();
	
	$itemdata = array();		
	
	echo '<assets>';
	
	foreach($assetlist as $itemid)
	{
		$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$itemdata = $row;
		}	
		
		$propertyset = array();
		global $propertyset;
						
		$query = $db->query('SELECT name,id FROM assetrelclosures JOIN assets ON (assetrelclosures.parentasset = assets.id) WHERE childasset='.$itemid.' AND depth > 0 ORDER BY depth DESC');
		
		$str = "";
		$candidates = array();
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			//if ($str != "") $str .= ' | ';
			//$str .= '<a href="view.php?id='.$row['id'].'">'.$row['name'].'</a>';		
			$candidates[] = $row;
		}
		
		foreach($candidates as $v)
		{
			$dirname = $_SERVER['DOCUMENT_ROOT'].'/media/layouts/'.$v['id'];
			if (file_exists($dirname))
			{
				if (file_exists($dirname.'/model.obj'))
				{
					$envname = $v['name'];
					$envid = $v['id'];
				}
			}
		}

		echo '<asset>';
		echo '   <name>'.$itemdata['name'].'</name>';
		echo '   <id>'.$itemdata['id'].'</id>';
		echo '   <description>'.$itemdata['descript'].'</description>';
		echo '   <isolation>';
		require('getisostatus.php');
		echo '   </isolation>';	
		echo '   <properties>';
		
		$properties = array();
			
		$query = $db->query('SELECT id,name,typename,value FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) WHERE assetvalues.assetid='.$itemid);
			
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (isset($properties[$row['id']])) continue;
				
			$properties[$row['id']]['name'] = $row['name'];
			$properties[$row['id']]['type'] = $row['typename'];
			$properties[$row['id']]['value'] = $row['value'];
		}	
		
		$query = $db->query('SELECT id,name,typename,value,depth FROM assetrelclosures JOIN assetvalues ON (assetvalues.assetid = assetrelclosures.parentasset) JOIN properties ON (properties.id = assetvalues.propertyid) WHERE assetrelclosures.childasset='.$itemid.' AND assetrelclosures.relationship = 3 ORDER BY depth DESC, name ASC');

		$md = -2;
		$skip = array();
		if ($query !== FALSE)
		{
			
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				if (isset($properties[$row['id']])) continue;
				
				if ($row['value'] == '@')
				{
					$skip[] = $row['id'];				
				};
				if (in_array($row['id'],$skip)) continue;
				
				if ($md == -2) $md = $row['depth'];
				
				$properties[$row['id']]['name'] = $row['name'];
				$properties[$row['id']]['type'] = $row['typename'];
				$properties[$row['id']]['value'] = $row['value'];		
				if ($row['depth'] < $md) $properties[$row['id']]['inherited'] = true;		
			}	
		}
				
		
		$dynamics = array();
		$query = $db->query('SELECT propertyid,sourceid,node,address,transform FROM datalinks WHERE assetid='.$itemid);

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$dynamics[$row['propertyid']] = array();
			$dynamics[$row['propertyid']][$row['node']] = $itemid.':'.$row['propertyid'];
		}	
		
		$commserror = false;	
			
		foreach($properties as $k => $v)
		{
			if (!isset($v['name'])) continue;
			$nm = str_replace(")","",str_replace("(","_",str_replace(" ","",$v['name'])));
			if (!file_exists($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($v['type']).'.php'))
			{
				$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($v['type']).'.php';
				
				echo '<'.$nm.' id="'.$k.'" type="'.$v['type'].'" name="'.ucwords($v['name']).'" source="'.$itemid.'">';
														
				if (file_exists($modulefile))
				{
					require($modulefile);
					
					//if (!is_array($value)) echo '<nonarray/>';
					
					$value = array();
						
					if (isset($v['value']))
						$bits = explode('|',$v['value']);
					else
						$bits = "";
					
					for($x=0;$x<count($inputs);$x++)
					{															
						if ((!isset($bits[$x])) || ($bits[$x] == "")) 
						{
							//echo 'Value Not Set...';
							if (isset($inputs[$x]['default']))
								$value[$inputs[$x]['name']] = LinkedData($itemid,$k,$inputs[$x]['name'],$inputs[$x]['default']);
							else
								$value[$inputs[$x]['name']] = LinkedData($itemid,$k,$inputs[$x]['name'],'');				
						}
						else
							$value[$inputs[$x]['name']] = LinkedData($itemid,$k,$inputs[$x]['name'],$bits[$x]);
						
						$n = str_replace(")","",str_replace("(","_",str_replace(" ","",$inputs[$x]['name'])));
						echo '<'.$n;
						if ((isset($dynamics[$k])) && (isset($dynamics[$k][$inputs[$x]['name']])))
						{
							echo ' external="'.$dynamics[$k][$inputs[$x]['name']].':'.$inputs[$x]['name'].'"';
						}

						echo '>'.$value[$inputs[$x]['name']].'</'.$n.'>';
						if ($value[$inputs[$x]['name']] == "Error")
						{
							$commserror = true;
						}					
					}
					switch($v['type'])
					{
					case 'MEASUREMENT':
						$propertyset[$k] = $value['measurement'];	
						break;
					case 'STATUS':
						$propertyset[$k] = $value['state'];	
						break;					
					}
					
				}
				else
				{			
					if ((isset($v['value'])) && (!is_array($v['value'])))
					{
						echo $v['value'];					
					}		
				}
				echo '</'.$nm.'>';		
			}
			else		
			{
				$value = '';
				$name = $v['name'];
				$media = false;
				$propid = $k;
				if (isset($v['value']))	$value = $v['value'];
							
				require($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($v['type']).'.php');						
			}		
		}	
		
		echo '   </properties>';
		
		echo '   <secondaries>';
		include('getsecondaries.php');
		echo '   </secondaries>';	
		
		echo '   <media>';
		
		$fldr = $_SERVER['DOCUMENT_ROOT'].'/media/assets/'.$itemid;
		
		//$query = $db->query('SELECT DISTINCT category FROM mediatags JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE mediatags.assetid='.$itemid." ORDER BY category");
		/*$query = $db->query('SELECT id,mediatype,name,category,path,depth FROM assetrelclosures JOIN mediatags ON (mediatags.assetid = assetrelclosures.parentasset) JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE assetrelclosures.childasset='.$itemid.' AND assetrelclosures.relationship = 3 ORDER BY depth DESC, category ASC, name ASC');
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$mc = $row['category'];
			if ($mc == "") $mc = "Misc";
			echo '     <group name="'.$row['category'].'"/>';
		}	
		
		$query = $db->query('SELECT name,path FROM mediatags JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE mediatags.assetid='.$itemid." ORDER BY name");
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$mc = $row['category'];
			if ($mc == "") $mc = "Misc";
			echo '     <document name="'.$row['name'].'" url="/media/assets/'.$itemid.'/'.$row['path'].'"/>';
		}*/
		
		echo '   </media>';	
		
		echo '   <alerts>';
		$query = $db->query('SELECT * FROM alerts WHERE assetid='.$itemid);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{		
			echo '  <alert name="'.$row['name'].'" desc="'.$row['description'].'" medialink="'.$row['media'].'" relationship="'.$row['relationship'].'" status="'.$row['state'].'" id="'.$row['id'].'"/>';	
		}	
			
		echo '   </alerts>';	
		
		UpdateLinkedData();

	if (!isset($relationships)) include($sitefolder.'/cache/relationships/all.inc');
	if (!isset($asset[$itemid])) include($sitefolder.'/cache/relationships/'.$itemid.'.inc');

	echo '  <relationships>';

			$query = $db->query("SELECT parentasset, assets.name, relationships.upstreamname, relationship FROM assetrelationships JOIN relationships ON (relationships.id = assetrelationships.relationship) JOIN assets ON (assets.id = parentasset) WHERE (relationships.style < 2) AND childasset=".$itemid);
					
			$relsdone = array();

			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				echo '      <relationship id="'.$row['relationship'].'" target="'.$row['parentasset'].'" direction="0"/>';
			}			
			
			$query = $db->query("SELECT childasset, assets.name, relationships.upstreamname, relationship FROM assetrelationships JOIN relationships ON (relationships.id = assetrelationships.relationship) JOIN assets ON (assets.id = childasset) WHERE (relationships.style < 2) AND parentasset=".$itemid);
					
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				echo '      <relationship id="'.$row['relationship'].'" target="'.$row['childasset'].'" direction="1"/>';
			}			
	/*foreach($asset[$itemid]['relationships'] as $k => $v)
	{
		//print_r($v);
		foreach($v as $a=>$b)
		{
			$us = 0;
			if ($b['upstream'] == 1) $us = 1;
				
			echo '      <relationship id="'.$k.'" target="'.$b['target'].'" direction="'.$us.'"/>';
		}
	}*/
		echo '  </relationships>';
		
		echo '  <zeroenergy>';
		
		$query = $db->query('SELECT * FROM module_zeroenergy');
		
		$any = false;
		$atzero = true;
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{		
			if (isset($propertyset[$row['propertyid']]))
			{
				$any = true;
				if ($propertyset[$row['propertyid']] > $row['threshold'])
				{				
					$atzero = false;
					break;
				}
			}
		}	
		if ($any == true)
		{
			if ($atzero == false) 
				echo 'No';
			else
				echo 'Yes';	
		}
		echo '</zeroenergy>';
		
		if (isset($envname))
		{
			echo '   <environment>';
			echo '       <name>'.$envname.'</name>';
			echo '       <assetid>'.$envid.'</assetid>';
			echo '   </environment>';
		}
		
		echo '  <tags>';
		//First, select relationships to use in the list (tags + all heirarchies)
		$query = $db->query('SELECT id FROM relationships WHERE style=2 OR style=3');
		$rels = array();
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$rels[] = $row['id'];
		}	
		
		$buf = implode(',',$rels);
		if ($buf == ",") $buf = "";
		
		$query = $db->query('SELECT DISTINCT name FROM assetrelclosures JOIN assets ON (assets.id = assetrelclosures.parentasset) WHERE childasset='.$itemid." AND relationship IN (".$buf.")");		
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			echo '     <tag>'.$row['name'].'</tag>';
		}	
		
		echo '  </tags>';
		
		$bindingfile = $_SERVER['DOCUMENT_ROOT'].'/cache/bindings/'.$itemid.'.xml';
		if (file_exists($bindingfile))
		{
			readfile($bindingfile);
		}
		
		echo '</asset>';
	};
	
	echo '</assets>';
	
	include('apioutput.inc');
	
?>