<?php
/**
 * Gets all attributes of a specific object
 *
 * This gets all information about an asset in XML or JSON form.
 *
 * The object can be found using the following parameters...
 *
 *   asset - The internal ARDI asset ID
 *   artag - The Augmented Reality tag of the object
 *
 * @author Steven Harding
 */	
	
	//require_once($installfolder.'/include/dynamicdata.php');
	
	function SortMedia($a,$b)
	{
		if ($a->name == $b->name) return 0;
		return ($a->name < $b->name) ? -1 : 1;
	}
	
	require_once('apiauth.inc');
	
	$assetlist = array();
	
	$itemid = 0;
	$params = false;
    if(isset($_REQUEST['artag']))
	{
		//Looking up asset via Augmented Reality tag....	
		$params = true;		

		$query = $db->query("SELECT properties.name,assetvalues.value, assetproperties.assetid FROM properties JOIN assetproperties ON (assetproperties.propertyid = properties.id) JOIN assetvalues ON (assetproperties.propertyid = assetvalues.propertyid AND assetvalues.assetid = assetproperties.assetid ) WHERE typename='ARTAG' AND assetvalues.value LIKE '".$_REQUEST['artag']."'");
		if ($query != FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$assetlist[] = $row['assetid'];
				//$itemid = $row['assetid'];
			}
		}
		
		if (count($assetlist) == 0)
		{
			$query = $db->query("SELECT assetvalues.assetid,assetvalues.value FROM properties JOIN assetvalues ON (properties.id = assetvalues.propertyid ) WHERE typename='ARTAG' AND assetvalues.value='".$_REQUEST['artag']."'");
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$assetlist[] = $row['assetid'];
				//$itemid = $row['assetid'];
			}	
		}
	}
	
	if(isset($_REQUEST['asset']))
	{
		//Looking up asset via Asset ID
			
		//$itemid = $_REQUEST['asset'];		
		$params = true;
		$assetlist[] = $_REQUEST['asset'];
	}
	
	if (count($assetlist) == 0) 
	{
		if ($params == false)
			APIError(401, "Missing Parameter");
		else
			APIError(201, "Not Found");
	}
	
	ob_start();
	
	$itemdata = array();		
	
	include($installfolder.'/model/asset.php');
	include($installfolder.'/model/relationship.php');
	
	echo '<assets>';
	
	foreach($assetlist as $itemid)
	{
		$query = $db->query('SELECT * FROM assets WHERE id='.$itemid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$itemdata = $row;
		}	
		
		$propertyset = array();
		global $propertyset;
						
		$query = $db->query('SELECT name,id FROM assetrelclosures JOIN assets ON (assetrelclosures.parentasset = assets.id) WHERE childasset='.$itemid.' AND depth > 0 ORDER BY depth DESC');
		
		$str = "";
		$candidates = array();
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			//if ($str != "") $str .= ' | ';
			//$str .= '<a href="view.php?id='.$row['id'].'">'.$row['name'].'</a>';		
			$candidates[] = $row;
		}
		
		foreach($candidates as $v)
		{
			$dirname = $_SERVER['DOCUMENT_ROOT'].'/media/layouts/'.$v['id'];
			if (file_exists($dirname))
			{
				if (file_exists($dirname.'/model.obj'))
				{
					$envname = $v['name'];
					$envid = $v['id'];
				}
			}
		}
		
		$thisasset = new Asset($itemid);
		$thisasset->Load();

		echo '<asset>';
		echo '   <name>'.$itemdata['name'].'</name>';
		echo '   <fullname>'.$thisasset->GetFullName().'</fullname>';
		echo '   <id>'.$itemdata['id'].'</id>';
		echo '   <description>'.$itemdata['descript'].'</description>';
		echo '   <isolation><status>';
		echo $thisasset->GetIsolationStatus()['state'];
		echo '</status></isolation>';	
		echo '   <properties>';
		
		$properties = $thisasset->GetProperties();
		$thisasset->GetValues($properties);
		
		//OK - some properties (such as URLs) that add BUTTONS rather than real info can be skipped.
		$counter = 0;
		
		foreach($properties as $prp)
		{
			if ($prp->type == "URL") continue;
			if ($prp->type == "TAG") continue;
			if ($prp->type == "ARTAG") continue;
			$counter++;
		}
		
		if ($counter <= 0)
		{
			//OK - this is a container. Perhaps there is more we can read from CHILD objects?
			$matches = array();
			$rels = $thisasset->GetRelationships();
			if (isset($rels[2]))
			{
				foreach($rels[2] as $r)
				{
					if ($r['upstream'] == false)
					{
						$matches[] = $r['target'];
					}
				}
			}
			
			if ((count($matches) > 0) && (count($matches) <= 3))
			{
				//OK - show the properties for all of these sub-items....
				foreach($matches as $match)
				{
					$otherasset = new Asset($match);
					$propset = $otherasset->GetProperties();
					
					//Go through and trim less relevant info...
					for($x=count($propset)-1;$x>=0;$x--)
					{
						if ($propset[$x]->type != 'MEASUREMENT')
						{
							unset($propset[$x]);
							continue;
						}
						if ($propset[$x]->origintype != "local")
						{
							unset($propset[$x]);
							continue;
						}
					}
					
					$propset = array_values($propset);
					
					for($x=0;$x<count($propset);$x++)
					{
						$propset[$x]->origintype = "secondary";
					}
					
					$otherasset->GetValues($propset);
					
					$properties = array_merge($properties,$propset);
					//print_r($propset);
				}
			}
		}
		
		$commserror = false;	
		foreach($properties as $p)
		{
			if (!isset($p->type)) continue;
			$nm = str_replace(")","",str_replace("(","_",str_replace(" ","",$p->name)));
			if (!file_exists($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($p->type).'.php'))
			{
				$oname = "";
				if ($p->origin != $itemid)
				{
					$origin = new Asset($p->origin);
					$oname = ' sourcename="'.$origin->name.'"';
				}
				echo '<'.$nm.' id="'.$p->id.'" type="'.$p->type.'" name="'.ucwords($p->name).'" class="'.$p->origintype.'" source="'.$p->origin.'"'.$oname.'>';
				$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($p->type).'.php';
				
				$dyn = array();
				if (isset($p->value['_dynamics']))
				{
					$dyn = $p->value['_dynamics'];
				}
				
				foreach($p->value as $k => $v)
				{
					if ($k == '_dynamics') continue;
					$n = str_replace(")","",str_replace("(","_",str_replace(" ","",$k)));
					echo '<'.$n;
					if (in_array($k,$dyn))
					{
						echo ' node="'.$k.'"';
					}
					echo '>';
					echo $v;
					echo '</'.$n.'>';
				}
				echo '</'.$nm.'>';
			}
			else
			{
				//$value = "";
				$name = $p->name;
				$media = false;
				$propid = $p->id;
				$value = implode('|',$p->value);
							
				require($_SERVER['DOCUMENT_ROOT'].'/modules/xml/'.strtolower($p->type).'.php');	
			}
		}
			
		
		echo '   </properties>';
		
		echo '   <media>';
		
		$fldr = $installfolder.'/media/assets/'.$itemid;
		
		$mlist = $thisasset->GetMedia();
		usort($mlist,"SortMedia");
		
		foreach($mlist as $m)
		{
			echo '<item name="'.$m->name.'">'.$m->path.'</item>';
		}
		
		//$query = $db->query('SELECT DISTINCT category FROM mediatags JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE mediatags.assetid='.$itemid." ORDER BY category");
		/*$query = $db->query('SELECT id,mediatype,name,category,path,depth FROM assetrelclosures JOIN mediatags ON (mediatags.assetid = assetrelclosures.parentasset) JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE assetrelclosures.childasset='.$itemid.' AND assetrelclosures.relationship = 3 ORDER BY depth DESC, category ASC, name ASC');
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$mc = $row['category'];
			if ($mc == "") $mc = "Misc";
			echo '     <group name="'.$row['category'].'"/>';
		}	
		
		$query = $db->query('SELECT name,path FROM mediatags JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE mediatags.assetid='.$itemid." ORDER BY name");
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$mc = $row['category'];
			if ($mc == "") $mc = "Misc";
			echo '     <document name="'.$row['name'].'" url="/media/assets/'.$itemid.'/'.$row['path'].'"/>';
		}*/
		
		echo '   </media>';	
		
		echo '   <alerts>';
		$query = $db->query('SELECT * FROM alerts WHERE assetid='.$itemid);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{		
			echo '  <alert name="'.$row['name'].'" desc="'.$row['description'].'" medialink="'.$row['media'].'" relationship="'.$row['relationship'].'" status="'.$row['state'].'" id="'.$row['id'].'"/>';	
		}	
			
		echo '   </alerts>';	
		
		//UpdateLinkedData();

	if (!isset($relationships)) include($sitefolder.'/cache/relationships/all.inc');
	if (!isset($asset[$itemid])) include($sitefolder.'/cache/relationships/'.$itemid.'.inc');

	$rels = Relationships::GetAllRelationships();
	$rx = $thisasset->GetRelationships();

	echo '  <relationships>';

		foreach($rx as $k => $v)
		{
			foreach($rels as $rq)
			{
				if ($rq->id == $k)
				{
					$r = $rq;
				}
			}
		
			echo '<related id="'.$k.'" name="'.$r->name.'" upname="'.$r->upname.'" downname="'.$r->downname.'">';
			foreach($v as $inf)
			{
				$otherasset = new Asset($inf['target']);
				echo '<to id="'.$inf['target'].'" direction="';
				if ($inf['upstream'] == true)
					echo 'upstream';
				else
					echo 'downstream';
				echo '"';
				echo ' name="'.$otherasset->name.'"/>';
			}
			echo '</related>';
		}
	
		echo '  </relationships>';
		
		echo '  <zeroenergy>';
		
		$query = $db->query('SELECT * FROM module_zeroenergy');
		
		$any = false;
		$atzero = true;
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{		
			if (isset($propertyset[$row['propertyid']]))
			{
				$any = true;
				if ($propertyset[$row['propertyid']] > $row['threshold'])
				{				
					$atzero = false;
					break;
				}
			}
		}	
		if ($any == true)
		{
			if ($atzero == false) 
				echo 'No';
			else
				echo 'Yes';	
		}
		echo '</zeroenergy>';
		
		if (isset($envname))
		{
			echo '   <environment>';
			echo '       <name>'.$envname.'</name>';
			echo '       <assetid>'.$envid.'</assetid>';
			echo '   </environment>';
		}
		
		echo '  <tags>';
		//First, select relationships to use in the list (tags + all heirarchies)
		$query = $db->query('SELECT id FROM relationships WHERE style=2 OR style=3');
		$rels = array();
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$rels[] = $row['id'];
		}	
		
		$buf = implode(',',$rels);
		if ($buf == ",") $buf = "";
		
		$query = $db->query('SELECT DISTINCT name FROM assetrelclosures JOIN assets ON (assets.id = assetrelclosures.parentasset) WHERE childasset='.$itemid." AND relationship IN (".$buf.")");		
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			echo '     <tag>'.$row['name'].'</tag>';
		}	
		
		echo '  </tags>';
		
		$bindingfile = $_SERVER['DOCUMENT_ROOT'].'/cache/bindings/'.$itemid.'.xml';
		if (file_exists($bindingfile))
		{
			readfile($bindingfile);
		}
		
		echo '</asset>';
	};
	
	echo '</assets>';
	
	include('apioutput.inc');
	
?>