<?php
/**
 * Gets information about the environment for an asset.
 *
 * It is used to calculate the correct environment to load, as well as to
 * get other environment-related info such as scripts present etc.
 *
 * Takes the ID of an asset as a parameter
 *
 * @author Steven Harding
 */	


$format = "xml";

//Content Here...

include($sitefolder.'/cache/relationships/all.inc');

echo '<envdetails>';

	if (isset($_REQUEST['id']))
	{
		$itemid = $_REQUEST['id'];
	}
			
	if ((!isset($itemid)) || ($itemid < 1))
	{
		//OK - use the pre-installed base asset '5'
		$itemid = 5;
	}
	
	$locationparents = array();		
	$query = $db->query('SELECT name,id FROM assetrelclosures JOIN assets ON (assetrelclosures.parentasset = assets.id) WHERE childasset='.$itemid.' AND depth > 0 ORDER BY depth DESC');
	
	$str = "";
	$candidates = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{		
		$candidates[] = $row;
	}			
	
	//print_r($candidates);
	
	/*$query = $db->query("SELECT properties.name,assetvalues.value, assetproperties.assetid FROM properties JOIN assetproperties ON (assetproperties.propertyid = properties.id) JOIN assetvalues ON (assetproperties.propertyid = assetvalues.propertyid) WHERE typename='LOCATION' AND assetvalues.assetid=".$itemid);						
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$position = $row['value'];
	}*/	

	$any = false;	
	$model = false;
	
	foreach($candidates as $v)
	{
		$dirname = $sitefolder.'/media/layouts/'.$v['id'];
		if (file_exists($dirname))
		{
			if ((file_exists($dirname.'/model.obj')) || (file_exists($dirname.'/1.obj')))
			{
				echo '   <environment name="'.htmlentities($v['name']).'" id="'.$v['id'].'"/>';
				$usedid = $v['id'];
				$any = true;
				break;
			}
		}
	}
	
	$dirname = $sitefolder.'/media/layouts/'.$itemid;
	if (file_exists($dirname))
	{
		if (file_exists($dirname.'/model.obj'))
		{
			echo '   <environment name="ThisObject" id="'.$itemid.'"/>';
			$usedid = $itemid;
			$any = true;
		}
	}
	
	if ($any == false)
	{
		echo '   <error message="No Environment" code="NORESULT"/>';
	}
	else
	{
		$lst = array();
		foreach($candidates as $v)
		{
			$lst[] = $v['id'];
			if ($v['id'] == $usedid) break;
		}
						
		//echo "SELECT name,category,path,id FROM mediatags JOIN mediafiles ON (mediafiles.id = mediatags.assetid) WHERE assetid IN (".implode(',',$lst).")";
		
		$lst[] = $itemid;
		
		$query = $db->query("SELECT name,category,path,id,assetid FROM mediatags JOIN mediafiles ON (mediafiles.id = mediatags.mediaid) WHERE assetid IN (".implode(',',$lst).")");
	
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['category'] == 'Scripts')
			{
				echo '   <script name="'.htmlentities($row['name']).'" href="http://'.$_SERVER['HTTP_HOST'].'/media/assets/'.$row['assetid'].'/'.$row['path'].'"/>';
			}
		}	
	}

echo '</envdetails>';
?>