<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	

$format = "xml";

if (isset($_REQUEST['format']))
{
	if ($_REQUEST['format'] == 'json')
	{
		$format = 'json';
	}
}

if ($format != "xml")
{
	ob_start();
}

//Content Here...

include($sitefolder.'/cache/relationships/all.inc');

echo '<config>';
echo '  <relations>';
foreach($relationships as $k => $v)
{
	$passdata = "";
	if (isset($v['passes']))
	{
		foreach($v['passes'] as $p)
		{
			if ($passdata != "") $passdata .= ",";
			$passdata .= $p;
		}
	}
	$additional = "";
	
	if (isset($v["energysource"]))
	{
		$additional .= 'energy="yes" ';
	}
	
	echo '   <relationship name="'.$v['name'].'" id="'.$k.'" upname="'.$v['upname'].'" downname="'.$v['downname'].'" passes="'.$passdata.'" colour="'.$v['colour'].'" type="'.$v['type'].'" '.$additional.'/>';
}
echo '  </relations>';

echo '  <properties>';
$query = $db->query('SELECT name,typename,id,options FROM properties');	

						while($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							echo '    <property name="'.$row['name'].'" id="'.$row['id'].'" type="'.$row['typename'].'"';
							$arr = explode('|',$row['options']);
							if (in_array('Energy',$arr))
							{
								echo ' energy="yes"';
							}
							if (in_array('ZeroCenter',$arr))
							{
								echo ' zerocenter="yes"';
							}
							echo '>';
							$fn = $sitefolder.'/cache/display/properties/'.$row['id'].'.xml';
							if (file_exists($fn))
							{
								include($fn);
							}
							echo '</property>';
						}
echo '  </properties>';					
echo '</config>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>