<?php
/**
 * Get history data
 * 
 * Requests a set of history data from the appropriate historian server
 * and outputs it in a variety of possible formats.
 *
 * @author Steven Harding
 */	
	
	
	
	$format = "json";
		
	include($_SERVER['DOCUMENT_ROOT'].'/include/historian.php');
	
	$start = $_REQUEST['start'];
	$end = $_REQUEST['end'];	
	
	date_default_timezone_set('Australia/Sydney');
	
	$p = strpos($start,"-");
	if ($p === FALSE)
	{
		$start = date('Y-m-d H:i:s', $start/1000);
	}
	
	$p = strpos($end,"-");
	if ($p === FALSE)
	{
		$end = date('Y-m-d H:i:s', $end/1000);
	}
	
	$points = array();
	
	if (isset($_REQUEST['points']))
	{
		$bits = explode('_',$_REQUEST['points']);
	}
	if (isset($_REQUEST['props']))
	{
		$bits = explode('_',$_REQUEST['props']);
	}
	if (!isset($bits)) exit;
	
	$x = -1;
	foreach($bits as $b)
	{
		$x++;
		$l = array();
		$pieces = explode(':',$b);
		$l['asset'] = $pieces[0];
		$l['property'] = $pieces[1];
		$l['node'] = $pieces[2];
		$l['id'] = $x;
		$points[] = $l;
	}
	
	/*ob_start();	
	print_r($points);
	$pnts = ob_get_clean();
	file_put_contents("c:\\tmp\\debugging.txt",$pnts);
	unset($pnts);*/
	
	//echo 'Hello?';
		
	$function = 'raw';
	$grain = 1;	
	$first = 1;
	
	if (isset($_REQUEST['followup']))
	{
		$first = 0;
	}
	
	if (isset($_REQUEST['function']))
	{
		if ($_REQUEST['function'] == 'avg')
		{
			$function = 'avg';
		}
		if ($_REQUEST['function'] == 'max')
		{
			$function = 'max';
		}
		if ($_REQUEST['function'] == 'min')
		{
			$function = 'min';
		}
	}
	
	if (isset($_REQUEST['grain']))
	{
		$grain = filter_var($_REQUEST['grain'],FILTER_VALIDATE_INT);
		if ($grain === FALSE) $grain = 1;
	}
		
	$res = GetBulkHistory($points,$start,$end,$grain,$function,$first);		
	if ($res === FALSE)
	{		
		$res = array();
	}
	
	if (isset($_REQUEST['format']))
	{
		if ($_REQUEST['format'] == "tdl") $format = 'tdl';
		if ($_REQUEST['format'] == "xml") $format = 'xml';
	}
	
	if ($format == "json")
	{
		$split = false;
		if (isset($_REQUEST['mode']))
		{
			$split = true;
		}
		
		if ($split == false)
		{
			header('Content-Type: application/json');
			echo "{  \"records\" : [";
			$first = true;
			foreach($res as $q)
			{
				if (!isset($q[1])) continue;
				if ($first == true)
					$first = false;
				else
					echo ',';
				$tm = strtotime($q[1])*1000;
				echo '[ '.$tm.','.$q[0].','.$q[2].' ]';
			}
			echo "] }";
		}
		else
		{
			header('Content-Type: application/json');
			echo "{  ";
			foreach($points as $p)
			{
				echo "  \"records\" : [";
				$first = true;
				foreach($res as $q)
				{
					if (!isset($q[1])) continue;
					if ($first == true)
						$first = false;
					else
						echo ',';
					$tm = strtotime($q[1])*1000;
					echo '[ '.$tm.','.$q[0].','.$q[2].' ]';
				}
				echo "]";
			}
			echo "}";
		}
	}
	
	if ($format == "tdl")
	{
		foreach($res as $q)
		{
			if (!isset($q[1])) continue;

			echo $q[1].','.$q[0].','.$q[2]."\r\n";
		}
	}
	
	if ($format == "xml")
	{
		echo "<recording>";
		foreach($res as $q)
		{
			if (!isset($q[1])) continue;

			echo ' <sample time="'.$q[1].'" point="'.$q[0].'" value="'.$q[2].'" />'."\r\n";
		}
		echo "</recording>";
	}
?>