<?php
/**
 * Gets the model of an object based on its ARDI ID
 *
 * @author Steven Harding
 */	
 
 
class HttpCache 
{
    public static function Init($lastModifiedTimestamp, $maxAge)
    {
        if (self::IsModifiedSince($lastModifiedTimestamp))
        {
            self::SetLastModifiedHeader($lastModifiedTimestamp, $maxAge);
        }
        else 
        {
            self::SetNotModifiedHeader($maxAge);
        }
    }

    private static function IsModifiedSince($lastModifiedTimestamp)
    {
        $allHeaders = getallheaders();

        if (array_key_exists("If-Modified-Since", $allHeaders))
        {
            $gmtSinceDate = $allHeaders["If-Modified-Since"];
            $sinceTimestamp = strtotime($gmtSinceDate);

            // Can the browser get it from the cache?
            if ($sinceTimestamp != false && $lastModifiedTimestamp <= $sinceTimestamp)
            {
                return false;
            }
        }

        return true;
    }

    private static function SetNotModifiedHeader($maxAge)
    {
        // Set headers
        header("HTTP/1.1 304 Not Modified", true);
        header("Cache-Control: public, max-age=$maxAge", true);
        die();
    }

    private static function SetLastModifiedHeader($lastModifiedTimestamp, $maxAge)
    {
        // Fetching the last modified time of the XML file
        $date = gmdate("D, j M Y H:i:s", $lastModifiedTimestamp)." GMT";

        // Set headers
        header("HTTP/1.1 200 OK", true);
        header("Cache-Control: public, max-age=$maxAge", true);
        header("Last-Modified: $date", true);
    }
}

	//require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	//require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	$itemid = $_REQUEST['id'];

	$query = $db->query("SELECT * FROM models WHERE id=".$itemid);
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$iteminfo = $row;
	}	

	$ext = pathinfo($row['obj'],PATHINFO_EXTENSION);
	
        $pth = $sitefolder.$row['obj'];
        if (!file_exists($pth))
{
    $pth = $installfolder.$row['obj'];
}

if (!file_exists($pth))
{
    exit;
}

	$tm = filemtime($pth);
	
	//echo 'Looking For '.$row['obj'];
	//exit;
	
	//HttpCache::Init($tm,604800);
	
    if ($ext == "unity3d")
	{
		ob_start("ob_gzhandler");	
		header("Content-type: application/vnd.unity");
		$filename = $sitefolder.$iteminfo['obj'];
		if (isset($_REQUEST['platform']))
		{
			if ($_REQUEST['platform'] == 'android')
			{				
				$filename2 = str_replace(".unity3d","_android.unity3d",$filename);
				if (file_exists($filename2)) $filename = $filename2;
			}
		}		
		readfile($filename);
		ob_end_flush();
		exit;
	}

	ob_start("ob_gzhandler");	
	header("Content-type: text/plain");
	
	echo "#OBJ Object Model File\n";
	echo "#From ".$iteminfo['obj']."\n";
	readfile($pth);
	//echo file_get_contents($_SERVER['DOCUMENT_ROOT'].$iteminfo['obj']);
	
	ob_end_flush();
?>
