<?php
/**
 * Gets a list of obects AND THEIR POSITIONS inside an environment
 *
 * Creates a list of objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
 
		require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

		include('apiauth.inc');
		
		ob_start();
		
		if (!isset($userid))
		{
			APIError(303, "This function requires user credentials");
		}
	
		echo '<pins>';
					      
		$set = array();
		$query = $db->query("SELECT value FROM userdata WHERE property='pins' AND userid=".$userid);
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$bits = explode(':',$row['value']);
			
			$set[] = $bits;
		}
		
		$anames = array();
		$pnames = array();
		$inlist = array();
		$assetlist = array();
		$propertylist = array();
		
		foreach($set as $vx)
		{
			if (!in_array($vx[0],$assetlist))
			{
				$assetlist[] = $vx[0];
			}
			if (!in_array($vx[1],$propertylist))
			{
				$propertylist[] = $vx[1];
			}
		}
		
		if (count($assetlist) > 0)
		{
			$query = $db->query("SELECT name,id FROM assets WHERE id IN (".implode(',',$assetlist).")");
			if ($rx = $query->fetch(PDO::FETCH_ASSOC))
			{
				$anames[0+$rx['id']] = $rx['name'];
			}
			
			$query = $db->query("SELECT name,id FROM properties WHERE id IN (".implode(',',$propertylist).")");
			if ($rx = $query->fetch(PDO::FETCH_ASSOC))
			{
				$pnames[0+$rx['id']] = $rx['name'];
			}
			
			$values = array();
			
			$query = $db->query("SELECT assetid,propertyid,value FROM assetvalues WHERE assetid IN (".implode(',',$assetlist).") AND propertyid IN (".implode(',',$propertylist).")");
			if ($rx = $query->fetch(PDO::FETCH_ASSOC))
			{
				foreach($set as $vx)
				{
					$as = 0+$vx[0];
					$pr = 0+$vx[1];
				
					if (($rx['assetid'] == $as) && ($rx['propertyid'] == $pr))
					{
						if (!isset($values[$as]))
						{
							$values[$as] = array();
						}
						if (!isset($values[$as][$pr]))
						{
							$values[$as][$pr] = array();
						}
						
						$bits = explode('|',$rx['value']);
						
						$values[$as][$pr]['units'] = $bits[1];
						if (count($bits) < 5)
							$values[$as][$pr]['places'] = 2;
						else
							$values[$as][$pr]['places'] = $bits[4];
					};
					
				}
			}
			
			foreach($set as $vx)
			{
				echo '<pin><address>'.$vx[0].':'.$vx[1].':'.$vx[2].'</address><name>'.$anames[0+$vx[0]].' '.$pnames[0+$vx[1]].'</name><decimals>'.$values[0+$vx[0]][0+$vx[1]]['places'].'</decimals><units>'.$values[0+$vx[0]][0+$vx[1]]['units'].'</units></pin>';
			}
		}
		
		echo '</pins>';
	
		include('apioutput.inc');
	
?>