<?php
/**
 * Gets all 'secondaries' (inhereted information) of an object 
 * 
 * Note that this file is an include file designed to be called by other
 *    API functions and not to be called directly by clients
 *
 * @author Steven Harding
 */	
	$content = "";
	
	//Explore cache to locate upstream sources of other relevant data...
	
	global $asset;
	global $itemid;		
	
	$found = array();
	global $found;
	
	require_once($sitefolder.'/cache/relationships/all.inc');
	global $relationships;
			
	//Now - search for secondaries!
	FindSecondaries($itemid,0);
	
	function FindSecondaries($id,$rels)
	{
		global $db;
		global $asset;
		global $found;
		global $relationships;
		global $propertyset;
		global $sitefolder;
		global $dynamics;
		
		if (!isset($asset[$id]))
		{		
			require_once($sitefolder.'/cache/relationships/'.$id.'.inc');
		}
				
		if (!isset($asset[$id]))
		{		
			return;
		}
		
		//echo 'Scanning '.$id." within ".$rels;
		
		foreach($asset[$id]["values"] as $k => $v)
		{			
			if (($rels != 0) && ($rels != 6))
			{
				if (!isset($relationships[$rels]["passes"])) continue;
				if (!in_array($k,$relationships[$rels]["passes"])) continue;
			}			
			if (($v['type'] == "MEASUREMENT") || ($v['type'] == "STATUS"))
			{
				//echo 'Located Measurement!';
				if (!isset($found[$k]))
				{
					if ($rels != 0)
					{ 
						//OK - load some value data here....
						$nm = str_replace(")","",str_replace("(","_",str_replace(" ","",$v['name'])));
						
						$query = $db->query('SELECT typename, options, value,name,properties.id FROM properties JOIN assetvalues ON ( assetvalues.propertyid = properties.id ) WHERE properties.id = '.$k.' AND assetvalues.assetid='.$id.' ORDER BY name DESC');
						//$query = $db->query('SELECT typename, options, value,name FROM properties JOIN assetvalues ON ( assetvalues.propertyid = properties.id ) WHERE properties.id = '.$k.' AND assetproperties.assetid='.$id);
						//echo 'SELECT typename, options, value,name FROM properties LEFT JOIN assetvalues ON ( assetvalues.propertyid = properties.id ) WHERE properties.id = '.$k.' AND assetvalues.assetid='.$id;

						if($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							$basevalue = $row['value'];
							$options = $row['options'];
							$module = $row['typename'];
							$propname = $row['name'];
						}
						else
						{
							$query = $db->query('SELECT value FROM assetrelationships JOIN assetvalues ON ( assetvalues.assetid = assetrelationships.parentasset AND assetvalues.propertyid = '.$k.' ) WHERE assetrelationships.childasset='.$id);	
							
							$basevalue = '';
							$module=$v['type'];
							
							if($row = $query->fetch(PDO::FETCH_ASSOC)) 
							{
								$basevalue = $row['value'];
							}	
						}
						
						$value = array();
						$bits = explode('|',$basevalue);
						
						echo '<'.$nm.' id="'.$k.'" type="'.$v['type'].'" name="'.ucwords($v['name']).'" source="'.$id.'">';
						
						$modulefile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($module).'.php';
						if (file_exists($modulefile))
						{
							//Import module...
							include ($modulefile);
									
							for($x=0;$x<count($inputs);$x++)
							{
								if ((!isset($bits[$x])) || ($bits[$x] == "")) 
								{
									if (isset($inputs[$x]['default']))
									{
										$bits[$x] = $inputs[$x]['default'];
										$value[$inputs[$x]['name']] = LinkedData($id,$k,$inputs[$x]['name'],$inputs[$x]['default']);
									}
									else
										$value[$inputs[$x]['name']] = LinkedData($id,$k,$inputs[$x]['name'],'');													
								}
								else
									$value[$inputs[$x]['name']] = LinkedData($id,$k,$inputs[$x]['name'],$bits[$x]);
								
								//echo 'LinkedData...';
								
								$n = str_replace(")","",str_replace("(","_",str_replace(" ","",$inputs[$x]['name'])));
								echo '<'.$n;
								if ($bits[$x] != $value[$inputs[$x]['name']])
								{
									echo ' external="'.$id.':'.$row['id'].':'.$inputs[$x]['name'].'"';
								}
								
								echo '>'.$value[$inputs[$x]['name']];
								//print_r($dynamics);
								echo '</'.$n.'>';															
							}
							
							switch($v['type'])
							{
							case 'MEASUREMENT':
								$propertyset[$k] = $value['measurement'];	
								break;
							case 'STATUS':
								$propertyset[$k] = $value['state'];	
								break;					
							}
						}	
						else
						{
							echo $basevalue;
						}
						
						echo '</'.$nm.'>';
					}
					//echo 'Marking Off '.$k;
					$found[$k] = true;
				}				
			}			
		}
		
		if ($rels == 0)
		{			
			foreach($asset[$id]["relationships"] as $k => $v)
			{
				//echo 'Checking Relationship '.$k.' for passes...';
				foreach($v as $rel)
				{
					if ($rel['upstream'] == true)
					{				
						if (($k == 6) || (isset($relationships[$k]['passes'])))
						{
							//echo 'Relationship '.$k.' Has Passes!';
							$alldone = true;
							foreach($relationships[$k]['passes'] as $propallowed)
							{
								if (!isset($found[$propallowed]))
								{
									$alldone = false;
								}
							}
							if ($k == 6) $alldone = false;
							if (!$alldone) FindSecondaries($rel["target"],$k);
						}
					}
				}
			}
		}
		else
		{
			//echo 'Subscanning Relationship '.$rels;
			if (isset($asset[$id]["relationships"][$rels]))
			{
				//echo 'Relationship Direction: '.$asset[$id]["relationships"][$rels]["upstream"];
				foreach($asset[$id]["relationships"][$rels] as $rl)
				{
					if ($rl["upstream"] == true)
					{
						//echo 'Subscan...';
						//Hold on...are there any properties LEFT?
						$alldone = true;
						foreach($relationships[$rels]['passes'] as $propallowed)
						{
							if (!isset($found[$propallowed]))
							{
								$alldone = false;
							}
						}								
						
						if ($alldone == false) FindSecondaries($rl["target"],$rels);
					}
				}
			}
			
			if (isset($asset[$id]["relationships"][6]))
			{
				if ($asset[$id]["relationships"][6][0]["upstream"] == true)
				{
					FindSecondaries($asset[$id]["relationships"][6][0]['target'],$rels);
				}
			}
		}
		
		//echo $iso;
		//global $iso;
	}	
	
	//echo 'Value of ISO: '.$iso;
	
	//if ($iso != "") echo $iso;
?>