<?php
/**
 * Gets a list of obects AND THEIR POSITIONS inside an environment
 *
 * Creates a list of objects within a given environment. 
 *
 * The 'id' parameters is the ID of the environment object.
 *
 * @author Steven Harding
 */	
		
	
		$itemid = $_REQUEST['id'];
		$done = array();
	
		header("Content-type: text/xml");
		echo '<contents>';
		
		$query = $db->query("SELECT typename,id FROM properties WHERE typename='MODEL' OR typename='LOCATION'");
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['typename'] == 'MODEL')
			{
				$modelprop = $row['id'];
			}
			if ($row['typename'] == 'LOCATION')
			{
				$locationprop = $row['id'];
			}
		}
	       
		$modelid = array();    
		$modeltex = array();
		$modelcol = array();
		
		$query = $db->query("SELECT assets.id,assetvalues.value FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id) JOIN assetvalues ON (assets.id = assetvalues.assetid) WHERE assetvalues.propertyid=".$modelprop." AND assetrelclosures.parentasset = ".$itemid);       
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$bits = explode('|',$row['value']);
			$modelid[$row['id']] = $bits[0];
			if (count($bits) > 1)
			{
				$modeltex[$row['id']] = $bits[1];
				$modelcol[$row['id']] = $bits[2];
			}
		}
		
		$query = $db->query("SELECT link.childasset as id, value FROM assetrelclosures as link JOIN assetrelclosures as tagged ON (tagged.childasset=link.childasset AND tagged.relationship=3) JOIN assetvalues ON (tagged.parentasset = assetvalues.assetid) WHERE assetvalues.propertyid=".$modelprop." AND link.parentasset = ".$itemid);       
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$bits = explode('|',$row['value']);
			if (!isset($modelid[$row['id']]))
			{
				$modelid[$row['id']] = $bits[0];
				if (count($bits) > 1)
				{
					$modeltex[$row['id']] = $bits[1];
					$modelcol[$row['id']] = $bits[2];
				}
			}
		}
		
		$dynamiclocations = array();
		$query = $db->query("SELECT link.childasset as id, lastvalue,node FROM assetrelclosures as link JOIN datalinks ON (datalinks.assetid = link.childasset) WHERE datalinks.propertyid=".$locationprop." AND link.parentasset = ".$itemid);       
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			
			if (isset($dynamiclocations[$row['id']]))
			{
				$dynamiclocations[$row['id']][$row['node']] = $row['lastvalue'];
			}
			else
			{
				$dynamiclocations[$row['id']] = array();
				$dynamiclocations[$row['id']][$row['node']] = $row['lastvalue'];
			}
		}
		
		//print_r($dynamiclocations);

		$boundassets = array();

		$query = $db->query("SELECT DISTINCT id,name,descript,value FROM assets JOIN assetrelclosures ON (assetrelclosures.childasset=assets.id) JOIN assetvalues ON (assets.id = assetvalues.assetid) WHERE assetvalues.propertyid=".$locationprop." AND assetrelclosures.parentasset = ".$itemid);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$ps = $row['value'];
			$bits = explode('|',$ps);
			
			if (isset($dynamiclocations[$row['id']]))
			{
				if (isset($dynamiclocations[$row['id']]['position']))
				{
					$bits[0] = '@position:'.$dynamiclocations[$row['id']]['position'];
				}
				if (isset($dynamiclocations[$row['id']]['scale']))
				{
					$bits[1] = '@scale:'.$dynamiclocations[$row['id']]['scale'];
				}
				if (isset($dynamiclocations[$row['id']]['rotation']))
				{
					$bits[2] = '@rotation:'.$dynamiclocations[$row['id']]['rotation'];
				}
			}
			
			echo '  <asset id="'.$row['id'].'" name="'.$row['name'].'" position="'.$bits[0].'" rotation="'.$bits[2].'" scale="'.$bits[1].'"';
			if (count($bits) > 3)
			{
				echo ' relativeto="'.$bits[3].'"';
			}
			if ($row['descript'] != "")
			{
				echo ' desc="'.$row['descript'].'"';
			}
			if (isset($bundles[$row['id']]))
			{
				echo ' bundle="yes"';
			}
			if (isset($modelid[$row['id']]))
			{
				echo ' model="'.$modelid[$row['id']].'"';
				if (isset($modelcol[$row['id']]))
				{
					echo ' colour="'.$modelcol[$row['id']].'"';
				}
				if (isset($modeltex[$row['id']]))
				{
					echo ' skin="'.$modeltex[$row['id']].'"';
				}
			}
			echo '>';
			
			$done[] = $row['id'];
														
				if (!isset($asset[$row['id']]))
				{
					include($sitefolder.'/cache/relationships/'.$row['id'].'.inc');					
				}
				
				$qry = $db->query('SELECT assetvalues.propertyid,typename,value,node FROM assetvalues JOIN properties ON (properties.id = propertyid) LEFT OUTER JOIN datalinks ON (datalinks.propertyid=assetvalues.propertyid AND datalinks.assetid=assetvalues.assetid) WHERE assetvalues.assetid='.$row['id'].' ORDER BY name ASC');	
		
				$lastpid = 0;
		
				while($rx = $qry->fetch(PDO::FETCH_ASSOC)) 
				{
					if ($rx['propertyid'] == $modelprop) continue;
					if ($rx['propertyid'] == $locationprop) continue;
					if ($rx['propertyid'] == $lastpid) continue;
						
					$lastpid = $rx['propertyid'];
					
					echo '    <value id="'.$rx['propertyid'].'" ';
					$fn = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($rx['typename']).'.php';
					if (!file_exists($fn)) continue;
					
					include($fn);
					$bits = explode('|',$rx['value']);
					for($x=0;$x<count($inputs);$x++)
					{
						if (isset($bits[$x]))
						{
							echo str_replace(" ","_",$inputs[$x]['name']).'="';
							if ((isset($rx['node'])) && ($rx['node'] != "") && ($rx['node'] == $inputs[$x]['name']))	
							{
								if (($bits[$x] == "") && (isset($inputs[$x]['default'])))
									$initial = htmlentities($inputs[$x]['default']);
								else
									$initial = htmlentities($bits[$x]);
									
								echo '@'.$rx['node'].':'.$initial;							
							}
							else
							{								
								if (($bits[$x] == "") && (isset($inputs[$x]['default'])))
									echo htmlentities($inputs[$x]['default']);
								else
									echo htmlentities($bits[$x]);								
							}
							echo '" ';
						}
					}
					echo '/>';
				}
				
				/*if (isset($asset[$row['id']]))
				{
					if (isset($asset[$row['id']]['values']))
					{				
						foreach($asset[$row['id']]['values'] as $k => $v)
						{
							echo '   <value id="'.$k.'"/>';
						}
					}
				}*/
				
				$bf = $sitefolder.'/cache/bindings/'.$row['id'].'.xml';				
				if (file_exists($bf))
				{
					$content = file_get_contents($bf);
					preg_match_all("/boundasset=\"([0-9]*)\"/", $content, $matches);
					foreach($matches[1] as $m)
					{
						if (!in_array($m,$boundassets)) $boundassets[] = $m;
					};
					echo $content;					
				}
		    
			
			
	    	echo '</asset>'."\r\n";
		}
		
		if (count($boundassets) > 0)
		{
			
			foreach($boundassets as $bs)
			{
				if (in_array($bs,$done))
				{
					continue;
				}
			
				if (!isset($asset[$bs]))
				{
					include($sitefolder.'/cache/relationships/'.$bs.'.inc');					
				}
				
				if (isset($asset[$bs]))
				{
															
					echo '  <asset id="'.$bs.'" name="'.$asset[$bs]['name'].'">';
					
					$qry = $db->query('SELECT assetvalues.propertyid,typename,value,node FROM assetvalues JOIN properties ON (properties.id = propertyid) LEFT OUTER JOIN datalinks ON (datalinks.propertyid=assetvalues.propertyid AND datalinks.assetid=assetvalues.assetid) WHERE assetvalues.assetid='.$bs.' ORDER BY name ASC');				
		
					$lastpid = 0;
					while($rx = $qry->fetch(PDO::FETCH_ASSOC)) 
					{
						if ($rx['propertyid'] == $modelprop) continue;
						if ($rx['propertyid'] == $locationprop) continue;
						if ($rx['propertyid'] == $lastpid) continue;
						
						$lastpid = $rx['propertyid'];
						
						echo '    <value id="'.$rx['propertyid'].'" ';
						$fn = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($rx['typename']).'.php';
						if (!file_exists($fn)) continue;
						
						include($fn);
						$bits = explode('|',$rx['value']);
						for($x=0;$x<count($inputs);$x++)
						{
							if (isset($bits[$x]))
							{
								echo str_replace(" ","_",$inputs[$x]['name']).'="';
								if ((isset($rx['node'])) && ($rx['node'] == $inputs[$x]['name']))
								{
									if (($bits[$x] == "") && (isset($inputs[$x]['default'])))
										$initial = htmlentities($inputs[$x]['default']);
									else
										$initial = htmlentities($bits[$x]);
									
									echo '@'.$rx['node'].':'.$initial;										
									//echo '@'.$rx['node'];
								}									
								else
								{
									if (($bits[$x] == "") && (isset($inputs[$x]['default'])))
										echo $inputs[$x]['default'];
									else
										echo $bits[$x];												
								}
								echo '" ';
							}
						}
						echo '/>';
					}
					
					echo '  </asset>'."\r\n";					
				}
			}
		}

	
	echo '</contents>';
?>