<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	
 
require_once('apiauth.inc');
include($installfolder.'/model/asset.php');

$conditions = "";
$joinquery = "";

if (isset($_REQUEST['q']))
{
	$for = $_REQUEST['q'];
	$q = $for;
	$in = "*";
	
	$hit = array();

	if ($in == "*")
	{
		echo '<results>';

		$query = $db->query("SELECT id,name,type FROM assets ".$joinquery."WHERE (name LIKE '%".$q."%')".$conditions." ORDER BY type,name");
							
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$ass = new Asset($row['id']);
			$nm = $ass->GetFullName();
			echo '<result id="'.$row['id'].'" fullname="'.$nm.'" type="name">'.$row['name'].'</result>';
			$hit[] = $row['id'];
		}

		$query = $db->query("SELECT assets.id,assets.name,assets.type FROM assetvalues JOIN assets ON (assets.id = assetvalues.assetid)".$joinquery."WHERE (value LIKE '%".$q."%')".$conditions." ORDER BY assets.type,assets.name");
								
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (in_array($row['id'],$hit)) continue;
			$ass = new Asset($row['id']);
			$nm = $ass->GetFullName();
			echo '<result id="'.$row['id'].'" fullname="'.$nm.'" type="property">'.$row['name'].'</result>';
			$hit[] = $row['id'];
		}
		
		$query = $db->query("SELECT id,name,type FROM assets ".$joinquery."WHERE (descript LIKE '%".$q."%')".$conditions." ORDER BY type,name");
								
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if (in_array($row['id'],$hit)) continue;
			$ass = new Asset($row['id']);
			$nm = $ass->GetFullName();
			echo '<result id="'.$row['id'].'" fullname="'.$nm.'" type="descript">'.$row['name'].'</result>';
			$hit[] = $row['id'];
		}
				
		echo '</results>';
	};
}
else
{
	if (isset($_REQUEST['taggedas']))
	{
		echo '<results>';
		if (!is_numeric($_REQUEST['taggedas']))
		{
			//First, let's get the number to go with this name...
			$query = $db->query("SELECT id FROM assets WHERE name=".$db->quote($_REQUEST['taggedas']));
						
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$_REQUEST['taggedas'] = $row['id'];
			}
			else
			{
				$_REQUEST['taggedas'] = 0;
			}
		}
		
		$tagid = filter_var($_REQUEST['taggedas'],FILTER_VALIDATE_INT);
		if (($tagid === FALSE) || ($tagid == 0)) exit;
		
		//OK - find all of the items that are tagged with this asset...
		$query = $db->query("SELECT name,id FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE (relationship=3 AND assetrelclosures.parentasset = ".$tagid.")");
						
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			echo '<result id="'.$row['id'].'" name="'.$row['name'].'"/>';
		}
		echo '</results>';
	}
}

include('apioutput.inc');

?>