<?php
/**
 * 3D Editor Function - Set AR Tag Location
 * 
 * Sets the physical location of an AR tag
 *
 * @author Steven Harding
 */	
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	$itemid = FALSE;
	if (isset($_REQUEST['id']))
	{
		$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
	}
	if ($itemid === FALSE)
	{
		exit;
	}
	
	if ($itemid == 0)
	{
		echo "Bad ID!";
		exit;
	}

	if (isset($_REQUEST['position']))
	{
		$position = $_REQUEST['position'];
	}
	
	if (isset($_REQUEST['scale']))
	{
		$scale = $_REQUEST['scale'];
	}
	
	if (isset($_REQUEST['rotation']))
	{
		$rotation = $_REQUEST['rotation'];
	}		
	
	//Get Current Value (If Any)
	$query = $db->query('SELECT value FROM assetvalues JOIN properties ON (assetvalues.propertyid = properties.id) WHERE assetvalues.assetid='.$itemid." AND typename='ARTAG'");
	
	$unit = "";
	$tagid = 0;
	
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$bits = explode('|',$row['value']);
		$unit = $bits[1];
		$tagid = $bits[0];
	}
	
	if ($tagid == 0)
	{
		exit;
	}
	
	$query = $db->query('SELECT location from artags WHERE id='.$tagid." AND area=".$db->quote($unit));
			
	$existing = "";
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$existing = $row['location'];
	}
	
	$final = array("","","");	
	$bits = explode('|',$existing);
	for($x=0;$x<count($bits);$x++)
	{
		$final[$x] = $bits[$x];
	}
	
	if (isset($position)) $final[0] = $position;
	if (isset($scale)) $final[1] = $scale;
	if (isset($rotation)) $final[2] = $rotation;
	
	$value = implode('|',$final);
	
	if ($existing == "")
	{
		$db->query('INSERT INTO artags (id,area,location) VALUES ('.$tagid.','.$db->quote($unit).','.$db->quote($value).')');		
	}
	else
	{
		$db->query('UPDATE artags SET location='.$db->quote($value).' WHERE id='.$tagid.' AND area='.$db->quote($unit));
	}
	
?>