<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	if (!isset($_REQUEST['asset']))
	{
		exit;
	}

	if (!isset($_REQUEST['property']))
	{
		exit;
	}

	if (!isset($_REQUEST['value']))
	{
		exit;
	}

	$asset = $_REQUEST['asset'];
	$value = $_REQUEST['value'];
	$format = "xml";
	$property = $_REQUEST['property'];
	$input = "";

	if (isset($_REQUEST['input']))
	{
		$input = $_REQUEST['input'];
	}

	$asset = filter_var($asset,FILTER_VALIDATE_INT);
	if ($asset === FALSE) exit;

	$property = filter_var($property,FILTER_VALIDATE_INT);
	if ($property === FALSE) exit;

	$recordexists = false;

	$query = $db->query('SELECT typename, options, value,name FROM properties LEFT OUTER JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE properties.id='.$property.' AND assetvalues.assetid='.$asset);	

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$recordexists = true;
		if (isset($row['value'])) $basevalue = $row['value'];		
		$module = $row['typename'];
		$propname = $row['name'];
	}
	else
	{
		$basevalue = "";
		
		$qry = "SELECT tagged.childasset as id, value FROM assetrelclosures as tagged JOIN assetvalues ON (tagged.parentasset = assetvalues.assetid) WHERE (tagged.childasset=".$asset." AND tagged.relationship=3 AND assetvalues.propertyid=".$property.")";
		
		$query = $db->query($qry);       
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$basevalue = $row['value'];
			}
		}
		
		$query = $db->query('SELECT typename, options,name FROM properties WHERE properties.id='.$property);
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$module = $row['typename'];
			$propname = $row['name'];
		}	
	}

	$final = $value;
	
	if ($input != "")
	{
		if (isset($module))
		{	
			$infile = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($module).'.php';
			echo $infile;
			if (file_exists($infile))
			{
				include($infile);
			}
		}	
		
		$existing = explode('|',$basevalue);
		
		if (isset($inputs))
		{
			$final = "";
			for($x=0;$x<count($inputs);$x++)
			{
				$val = "";
				if (isset($existing[$x]))
				{
					$val = $existing[$x];
				}
				if ($_REQUEST['name'] == $inputs[$x]['name'])
				{			
					$val = $_REQUEST['value'];
				}
		
				if ($x > 0) $final .= '|';
				$final .= $val;
			}		
		}
		else
		{
			$final = $_REQUEST['value'];
		}
	}
	
	echo '<response>';

	$action = "None";

	if ($asset != 0)
	{		
		if ($final == "")
		{
			$action = "Deleted";
			$db->query("DELETE FROM assetvalues WHERE assetid=".$asset.' AND propertyid='.$property);
		}
		else
		{
			if ($recordexists == true)
			{
				$action = "Updated";
				//echo 'Updating... '.$final;
				$db->query("UPDATE assetvalues SET value='".$final."' WHERE assetid=".$asset.' AND propertyid='.$property);	
				//LogEvent("asset",$asset,"[prop:".$property."] Updated");
			}
			else
			{
				$action = "Added";
				//echo 'Inserting...';
				$db->query('INSERT INTO assetvalues (assetid, propertyid, value) VALUES ('.$asset.','.$property.",'".$final."')");	
				//LogEvent("asset",$asset,"[prop:".$property."] Added");
			}
		}
	}
		
	echo '   <success id="'.$asset.'" action="'.$action.'"/>';
			
	echo '</response>';

	if ($format != "xml")
	{
		$content = ob_get_clean();
		if ($format == 'json')
		{
			$xml = simplexml_load_string($content);
			$json = json_encode($xml);
			echo $json;
			exit;
		}
	}

?>