<?php
/**
 * 3D Editor Function - Save A Location
 * 
 * Saves the location of a 3D object (<position>|<rotation>|<scale>)
 *
 * @author Steven Harding
 */	
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

	$itemid = FALSE;
	if (isset($_REQUEST['id']))
	{
		$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
	}
	if ($itemid === FALSE)
	{
		exit;
	}
	
	if ($itemid == 0)
	{
		echo "Bad ID!";
		exit;
	}

	if (isset($_REQUEST['position']))
	{
		$position = $_REQUEST['position'];
	}
	
	if (isset($_REQUEST['scale']))
	{
		$scale = $_REQUEST['scale'];
	}
	
	if (isset($_REQUEST['rotation']))
	{
		$rotation = $_REQUEST['rotation'];
	}		
	
	//Get Current Value (If Any)
	$query = $db->query('SELECT value,properties.id as id FROM assetvalues JOIN properties ON (assetvalues.propertyid = properties.id) WHERE assetvalues.assetid='.$itemid." AND typename='LOCATION'");
	
	$existing = "";
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$existing = $row['value'];
		$pid = $row['id'];
	}
	else
	{
		//Otherwise, get the ID of the 'Location' attribute...
		$query = $db->query("SELECT id FROM properties WHERE typename='LOCATION'");
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{			
			$pid = $row['id'];
		}
	}
	
	$final = array("","","");	
	$bits = explode('|',$existing);
	for($x=0;$x<count($bits);$x++)
	{
		$final[$x] = $bits[$x];
	}
	
	if (isset($position)) $final[0] = $position;
	if (isset($scale)) $final[1] = $scale;
	if (isset($rotation)) $final[2] = $rotation;
	
	$value = implode('|',$final);
	
	if ($existing == "")
	{
		echo 'INSERT INTO assetvalues (propertyid, assetid, value) VALUES ('.$pid.','.$itemid.','.$db->quote($value).')';
		
		$db->query('INSERT INTO assetvalues (propertyid, assetid, value) VALUES ('.$pid.','.$itemid.','.$db->quote($value).')');
		$db->query('INSERT IGNORE INTO assetproperties (propertyid, assetid) VALUES ('.$pid.','.$itemid.')');
	}
	else
	{
		echo 'UPDATE assetvalues SET value='.$db->quote($value).' WHERE assetid='.$itemid.' AND propertyid='.$pid;
		
		$db->query('UPDATE assetvalues SET value='.$db->quote($value).' WHERE assetid='.$itemid.' AND propertyid='.$pid);
	}
	
?>