<?php
/**
 * Driver Function - Get source details
 * 
 * During initialisation (and reconfiguration) drivers call this function
 *   to get all of the information about a particular data source.
 *
 * The resulting file contains data about the source itself and all of the
 *   data points associated with it 
 *
 * @author Steven Harding
 */	
	
	//require_once($installfolder.'/include/displayfunctions.php');
	
	$profile = 1;
	$mode = 0;
	if (isset($_REQUEST['profile']))
	{
		$profile = $_REQUEST['profile'];
		$profile = filter_var($profile,FILTER_VALIDATE_INT);
		if ($profile === FALSE) exit;
	}
	
	if (isset($_REQUEST['mode']))
	{
		$mode = $_REQUEST['mode'];
		$mode = filter_var($mode,FILTER_VALIDATE_INT);
		if ($mode === FALSE) exit;
	}
	
	$query = $db->query('SELECT * FROM datasources JOIN assets ON (datasources.assetid = assets.id) WHERE profile='.$profile.' AND mode='.$mode.' AND assetid='.$_REQUEST['asset']);
	
	//echo 'SELECT * FROM datasources JOIN assets ON (datasources.assetid = assets.id) WHERE profile='.$profile.' AND mode='.$mode.' AND assetid='.$_REQUEST['asset'];

	$info = array();
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$info = $row;
	}
	
	if (count($info) == 0)
	{
		exit;
	}
	
	header('Content-type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
	
	echo '<sourcedata>';	

	echo '  <connection>';
	
	echo '     <address>';
	if ($info['address'] == '#')
	{
		//This address is actually stored in a MEDIA FILE for the asset, due to it's excessive size.
		$pth = $_SERVER['DOCUMENT_ROOT'].'/media/assets/'.$_REQUEST['asset'].'/driveraddress.txt';
		if (file_exists($pth))
		{
			echo file_get_contents($pth);
		}
		
	}
	else
		echo $info['address'];
		
	echo '</address>';
	
	echo '     <asset>'.$info['assetid'].'</asset>';
	echo '     <name>'.$info['name'].'</name>';		
	echo '     <port>'.$info['gatewayport'].'</port>';	
	if (isset($info['samplerate']))
	{
		if ($info['samplerate'] != -1)
		{
			echo '     <samplerate>'.$info['samplerate'].'</samplerate>';			
		}
	}	
	
	echo '  </connection>';
	
function Sanitise($xrd)
{
	//return $xrd;
	$s = str_replace("<","&lt;",$xrd);
	$s = str_replace(">","&gt;",$s);
	$s = str_replace("\"","&quot;",$s);
	$s = str_replace("\\","%5C",$s);
	return $s;	
}
	
	echo '  <points>';

	//OK - fetch the data we need...
	$query = $db->query('SELECT address, transform, node, assets.name as assetname, properties.name as propertyname, assetid, propertyid FROM datalinks JOIN assets ON (assets.id = datalinks.assetid) JOIN properties ON (properties.id = datalinks.propertyid) WHERE datalinks.mode='.$mode.' AND datalinks.profile='.$profile.' AND sourceid='.$_REQUEST['asset']);
	
	//echo 'SELECT address, transform, node, assets.name as assetname, properties.name as propertyname, assetid, propertyid FROM datalinks JOIN assets ON (assets.id = datalinks.assetid) JOIN properties ON (properties.id = datalinks.propertyid) WHERE datalinks.mode='.$mode.' AND datalinks.profile='.$profile.' AND sourceid='.$_REQUEST['asset'];

	$dynamicdata = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		echo '     <point address="'.htmlentities($row['address']).'" transform="'.$row['transform'].'" code="'.$row['assetid'].':'.$row['propertyid'].':'.$row['node'].'" name="'.$row['assetname'].'.'.$row['propertyname'].'.'.$row['node'].'"/>';
	}
	
	$query = $db->query('SELECT address, transform, node, assets.name as assetname, datalinks.assetid, propertyid,alerts.name as propertyname, -1 as propertyid FROM datalinks JOIN assets ON (assets.id = datalinks.assetid) JOIN alerts ON (alerts.id = datalinks.node) WHERE sourceid='.$_REQUEST['asset'].' AND propertyid=-1');

	$dynamicdata = array();
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		echo '     <point address="'.$row['address'].'" transform="'.$row['transform'].'" code="'.$row['assetid'].':'.$row['propertyid'].':'.$row['node'].'" name="'.$row['assetname'].'.'.$row['propertyname'].'.Status"/>';
	}
	
	echo '  </points>';
	
	echo '</sourcedata>';
?>