<?php
/**
 * Gets fundamental ARDI metadata
 *
 * This function returns the names of all relationships and properties.
 *
 * It is used to initialise all of the basic metadata of an external
 *   application (such as ARDI AR)
 *
 * @author Steven Harding
 */	
require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');

if (!isset($_REQUEST['origin']))
{
	exit;
}

if (!isset($_REQUEST['destination']))
{
	exit;
}

if (!isset($_REQUEST['rel']))
{
	exit;
}

$origin = $_REQUEST['origin'];
$destination = $_REQUEST['destination'];
$format = "xml";
$rel = $_REQUEST['rel'];

$origin = filter_var($origin,FILTER_VALIDATE_INT);
if ($origin === FALSE) exit;

$destination = filter_var($destination,FILTER_VALIDATE_INT);
if ($destination === FALSE) exit;

$rel = filter_var($rel,FILTER_VALIDATE_INT);
if ($rel === FALSE) exit;

$recordexists = false;

	$query = $db->query('SELECT COUNT(*) as cnt FROM assetrelationships WHERE parentasset='.$origin.' AND childasset='.$destination.' AND relationship = '.$rel);	

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['cnt'] == 0)
		{
			echo '<response><success message="Relationship Did Not Exist"/></response>';
			exit;
		}
	}

echo '<response>';

require_once($_SERVER['DOCUMENT_ROOT'].'/include/linker.php');
	
UnlinkAssets($origin,$destination,$rel);
	
echo '   <success message="Removed Link"/>';
		
echo '</response>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>