<?php
 /**
 * Historian Access
 *
 * Downloads history information from suitable data sources.
 */	
 
function GetHistoryRaw($asset,$property,$node,$start,$end)
{
	global $db;
	
	//Find historian source of this data...
	$profile = 1;
	
	$query = $db->query('SELECT gatewayport,datasources.assetid,datadriver.address FROM datalinks JOIN datasources ON ( datalinks.sourceid = datasources.assetid ) JOIN datadriver ON (datadriver.port = datasources.gatewayport) WHERE datalinks.assetid='.$asset.' AND datasources.profile='.$profile.' AND datasources.mode=1 AND propertyid='.$property.' AND node='.$db->quote($node).' AND datalinks.mode=1');
	if ($query !== FALSE)
	{
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$srcassetid=$row['assetid'];
			$sourceport = $row['gatewayport'];
			$sourceaddress = $row['address'];
		}
	}
	
	//echo 'SELECT gatewayport FROM datalinks JOIN datasources ON ( datalinks.sourceid = datasources.assetid ) WHERE assetid='.$asset.' AND propertyid='.$property.' AND node='.$db->quote($node).' AND mode=1';

	if (!isset($sourceport))
	{		
		//echo 'Port Not Found!';
		return false;
	}
	
	$ch = curl_init(); 
	//$sourceport = $port;
	$pointset = $asset.':'.$property.':'.$node;
	//$srcassetid = 27;
    
	$qry = "id=".$srcassetid."&points=".$pointset."&start=".$start."&end=".$end;	
	
	$qry = str_replace(" ","%20",$qry);
	if ($sourceaddress == "") $sourceaddress = "localhost";
	
	//echo "http://".$sourceaddress.":".$sourceport."/query?".$qry;	
	
    curl_setopt($ch, CURLOPT_URL, "http://".$sourceaddress.":".$sourceport."/query?".$qry); 
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 

    $output = curl_exec($ch); 

    curl_close($ch);     
		
	$arr = array();
	$bits = explode("\r\n",$output);
	for($x=1;$x<count($bits);$x++)
	{
		$pieces = explode(",",$bits[$x]);
		$arr[] = $pieces;
	}
	
	return $arr;
}

function GetBulkHistory($points,$start,$end,$grain,$function,$first)
{
	global $db;
		
	//Determine which historians actually STORE this data...
	$assetlist = array();
	$propertylist = array();
	$nodelist = array();
			
	//print_r($points);
	
	foreach($points as $p)
	{
		if (!in_array($p['asset'],$assetlist))
		{
			$assetlist[] = $p['asset'];
		}
		if (!in_array($p['property'],$propertylist))
		{
			$propertylist[] = $p['property'];
		}
	}
	
	$sources = array();
	$ports = array();
	
	//Now, it's time to query the DB to find their actual sources...
	
	$profile = 1;
	
	$qry = 'SELECT DISTINCT gatewayport,datasources.assetid, datalinks.assetid as asst, datalinks.node, datalinks.propertyid FROM datalinks JOIN datasources ON ( datalinks.sourceid = datasources.assetid ) WHERE datalinks.assetid IN ('.implode(',',$assetlist).') AND propertyid IN ('.implode(',',$propertylist).') AND datalinks.mode=1 AND datalinks.profile='.$profile;
	
	$query = $db->query($qry);
	
	/*ob_start();	
	print_r($points);
	$pnts = ob_get_clean();
	file_put_contents("c:\\tmp\\incoming.txt",$pnts);
	unset($pnts);		*/
	
	
	//ob_start();	
			
	if ($query !== FALSE)
	{
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			for($x=0;$x<count($points);$x++)
			{
				//print_r($points[$x]);
				if ($points[$x]['asset'] == $row['asst'])
				{
					if ($points[$x]['property'] == $row['propertyid'])
					{
						if ($points[$x]['node'] == $row['node'])
						{
							if (!isset($sources[$row['assetid']]))
							{
								$sources[$row['assetid']] = array();
							}
							//echo '***I JUST SELECTED THIS ITEM!';
							//print_r($points[$x]);
							$sources[$row['assetid']][] = $points[$x];							
							$ports[$row['assetid']] = $row['gatewayport'];
							break;
						}
					}
				}
			}			
		}
	}
	
	//$pnts = ob_get_clean();
	//file_put_contents("c:\\tmp\\incoming2.txt",$pnts);
	//unset($pnts);		
	
	//echo 'Source Count: '.count($sources).'<br/>';

	/*if (count($sources) == 0)
	{
		echo 'Failed To Load!';
	}

	if (count($sources) == 1)
	{
		echo 'Single Origin!';
	}
	else
	{
		//Split into multiple queries on multiple databases...
		echo 'Multi-Origin';
	}*/	
	
	$output = "";
	
	foreach($sources as $nm => $src)
	{	
		//echo 'Processing Source '.$nm.'<br/>';
	
		$ch = curl_init(); 
		
		$px = array();
		foreach($src as $p)
		{
			$px[] = $p['asset'].':'.$p['property'].':'.$p['node'];
		}
						
		$pointset = implode('_',$px);
		
		//print_r($src);
		
		$qry = "id=".$nm."&points=".$pointset."&start=".$start."&end=".$end;	
		
		$qry .= "&grain=".$grain."&function=".$function;
		if ($first == 0) $qry .= "&followup=1";
		
		$qry = str_replace(" ","%20",$qry);			
		
		//echo 'Sending Query: '.$qry.' to '.$ports[$nm]."\r\n";	
		
		curl_setopt($ch, CURLOPT_URL, "http://localhost:".$ports[$nm]."/query?".$qry); 
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
	
		$thisoutput = curl_exec($ch);
		
		$mapping = array();
		$x = -1;
		foreach($src as $p)
		{
			$x++;
			$mapping[$x] = $p['id'];
		}
		
		/*ob_start();	
		print_r($mapping);
		$pnts = ob_get_clean();
		file_put_contents("c:\\tmp\\mapping.txt",$pnts);
		unset($pnts);
		
		ob_start();	
		echo $thisoutput;		
		$pnts = ob_get_clean();
		file_put_contents("c:\\tmp\\output.txt",$pnts);
		unset($pnts);*/
		//echo 'Converting...';
		
		//echo $thisoutput;
		
		$lines = explode("\n",$thisoutput);
		$thisoutput = "";
		foreach($lines as $line)
		{
			$ps = strpos($line,',');
			if ($ps === FALSE) continue;
			if ($ps == "") continue;
			//echo "Incoming Line: ".substr($line,0,$ps)."<br/>";
			$line = $mapping[0+substr($line,0,$ps)].','.trim(substr($line,$ps+1));
			$thisoutput .= $line."\r\n";
		}
		
		//echo 'Conversion Complete - '.$thisoutput;
		
		//echo '----------------';
		
		/*$x = -1;
		foreach($src as $p)
		{
			$x++;
			$thisoutput = str_replace("\n".$x.",","\n".$p['id'].",",$thisoutput);	
			
			$v = $x.",";
			$n = substr($thisoutput,0,strlen($v));
			if ($n == $v)
			{				
				$thisoutput = $p['id'].substr($thisoutput,strlen($v)-1);
			}
			
			echo 'Converting '.$x.' To '.$p['id'].'<br/>';
					
		}
		
		echo '-----------';
		
		echo $thisoutput;*/
	
		$output .= $thisoutput; 
	
		curl_close($ch);
	}
		
	$arr = array();
	$bits = explode("\r\n",$output);
	for($x=0;$x<count($bits);$x++)
	{
		$pieces = explode(",",$bits[$x]);
		$arr[] = $pieces;
	}
	
	return $arr;
}

?>