<?php
 /**
 * Check Isolation Status
 *
 * Finds the isolation points (or failures) for an asset
 */	
	
	$scanset = array();
	global $scanset;
	
	$results = array();
	global $results;
	
	$touched = array();
	global $touched;
	
	if (!isset($relationships))
	{
		require($sitefolder.'/cache/relationships/all.inc');
	}
	global $relationships;
	
	/*StartScan(24);
	
	if (count($results) == 0)
	{
		echo 'Item Is Isolated!<br/><br/>';
	}
	else
	{
		echo 'Not Isolated - Supplied By...<br/>';		
	}
	
	foreach($results as $res)
	{
		echo $res['name'].'<br/>';
	}*/
	
	function GetActiveSources($point)
	{
		global $sitefolder;
		global $scanset;
		global $relationships;
		$pnt = array();
		$pnt['id'] = $point;
		$pnt['dir'] = -1;
		$pnt['depth'] = 0;
		$pnt['priority'] = 0;
		$pnt['rel'] = 0;
		$scanset[] = $pnt;
		
		if (!isset($asset[$point]))
		{
			require($sitefolder.'/cache/relationships/'.$point.'.inc');
		}
		
		$any = false;
		foreach(array_keys($asset[$point]['relationships']) as $r)
		{
			if (isset($relationships[$r]))
			{
				if (isset($relationships[$r]['energysource']))
				{
					$any = true;
					break;
				}
			}
		}
		
		if ($any == false)
		{
			//echo 'Not Anything!';
			$results = FALSE;
			return FALSE;
		}
		
		ScanISOLayers(0);
		
		/*global $results;
		for($x=0;$x<count($results);$x++)
		{
			if ($results[$x]['id'] == $point)
			{
				array_splice($results,$x,1);
				break;
			}
		}*/
		return true;
	}
	
	function ScanISOLayers($priority)
	{
		//echo 'Scanning Layer '.$priority.'<br/>';
				
		$lowestpri = $priority;
								
		global $scanset;
		while ($lowestpri != 999999)
		{		
			$setlen = count($scanset);
			$offset = 0;
			for($x=0;$x<$setlen;$x++)
			{
				if ($scanset[$offset]['priority'] <= $lowestpri)
				{
					//Begin Scan On This Item...
					ScanISOItem($scanset[$offset]);
					array_splice($scanset,$offset,1);
				}
				else
				{
					$offset++;
				}
			}	
			
			$lastlowest = $lowestpri;
			
			//OK - check for any more layers...
			$lowestpri = 999999;
			foreach($scanset as $scan)
			{
				if ($scan['priority'] < $lowestpri)
				{
					$lowestpri = $scan['priority'];
					if ($lowestpri == $lastlowest + 1) break;
				}
			}				
		}
	}
	
	function ScanISOItem($item)
	{
		global $asset;
		global $scanset;
		global $results;
		global $touched;
		global $db;
		global $relationships;
		global $sitefolder;
		
		$itemid = $item['id'];
								
		if (isset($touched[$itemid]))
		{
			return;
		}
		
		$touched[$itemid] = $item['dir'];				
		
		if (!isset($asset[$itemid]))
		{
			require($sitefolder.'/cache/relationships/'.$item['id'].'.inc');
		}
		
		//echo 'Scanning '.$asset[$itemid]['name'].'<br/>';
		
		//Check For Blockages...
		$blocked = false;
		
		foreach($asset[$itemid]['values'] as $k => $val)
		{
			if ($val['type'] == "ISOPOINT")
			{
				//Get Value...
				$query = $db->query("SELECT assetvalues.value as fixedvalue, datalinks.lastvalue as dynamicvalue FROM assetvalues LEFT OUTER JOIN datalinks ON (datalinks.assetid = assetvalues.assetid AND datalinks.propertyid=assetvalues.propertyid AND node='state') WHERE assetvalues.assetid=".$itemid." AND assetvalues.propertyid=".$k);
				
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$parts = explode('|',$row['fixedvalue']);
					
					//print_r($row);
					
					if(isset($row['dynamicvalue']))
					{
						$v = $row['dynamicvalue'];
					}
					else
					{
						$v = $parts[1];
					}
					$r = $parts[0];
					
					if ($r == $item['rel'])
					{						
						if ($v == 0) $blocked = true;
					}
										
				}					
			}
			
			if ($val['type'] == "NRPOINT")
			{
				//Get Value...
				//echo 'Inspecting NR Point<br/>';
				$query = $db->query("SELECT assetvalues.value as fixedvalue FROM assetvalues WHERE assetvalues.assetid=".$itemid." AND assetvalues.propertyid=".$k);
				
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$parts = $row['fixedvalue'];
					
					$r = $parts;
					//echo 'Results: '.$r.' vs '.$item['rel'].'<br/>';
					
					if (($r == $item['rel']) && ($item['dir'] == false))
					{						
						//echo 'Correct Type! Blocking here!<br/>';
						$blocked = true;
					}
										
				}					
			}
		}
		
		if ($blocked == true) 
		{
			//echo 'Blocked!<br/>';
			return;
		}
		
		//echo 'Run Relationships...<br/>';
		
		$parentcount = 0;
		foreach($asset[$itemid]['relationships'] as $k => $v)
		{
			if (($k == $item['rel']) || ($item['rel'] == 0))
			{
				//OK - isolation is based on physical relationships only...
				//echo 'Checking Relationship<br/>';
				if ($relationships[$k]['type'] != 'physical') continue;
				if (!isset($relationships[$k]['energysource'])) continue;
				
				foreach($v as $res)
				{
					$pass = false;
					
					if ($res['upstream'] == true)
					{
						$parentcount++;
					}
									
					/*if (($item['dir'] == -1) || (($item['dir'] == 0) && ($res['upstream'] == false)))
					{
						$pass = true;
					}
					if (($item['dir'] == -1) || (($item['dir'] == 1) && ($res['upstream'] == true)))
					{
						$pass = true;
					}*/
					$pass = true;	
									
					if ($pass == true)
					{
						if (isset($touched[$res['target']]))
						{
							continue;
						}
												
						$pnt = array();
						$pnt['id'] = $res['target'];
						$pnt['dir'] = $res['upstream'];
						$pnt['depth'] = $item['depth'] + 1;
						$pnt['priority'] = $item['depth'] + 1;
						$pnt['rel'] = $k;
						$scanset[] = $pnt;
						
						//echo 'Added Item To Processing list';
					}
				}
			}
		}
		
		$found = false;
			
		//echo 'Searching Results For '.$itemid.'<br/>';	
		
		foreach($results as $r)
		{
			if ($r['id'] == $itemid)
			{
				$found = true;
				break;
			}
		}
		if ($found == false)
		{
			//echo 'Parent Count: '.$parentcount.' and direction = '.$item['dir'];
			if (($parentcount == 0) && ($item['dir'] === true)) 
			{
				//echo 'WTF?';
				//print_r($item);
				//Got Origin Points
				$res = array();
				$res['name'] = $asset[$itemid]['name'];
				$res['id'] = $itemid;
				$results[] = $res;				
			}
			else
			{
				//echo 'Huh?';
				if (($parentcount == 0) && ($item['dir'] == -1))
				{
					$res = array();
					$res['name'] = $asset[$itemid]['name'];
					$res['id'] = $itemid;
					$results[] = $res;
					//echo 'Self Source!';
				}
			}
		}
		
	}
