<?php
 /**
 * Isolation Utility Functions
 *
 * Finds the isolation points (or failures) for an asset
 */	
	
	$scanset = array();
	global $scanset;
	
	$results = array();
	global $results;
	
	$touched = array();
	global $touched;
	
	if (!isset($relationships))
	{
		require($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/all.inc');
	}
	global $relationships;
	
	function GetIsolationPoints($point)
	{
		global $scanset;
		$pnt = array();
		$pnt['id'] = $point;
		$pnt['dir'] = -1;
		$pnt['depth'] = 0;
		$pnt['priority'] = 0;
		$pnt['rel'] = 0;
		$scanset[] = $pnt;
		
		ScanIPLayers(0);
		
		global $results;
		for($x=0;$x<count($results);$x++)
		{
			if ($results[$x]['id'] == $point)
			{
				$results[$x]['type'] = "Self-Source";
				break;
			}
		}
	}
	
	function ScanIPLayers($priority)
	{
		//echo 'Scanning Layer '.$priority.'<br/>';
				
		$lowestpri = $priority;
								
		global $scanset;
		while ($lowestpri != 999999)
		{		
			$setlen = count($scanset);
			$offset = 0;
			for($x=0;$x<$setlen;$x++)
			{
				if ($scanset[$offset]['priority'] <= $lowestpri)
				{
					//Begin Scan On This Item...
					ScanIPItem($scanset[$offset]);
					array_splice($scanset,$offset,1);
				}
				else
				{
					$offset++;
				}
			}	
			
			$lastlowest = $lowestpri;
			
			//OK - check for any more layers...
			$lowestpri = 999999;
			foreach($scanset as $scan)
			{
				if ($scan['priority'] < $lowestpri)
				{
					$lowestpri = $scan['priority'];
					if ($lowestpri == $lastlowest + 1) break;
				}
			}				
		}
	}
	
	function ScanIPItem($item)
	{
		global $asset;
		global $scanset;
		global $results;
		global $touched;
		global $db;
		global $relationships;
		
		$itemid = $item['id'];
		
		//echo 'Inspecting '.$item['id'].'<br/>';
								
		if (isset($touched[$itemid]))
		{
			return;
		}
		
		$touched[$itemid] = $item['dir'];				
		
		if (!isset($asset[$itemid]))
		{
			require($_SERVER['DOCUMENT_ROOT'].'/cache/relationships/'.$item['id'].'.inc');
		}
		
		//Check For Blockages...
		$blocked = false;
		
		foreach($asset[$itemid]['values'] as $k => $val)
		{
			if ($val['type'] == "ISOPOINT")
			{
				//Get Value...
				$query = $db->query("SELECT assetvalues.value as fixedvalue FROM assetvalues WHERE assetvalues.assetid=".$itemid." AND assetvalues.propertyid=".$k);
				
				//echo 'Investigating Iso Point<br/>';
				
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$parts = explode('|',$row['fixedvalue']);
					
					$r = $parts[0];
					
					//echo 'This Isolates '.$r.'<br/>';
					
					if ($r == $item['rel'])
					{						
						//echo 'Found and blocked!<br/>';
						$blocked = true;
						
						$res = array();
						$res['name'] = $asset[$itemid]['name'];
						$res['id'] = $itemid;
						$res['type'] = 'Isolation Point';
						$results[] = $res;
					}
										
				}					
			}
			
			if ($val['type'] == "NRPOINT")
			{
				//Get Value...
				
				//echo 'Found NR Point!';
				
				$query = $db->query("SELECT assetvalues.value as fixedvalue FROM assetvalues WHERE assetvalues.assetid=".$itemid." AND assetvalues.propertyid=".$k);
				
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$parts = $row['fixedvalue'];
					
					$r = $parts;
					
					if (($r == $item['rel']) && ($item['dir'] == false))
					{						
						$blocked = true;
						
						$res = array();
						$res['name'] = $asset[$itemid]['name'];
						$res['id'] = $itemid;
						$res['type'] = 'Non-Return Point';
						$results[] = $res;
					}
										
				}					
			}
		}
		
		if ($blocked == true) 
		{
			//echo 'Blocked!<br/>';
			return;
		}
		
		//echo 'Run Relationships...<br/>';
		
		$parentcount = 0;
		foreach($asset[$itemid]['relationships'] as $k => $v)
		{
			if (($k == $item['rel']) || ($item['rel'] == 0))
			{
				//OK - isolation is based on physical relationships only...
				
				if ($relationships[$k]['type'] != 'physical') continue;
				if (!isset($relationships[$k]['energysource'])) continue;
				
				foreach($v as $res)
				{
					$pass = false;
					
					if ($res['upstream'] == true)
					{
						$parentcount++;
					}
									
					$pass = true;	
									
					if ($pass == true)
					{
						if (isset($touched[$res['target']]))
						{
							continue;
						}
												
						$pnt = array();
						$pnt['id'] = $res['target'];
						$pnt['dir'] = $res['upstream'];
						$pnt['depth'] = $item['depth'] + 1;
						$pnt['priority'] = $item['depth'] + 1;
						$pnt['rel'] = $k;
						$scanset[] = $pnt;
						
						//echo 'Added Item To Processing list';
					}
				}
			}
		}
		
		if (($parentcount == 0) && ($item['dir'] == true)) 
		{
			//Got Origin Points
			
			//Ensure we don't already have an entry for this item...
			$found = false;
			
			foreach($results as $r)
			{
				if ($r['id'] == $itemid)
				{
					$found = true;
					break;
				}
			}
			
			if ($found == false)
			{
				$res = array();
				$res['name'] = $asset[$itemid]['name'];
				$res['id'] = $itemid;
				$res['type'] = 'Source';
				$results[] = $res;
			}
			
			//print_r($results);
		}
		
	}
