<?php
 /**
 * Mailout Functions
 *
 * Functions to automate the preperation of emails and support
 * email templates.
 */	
 
 
/**
 * Prepares an Email
 *
 * Creates a PHPMailer instance so that code only needs to update the
 * subject, recievers and content.
 */	
function PrepareMail($targetemail)
{
	require_once('PHPMailerAutoload.php');
	
	$ini = parse_ini_file($_SERVER['DOCUMENT_ROOT'].'/config/settings.ini',true);  
	
	$mail = new PHPMailer;
	$mail->IsSMTP();
	$security = "";
	if (isset($ini['smtp']['security'])) 
	{
		$mail->SMTPSecure = $ini['smtp']['security'];	
		$mail->SMTPAuth = TRUE;
		$mail->Password = $ini['smtp']['password'];	
	}
	$mail->Host = $ini['smtp']['host'];
	$mail->Username = $ini['smtp']['user'];
	$mail->Port = $ini['smtp']['port'];
	$mail->SMTPDebug  = 2; 
	$mail->Priority    = 3; 
  	$mail->CharSet     = 'UTF-8';
  	$mail->Encoding    = '8bit';
		
	$mail->From = $ini['smtp']['defaultaddr'];
	$mail->FromName = $ini['smtp']['defaultname'];
	$mail->SetFrom($mail->From,$mail->FromName);
	
	$mail->addAddress($targetemail);
	$mail->addReplyTo( $ini['smtp']['noreply'], 'No Reply');
		
	$mail->isHTML(true);
	return $mail;
}

?>