<?php

	class Page {   
		public $par;
		public $variables = array();		
		public $scripts = array();
		public $css = array();		
		private $structures = array();
		private $sectionname = "";
		public $base = "page";
		
		public $log = "";
				
        public function __construct() {
            
        }

        public function __destruct() {

        }

        public function render() 
		{
			//$this->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).'Rendering...<br/>';			
			foreach($this->structures as $s)
			{
				$this->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).' **]<br/>';
				$this->EndStructure();
			}
			
			echo $this->log;
        }		
		
		public function Start()
		{
			$this->StartStructure("");
		}
		
		public function SetVariable($name, $value)
		{
			$this->variables[$name] = $value;
		}
		
		public function StartStructure($name,$params = "")
		{
			$this->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).'[ '.$name.'<br/>';			
			
			if ($name == "") $name = $this->base;			
			
			$sec = new Structure();
			$sec->SetName($name,$this);
			$this->structures[] = $sec;
			ob_start();
			$this->par->depth++;			
			
			$param = explode('|',$params);
			foreach($param as $s)
			{
				$bits = explode('>',$s);
				if (count($bits) < 2) continue;
				$this->SetData($bits[0],$bits[1]);
			}
		}		
		
		public function Structure($name, $params)
		{
			$this->StartStructure($name,$params);			
			$this->EndStructure();
		}
		
		public function SetData($a,$b)
		{
			
			$this->SetSection($a,$b);
		}
		
		public function EndStructure()
		{
			$this->endSection();
			ob_get_clean();
			$this->par->depth--;
			$ar = array_pop($this->structures);
			$this->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).'] <br/>';
			echo $ar->render();
			$this->sectionname = "";
		}
		
		public function Section($name)
		{
			$this->endSection();
			$this->sectionname = $name;
			$this->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).'[ '.$name.'<br/>';
			//ob_start();
			$this->par->depth++;			
		}
		
		public function SetSection($name, $content)
		{
			echo 'Assigning '.$name.' = '.$content.' On Structure ';
			echo $this->structures[count($this->structures)-1]->template;
			echo '<br/>';
			$this->structures[count($this->structures)-1]->AddSection($name,$content);
		}
		
		private function endSection()
		{
			$sname = $this->sectionname;
			if ($sname == '') $sname = '*';
			//$this->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).'] '.$sname.'<br/>';
			$depth = ob_get_level();
			$content = trim(ob_get_clean());			
			//$content = "";
			if ($content != "")
			{
				if (count($this->structures) > 0)
				{
					$this->structures[count($this->structures)-1]->AddSection($this->sectionname,$content);
				}
			}
			$this->log .= str_repeat('&nbsp;&nbsp;',$depth).' <strong>end</strong><br/>';
			ob_start();
			$this->par->depth++;			
		}
		
		public function CloseAll()
		{
			while (ob_get_level() > 2)
			{
				$this->EndStructure();
			}
		}
    }
	
	class Structure
	{
		public $par;
		public $template;
		private $sections = array();
		private $structures = array();
		
		public function SetName($name,$parent)
		{
			$this->template = $name;
			$this->par = $parent;
		}
		
		public function AddSection($name, $content)
		{
			$this->par->log .= str_repeat('&nbsp;&nbsp;',ob_get_level()).' <strong>'.$name.'</strong> = '.htmlspecialchars($content).'<br/>';
			if (count($this->structures) == 0) 
				$this->sections[$name] = $content;			
			else
				$this->structures->AddSection($name,$content);

		}
		
		public function render()
		{
			//echo 'Attempting Render!';
			
			$vars = $this->par->variables;
			$content = $this->sections;
			$css = $this->par->css;
			$scripts = $this->par->scripts;
			
			$fn = $this->par->par->root.'/'.$this->template.'.php';
			
			//echo 'Searching For Include '.$fn;
			
			if (file_exists($fn))
			{
				//echo 'Got It!';
				include($fn);
			}
		}
	}

?>