<?php
if (class_exists('PostalService')) return;

function DBW($str)
{
	return mysql_real_escape_string($str);
}

function DBPlain($str)
{
	return strip_tags($str);
}

function DBHTML($str)
{
	return htmlentities($str);
}

class PostalService
{
	var $formfields;
	var $original;
	var $template;
	var $errors;
	var $fatal;
	
	function PostalService($tmp)
	{
		$this->formfields = array();
		$this->original = $_REQUEST;
		$this->template = $tmp;
	}
	
	function AutonumberKey($name,$friendly)
	{
		$indx = count($this->formfields);
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['friendly'] = $friendly;
		$this->formfields[$indx]['sanitise'] = FILTER_SANITIZE_NUMBER_INT;
		$this->formfields[$indx]['validate'] = FILTER_VALIDATE_INT;
		$this->formfields[$indx]['nonzero'] = true;	
		$this->formfields[$indx]['required'] = true;
	}
	
	function Int($name,$friendly, $required = false)
	{
		$indx = count($this->formfields);
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['friendly'] = $friendly;
		$this->formfields[$indx]['sanitise'] = FILTER_SANITIZE_NUMBER_INT;
		$this->formfields[$indx]['validate'] = FILTER_VALIDATE_INT;
		if ($required == true) $this->formfields[$indx]['required'] = true;
	}
	
	function Decimal($name, $friendly, $required = false)
	{
		$indx = count($this->formfields);
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['friendly'] = $friendly;
		$this->formfields[$indx]['sanitise'] = FILTER_SANITIZE_NUMBER_FLOAT;
		$this->formfields[$indx]['validate'] = FILTER_VALIDATE_FLOAT;
		if ($required == true) $this->formfields[$indx]['required'] = true;
	}
	
	function Enum($name,$friendly, $enum, $required = false)
	{
		$indx = count($this->formfields);
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['friendly'] = $friendly;
		$this->formfields[$indx]['enum'] = $enum;
		if ($required == true) $this->formfields[$indx]['required'] = true;
	}
	
	function DefaultValue($name, $value)
	{
		$indx = count($this->formfields);
		for($x=0;$x<count($this->formfields);$x++)
		{
			if ($this->formfields[$x]['name'] == $name)
			{
				$indx = $x;
				return;
			}
		}
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['default'] = $value;
	}
	
	function NonZero($name,$value)
	{
		$indx = count($this->formfields);
		for($x=0;$x<count($this->formfields);$x++)
		{
			if ($this->formfields[$x]['name'] == $name)
			{
				$indx = $x;
				return;
			}
		}
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['nonzero'] = true;
	}
	
	function Email($name,$friendly,$required = false)
	{
		$indx = count($this->formfields);
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['friendly'] = $friendly;
		$this->formfields[$indx]['sanitise'] = FILTER_SANITIZE_EMAIL;
		$this->formfields[$indx]['validate'] = FILTER_VALIDATE_EMAIL;
		if ($required == true) $this->formfields[$indx]['required'] = true;
	}
	
	function Text($name)
	{
		$indx = count($this->formfields);
		
		$this->formfields[$indx]['name'] = $name;
		$this->formfields[$indx]['friendly'] = $friendly;
		$this->formfields[$indx]['sanitise'] = FILTER_SANITIZE_STRING;
	}
	
	function Process()
	{
		$_REQUEST = $this->original;
		$this->fatal = false;
		$this->errors = array();
		
		foreach($this->formfields as $field)
		{
			if (isset($_REQUEST[$field['name']]))
			{
				$typecode = 0;
								
				$validated = false;	
				if (isset($field['sanitise']))
				{					
					$_REQUEST[$field['name']] = filter_var($this->original[$field['name']],$field['sanitise']);
					$typecode = $field['sanitise'];
				}						
				
				$exists = true;
				
				if (isset($field['validate'])) 
				{
					if (!filter_var($_REQUEST[$field['name']],$field['validate']))
					{						
						$_REQUEST[$field['name']] = "";		
						$exists = false;		
						$this->errors[] = $field['friendly']." Is Invalid.<br/>";
					}
					$typecode = $field['validate'];
				}
				
				if (isset($field['enum'])) 
				{
					$found = false;
					foreach($field['enum'] as $a)
					{
						if ($_REQUEST[$field['name']] == $a)
						{
							$found = true;
							break;
						}
					}
					if ($found == false)
					{
						$exists = false;
						$_REQUEST[$field['name']] = '';
						$this->errors[] = $field['friendly']." Has An Invalid Value.<br/>";						
					}
				}
				
				//echo 'Exists: '.$exists;
				
				if (isset($field['required']))
				{																			
					if ($_REQUEST[$field['name']] == "") $exists = false;
					
					if ((isset($field['nonzero'])) && ($_REQUEST[$field['name']] == 0))
					{
						if ($exists == true) $this->errors[] = $field['friendly']." Is Zero<br/>";
						$exists = false;						
					}
					
					if ($exists == false)
					{						
						$this->fatal = true;						
					}					
				}				
			}
			else
			{
				if (isset($field['required']))
				{
					$this->fatal = true;
				}
				if (isset($field['default']))
				{
					$_REQUEST[$field['name']] = $field['default'];
				}
			}
		}		
		//echo !$this->fatal;
		return !$this->fatal;
	}
}
?>