<?php
/**
 * Security Functions
 * 
 * Functions designed to handle user permissions over assets
 *
 * @author Steven Harding
 */	

//Send an 'Unauthorized' header if the parameter is 'false'
function OnlyShowIf($bl)
{
	global $testmode;
	if ($testmode == true) return;
	
	if ($bl == false)
	{
		http_response_code(401);
		header("HTTP/1.0 401 Unauthorized");
		exit;
	}
}

//Check if the user has read permission on the specified asset
function CheckReadPermission($id)
{
	global $testmode;
	if ($testmode == true) return true;
	
	global $guestaccessenabled;
	if ($guestaccessenabled == true) return true;
	
	if (!isset($_SESSION['userread'])) return false;
	if ($_SESSION['userread'] == true)
	{
		return true;
	}
	return false;
}

//Check if the user has edit permission on the specified asset
function CheckEditPermission($id)
{
	global $testmode;
	if ($testmode == true) return true;
	
	if (!isset($_SESSION['useredit'])) return false;
	if ($_SESSION['useredit'] == true)
	{
		return true;
	}
	return false;
}

//Check if the user has permission to add new assets
function CheckCreatePermission($parent)
{
	global $testmode;
	if ($testmode == true) return true;
	
	//print_r($_SESSION);
	if (!isset($_SESSION['usercreate'])) return false;	
	if ($_SESSION['usercreate'] == true)
	{
		return true;
	}
	return false;
}

//Check if the user has administrative access
function CheckAdmin()
{
	global $testmode;
	if ($testmode == true) return true;
	
	global $site;
	if ($site == "_test") 
	{
		if (isset($_REQUEST['override'])) return true;
	}
	
	if (!isset($_SESSION['useradmin'])) return false;
	if ($_SESSION['useradmin'] == true)
	{
		return true;
	}
	return false;
}

//Check if this is the superuser
function CheckSuperuser()
{
	global $testmode;
	if ($testmode == true) return true;
	
	if (!isset($_SESSION['usersuper'])) return false;
	if ($_SESSION['usersuper'] == true)
	{
		return true;
	}
	return false;
}

?>