<?php
//Push-A-Button Templating Engine...

if (!isset($_SESSION)) session_start();

if (class_exists('Template')) return;

class Template
{
	var $sectionlist;
	var $sections;
	var $values;
	var $templatefile;
	var $styles;
	var $scripts;	
	
	//Initialises the template file
	function Template($name, $base)
	{
		$this->templatefile = $base;
		$this->currentsection = "";
		$this->values = array();
		$this->sections = array();
		$this->styles = array();
		$this->scripts = array();
		
		$this->Set('title',$name);
	}
	
	//Call this to mark the page as 'public' (ie. not subject to security)
	function PublicPage()
	{
		$this->publicpage = true;
	}
	
	//Write out the contents of the template
	function Write()
	{
		if ($this->currentsection != "")
		{
			$this->EndSection();
		}
		
		if (!isset($_SESSION['userid']))
		{
			if (!isset($this->publicpage))
			{
				global $guestaccessenabled;
				if ($guestaccessenabled == false)
				{
					$dest = '/users/login.php';
					if (isset($_SERVER['REQUEST_URI']))
					{
						$_SESSION['bounceto'] = $_SERVER['REQUEST_URI'];
						if ($_SESSION['QUERY_STRING'] != "")
						{
							$_SESSION['bounceto'] = '?'.$_SERVER['QUERY_STRING'];
						}
					}
					exit;
				}				
			}
		}
		
		if (isset($_SESSION['REQUEST_URI']))
		{
			if ($_SESSION['REQUEST_URI'] != '/users/login.php')
			{
				$_SESSION['bounceto'] = $_SERVER['REQUEST_URI'];
				if ($_SESSION['QUERY_STRING'] != "")
				{
					$_SESSION['bounceto'] = '?'.$_SERVER['QUERY_STRING'];
				}
			}
		}

		require($this->templatefile);
	}
	
	//Write an error page instead
	function Error($heading,$error)
	{
		$this->Set('title',$heading);
		$this->StartSection('content');
		echo $error;
		$this->templatefile = substr($this->templatefile,0,strlen($this->templatefile)-4)."_error.php";
		echo 'Sending Error Message!';
		$this->Write();
	}	
	
	//Add a style sheet to the document header
	function AddStyleSheet($filename)
	{
		$this->styles[count($this->styles)] = $filename;
	}
	
	//Add a javascript file to the document header
	function AddScript($filename)
	{
		$this->scripts[count($this->scripts)] = $filename;
	}
	
	//Set a property of the template
	function Set($valname, $val)
	{
		$this->values[$valname] = $val;
	}
	
	//Begin a marked section (ie. 'onload', 'content' etc.)
	function StartSection($sectionname)
	{		
		if (!isset($_SESSION['userid']))
		{
			if (!isset($this->publicpage))
			{
				global $guestaccessenabled;
				if ($guestaccessenabled == false)
				{
					$dest = '/users/login.php';
					if (isset($_SERVER['REQUEST_URI']))
					{
						$_SESSION['bounceto'] = $_SERVER['REQUEST_URI'];
						if ($_SESSION['QUERY_STRING'] != "")
						{
							$_SESSION['bounceto'] = '?'.$_SERVER['QUERY_STRING'];
						}
					}
					header('Location: '.$dest);
					exit;
				}
			}
		}
	
		if ($this->currentsection != "")
		{
			$this->EndSection();
		}
		ob_start();
		$this->currentsection = $sectionname;
	}
	
	//Close the current section (for internal use only)
	function EndSection()
	{
		if ($this->currentsection != "")
		{
			$this->sections[$this->currentsection] = ob_get_clean();
			$this->currentsection = "";
		}
	}
	
	//Create the header (for use by the template itself)
	function header()
	{
		foreach($this->styles as $s)
		{
			echo '  <link rel="stylesheet" type="text/css" href="'.$s.'"/>';
		}
		
		foreach($this->scripts as $s)
		{
			echo '  <script type="text/javascript" src="'.$s.'"></script>';
		}
	}
	
	function valueset($name)
	{
		if (isset($this->values[$name])) return true;
		return false;
	}
	
	function value($name, $default = "")
	{
		if (isset($this->values[$name]))
			return $this->values[$name];
		else
			return $default;
	}
	
	function sectionexists($section)
	{
		if (isset($this->sections[$section])) return true;
		return false;
	}
	
	function insert($section)
	{
		if (isset($this->sections[$section])) 
		{			
			echo $this->sections[$section];
		}
	}	
};


?>