<?php
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/templateengine.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/config/settings.php');
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/db.php');
						
	$template = new Template('ARDI',$templatename);
	$template->Set('description','Email Action');			
	$template->Set('heading',$companyname);		
	
	$template->AddStyleSheet('/css/select2.css');
	$template->AddStyleSheet('/css/assetcontrol.css');	
	$template->AddScript('/js/select2.js');  
	$template->AddScript('/js/typeahead.bundle.min.js'); 			
	
function stripit($n)
{
	//return str_replace(" ","_",$n);
	return preg_replace("/[^a-zA-Z]/", "", $n);
}
	
	$template->Set('params','');
	
	$template->StartSection('onload');
?>
	$("#lookitup").typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">Not Found - ',
              '<a href="#" onclick="CreateAsset($(\'#lookitup\').val()); return false;">Add This Asset</a>',
              '</div>'
            ].join('\n')            
        }        
    });
    
    var nm = $('#lookitup').attr('name');    
    
    $("#lookitup").on('typeahead:selected',function (evt,item) {
        $(nm + "id").val(item.id);
    });
    
    $("#lookitup").after('<input type="hidden" name="' + nm + 'id" id="' + nm+ 'id"/>');
    
<?php
	
	$template->StartSection('content'); 
?>	
<script>

var assetlist = new Bloodhound({
  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
  queryTokenizer: Bloodhound.tokenizers.whitespace,
  remote: '/data/assetsearch2.php?q=%QUERY',  
  //local: $.map(assets, function(state) { return { value: state }; })
});
 
// kicks off the loading/processing of `local` and `prefetch`
assetlist.initialize();

function Browser()
{
	$('.assetfield').remove('#lookupbrowser');
	$('#lookitup').after('<div id="lookupbrowser" class="lookupbrowser" style="display: none;"><h3>Browser</h3><hr/>Loading Details...</div>');
	$('#lookupbrowser').show(500);
	BrowserUpdate(0,0,'');
}

function RecentList()
{
	$('.assetfield').remove('#lookupbrowser');
	$('#lookitup').after('<div id="lookupbrowser" class="lookupbrowser" style="display: none;"><h3>Tag Matches</h3><hr/>Loading Options...</div>');
	$('#lookupbrowser').show(500);
	RecentListUpdate();
}

function CloseBrowser()
{
	$('#lookupbrowser').hide(500);
}

function ClearBrowser()
{
	$('#lookupbrowser').hide(500);
	$($('#lookitup').attr('name') + "id").val(0);
	$('#lookitup').val("");
}

function BrowserUpdate(relno,ident,name)
{	
	$('#lookitup').val(name);
	$.post('/data/browse.php',{ id: ident, rel:relno },function (data) {
		$('#lookupbrowser').html(data);
	})
	$($('#lookitup').attr('name') + "id").val(ident);
}

function RecentListUpdate()
{		
	$.post('/data/recent.php',{},function (data) {
		$('#lookupbrowser').html(data);
	})	
}

function Recent(name,id)
{
	$('#lookitup').val(name);
	$($('#lookitup').attr('name') + "id").val(id);
	CloseBrowser();
}

function CreateAsset(str)
{
	window.location="/assets/create.php?name=" + str;
}

</script>

<div class="12u" >	
	<br/>
    <h3>Quick Lookup</h3>
    <div class="assetfield">
	    <input id="lookitup" name="result" type="text"/>
        <a href="#" onclick="Browser(); return false;"><div class="browsebutton actionbutton">
        	&nbsp;
        </div></a>
        <!--<div class="tagbutton actionbutton">
        	<a href="#" onclick="Tagger(); return false;">T</a>
        </div>-->
        <a href="#" onclick="RecentList(); return false;"><div class="recentbutton actionbutton">
        	&nbsp;
        </div></a><br/><br/>
        
    </div>    
</div>

    <?php

	$template->Write();
?>