<?php
//Templating Engine

class Structure
{
	public $par;
	public $template;
	public $workingon;
	private $data = array();	
	
	public function SetName($name,$parent)
	{
		$this->template = $name;
		$this->par = $parent;
	}
	
	public function AddData($name, $content)
	{		
		$this->data[$name] = $content;		
		$this->par->Log('Setting '.$this->template.' data: '.$name.' = '.$content);		
	}
	
	public function Params($str)
	{
		$bits = explode('|',$str);
		foreach($bits as $b)
		{
			$ps = strpos($b,'=');
			if ($ps !== FALSE)
			{				
				$nm = substr($b,0,$ps);
				$val = substr($b,$ps+1);
				//echo 'Working On '.$nm.' = '.$val;
				
				$this->AddData($nm,$val);				
			}
		}		
	}
	
	public function Start()
	{
		//echo 'Starting Structure!';
		$this->par->Log('Started '.$this->template);
		$this->par->Log('Adding Level @ '.$this->template.' Start');
		ob_start();		
	}
	
	public function EndSection($name)
	{		
		$this->par->Log('Dropping Level @ '.$this->template.' Section Close');
		$c = ob_get_clean();		
		$this->par->Log('Committing '.$this->template.' data: '.$name.' = '.$c);
		
		if (($c != "") || (($name == "") && (!isset($this->data['']))))
		{
			$this->data[$name] = $c;
		}
		$this->par->Log('Adding Level @ '.$this->template.' Section Close');
		ob_start();		
	}
	
	public function End()
	{						
		$this->EndSection('');
		$this->par->LogObject($this->data);
		//$this->par->Log('Dropping Level @ '.$this->template.' End (Section)');
		//ob_get_clean();
		$content = $this->data;
					
		$this->par->Log('Ended '.$this->template);
		
		$fn = $this->par->folder.'/'.$this->template.'.php';
						
		if (file_exists($fn))
		{			
			global $errormessage;
			
			include($fn);
		}
		
		$this->par->Log('Dropping Level @ '.$this->template.' End (Parent)');
		$response = ob_get_clean();
		echo $response;
		$this->par->Log('Output @ '.$this->template.' - '.$response);
		//echo '<br/><hr/><h2>'.$this->template.'</h2><hr/>'.$response;		
	}
}

class WebPage
{
	public $folder = "";
	public $log = "";
	public $style = "page";
	
	public $css = "";	
	
	private $base;
	private $structures = array();
	
	public function Init($sty = "page")
	{		
		$this->style = $sty;
		$this->folder = $_SERVER['DOCUMENT_ROOT']."/themes/default/struct";		
	
		$this->Log("Initialising Page");
	
		if (ob_get_level() > 0)
		{			
			ob_get_clean();
			$this->Log('Buffers Are Clean');
		}
	
		$this->base = new Structure();
		$this->base->SetName($this->style,$this);
		$this->base->Start();		
		$this->structures[] = $this->base;		
	}
	
	public function Write()
	{
		$this->Clear();
		$this->structures[0]->End();
		$this->base->SetName($this->style,$this);
		$content = ob_get_clean();
		/*echo $content;
		echo "<hr/>Debugging:<br/>\r\n";
		echo $this->log;*/
		//echo 'No Content!';
	}
	
	public function SetData($n,$p)
	{
		//print_r($this->structures);
		$this->structures[count($this->structures)-1]->AddData($n,$p);
	}
	
	public function Begin($n,$p)
	{
		$d = new Structure();
		$d->SetName($n,$this);
		$d->Params($p);
		$d->Start();
		$this->structures[] = $d;
	}
	
	public function End()
	{		
		if (count($this->structures) > 0)
		{			
			$st = $this->structures[array_keys($this->structures)[count($this->structures)-1]];
			$st->End();
			unset($this->structures[array_keys($this->structures)[count($this->structures)-1]]);
		}
	}
	
	public function EndData($name)
	{
		if (count($this->structures) > 0)
		{			
			$st = $this->structures[array_keys($this->structures)[count($this->structures)-1]];
			$st->EndSection($name);			
		}
	}
	
	public function Log($st)
	{
		$this->log .= str_repeat('-',ob_get_level()).htmlspecialchars($st).'<br/>'."\r\n";
	}
	
	public function LogObject($st)
	{
		ob_start();
		print_r($st);
		$cx = ob_get_clean();
		$this->log .= str_repeat('-',ob_get_level()).'>'.htmlspecialchars($cx).'<br/>'."\r\n";
	}
	
	public function Item($n,$p)
	{
		$this->Begin($n,$p);
		$this->End();
	}
	
	public function Clear()
	{
		for($x=count($this->structures)-1;$x>0;$x--)
		{
			$this->End();
		}
	}
}

function shutdown()
{
    global $page;	
	$page->Write();
}

register_shutdown_function('shutdown');

function T($struct, $param = "")
{	
	global $page;
	$page->Item($struct,$param);
	
}

function PageError($a,$b)
{
	global $title;
	global $page;
	
	$title = $a;
	
	$page->style = "page";
	//T('header-basic','title='.$a);
	
	echo '<h4>'.$a.'</h4>';
	echo $b;
				
	exit;
}

function Page404($a,$b)
{
	global $title;
	global $page;
	
	$title = $a;
	
	$page->style = "page-login";
	T('header-basic','title='.$a);
	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Description');
					echo $b;
				ET();
			ET();
		ET();
	ET();
	exit;
}

function PageLogin()
{
	global $title;
	global $page;
	
	$title = 'Please Login';
	
	$page->style = "page-login";
	T('header-basic','title='.$a);
	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Description');
					echo $b;
				ET();
			ET();
		ET();
	ET();
	exit;
}

function ST($struct, $param = "")
{
	global $page;
	$page->Begin($struct,$param);
}

function SS($name)
{
	global $page;
	$page->EndData($name);
}

function ET()
{
	global $page;
	$page->End();
	
}

function CloseAll()
{
	global $page;
	$page->Clear();
}

$page = new WebPage();

if (!isset($title)) $title = 'Unnamed';
if ($title == "") $title = 'Unnamed';

if (isset($style))
	$page->Init($style);
else
	$page->Init();

$page->SetData('title',$title);
global $page;

if (!isset($errormessage)) $errormessage = "";
global $errormessage;

?>
