<?php
/**
 * Update Relationship Cache
 * 
 * This function rebuilds the cache of relationships and should only be
 *   called after new relationships are added to the system or changes have been made
 *   to properties (ie. the 'passes' have changed, or a properties 'Energy' option has
 *   changed).
 *
 * @author Steven Harding
 */	
			
	$esources = array();
			
	$content = '<?php $relationships = array(); ';
	$query = $db->query("SELECT * FROM relationships");
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$content .= ' $relationships['.$row['id'].'] = array();';
		$content .= ' $relationships['.$row['id'].']["name"] = "'.$row['name'].'";';
		$content .= ' $relationships['.$row['id'].']["upname"] = "'.$row['upstreamname'].'";';
		$content .= ' $relationships['.$row['id'].']["downname"] = "'.$row['downstreamname'].'";';
		$content .= ' $relationships['.$row['id'].']["colour"] = "'.$row['colour'].'";';
		if (($row['flags'] & 1) != 0)
		{
			$content .= ' $relationships['.$row['id'].']["energysource"] = "yes";';	
		}		
						
		$typ = "physical";
		if ($row['style'] == 0) $typ = 'physical';
		if ($row['style'] == 1) $typ = 'logical';
		if ($row['style'] == 2) $typ = 'category';
		if ($row['style'] == 3) $typ = 'heirachial';
		
		$content .= ' $relationships['.$row['id'].']["type"] = "'.$typ.'";';
		
		$passes = "";
		
		if (isset($row['options']))
		{
			$bits = explode('|',$row['options']);
			foreach($bits as $b)
			{
				$pieces = explode('=',$b);
				if ($pieces[0] == 'pass')
				{										
					$items = explode(',',$pieces[1]);
					$esources[$row['id']] = $items;
					$passes = 'array('.implode(',',$items).')';
				}
			}
		}
		if ($passes != "")
		{
			$content .= ' $relationships['.$row['id'].']["passes"] = '.$passes.';';
		}
	}	
	
	//OK - take any properties marked as energy sources and make sure the RELATIONSHIP is
	//  also marked as an energy source...
	$done = array();
	
	$query = $db->query("SELECT id FROM properties WHERE options LIKE '%Energy%'");
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		foreach($esources as $k => $v)
		{
			if (in_array($k,$done)) continue;
			foreach($v as $number)
			{
				if ($number == $row['id'])
				{
					$content .= ' $relationships['.$k.']["energysource"] = "yes";';	
					$done[] = $k;
					break;
				}
			}
		}
	}
	
	$content .= "\r\n?>";
	file_put_contents($sitefolder.'/cache/relationships/all.inc',$content);
	
	$content = "";
	
	$content = '<?php $propertyset = array(); ';
	$query = $db->query("SELECT id,name FROM properties");
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$content .= ' $propertyset['.$row['id'].'] = array();';
		$content .= ' $propertyset['.$row['id'].']["name"] = "'.$row['name'].'";';
	}		
	
	$content .= "\r\n?>";
	file_put_contents($sitefolder.'/cache/relationships/properties.inc',$content);
	
	unset($relationships);
	
	//echo 'Resetting Relationships!';
		
?>