<?php

function write_php_ini($array, $file)
{
    $res = array();
    foreach($array as $key => $val)
    {
        if(is_array($val))
        {
            $res[] = "[$key]";
            foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
        }
        else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
    }
	file_put_contents($file,implode("\r\n",$res));
    //safefilerewrite($file, implode("\r\n", $res));
}

if (file_exists($_SERVER['DOCUMENT_ROOT'].'/sites/installed.flag'))
{
	header("Location: /");
	exit;
}

if (isset($_REQUEST['sitename']))
{
	if (trim($_REQUEST['sitename']) != "")
	{	
		$in = parse_ini_file($_SERVER['DOCUMENT_ROOT'].'/sites/default/config/settings.ini',true);
		$in['server']['company'] = $_REQUEST['sitename'];
		write_php_ini($in,$_SERVER['DOCUMENT_ROOT'].'/sites/default/config/settings.ini');
		
		$background = true;
		include($installfolder.'/pages/admin/tools/cacherebuild.php');
		
		header("Location: /");
		file_put_contents($_SERVER['DOCUMENT_ROOT'].'/sites/installed.flag',"!");
		exit;
	}
	else
	{
		$errormessage = "You must provide a name for your initial site!";
	}
}
	
?>

<html>
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>ARDI Site Name</title>
    <!-- Tell the browser to be responsive to screen width -->
    <meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <!-- Bootstrap 3.3.5 -->
    <link rel="stylesheet" href="/plugins/bootstrap/css/bootstrap.min.css">
   <!-- Font Awesome -->
    <link rel="stylesheet" href="/plugins/font-awesome/css/font-awesome.min.css">
	<!-- Font Awesome -->
    <link rel="stylesheet" href="/css/shared.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="/plugins/ionic/ionic.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="/themes/default/css/AdminLTE.min.css">
    <!-- iCheck -->
    <link rel="stylesheet" href="/plugins/iCheck/square/blue.css">

    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
        <script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
        <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>

  <body class="hold-transition login-page">
    <div class="login-box">
      <div class="login-logo">
        <a href="/"><b>Select a Name</a>
      </div><!-- /.login-logo -->
      <div class="login-box-body">
		<p>
		Finally, choose the name for your initial ARDI site.
		</p><hr/>
		<form method="POST" style="width: 50%;margin-left: auto; margin-right: auto;" enctype="multipart/form-data">
			<input type="text" style="width: 100%; margin-bottom: 10px;" name="sitename"/>
			<input type="submit" style="width: 100%;" class="btn btn-success" value="Begin Using ARDI"/>
		</form>
      </div><!-- /.login-box-body -->
    </div><!-- /.login-box -->

    <!-- jQuery 2.1.4 -->
    <script src="/plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 3.3.5 -->
    <script src="/plugins/bootstrap/js/bootstrap.min.js"></script>
    <!-- iCheck -->
    <script src="/plugins/iCheck/icheck.min.js"></script>
  </body>
</html>