<?php

class Property
{
	public $name;
	public $type;
	public $id;
	public $options = array();
	
	public function Property($id = 0)
	{
		$this->id = $id;
	}
	
	public function LoadFromArray($ar)
	{
		$this->name = $ar['name'];
		$this->id = $ar['id'];
		$this->type = $ar['typename'];
		if (isset($ar['options']))
		{
			$bits = explode(':',$ar['options']);
			$this->options = array();
			foreach($bits as $v)
			{
				$this->options[] = $v;
			}
		}
	}
	
	public function Load()
	{
		global $db;
		$qry = 'SELECT * FROM properties WHERE id='.$this->id;
		$query = $db->query($qry);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$this->LoadFromArray($row);
		}
	}
	
	public function IsEnergy()
	{
		if (in_array("Energy",$this->options)) return true;
		return false;
	}
	
	public function ZeroPoint()
	{
		if (in_array("ZeroCenter",$this->options)) return "Center";
		return "Start";
	}
	
	public function GetDefault()
	{
		foreach($this->options as $opt)
		{
			if (strlen($opt) > 8)
			{
				if (substr($opt,0,8) == 'default=')
				{
					return explode('|',substr($opt,8));
				}
			}
			
		}
		return array();
	}
}

class Properties
{
	public static function GetAllProperties()
	{
		global $db;
		$arr = array();
		$qry = 'SELECT id,name,typename FROM properties ORDER BY name';
		$query = $db->query($qry);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$p = new Property();
			$p->LoadFromArray($row);
			$arr[] = $p;
		}
		return $arr;
	}
}

?>