<?php
	
	OnlyShowIf(CheckAdmin());
	
	$id = -1;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$modename = 'Add New Driver';
	
	$propinfo = array();
	if ($id >= 0)
	{
		$query = $db->query("SELECT * FROM datadriver WHERE port=".$_REQUEST['id']);
			
		if($p = $query->fetch(PDO::FETCH_ASSOC)) 
		{	
			$propinfo = $p;
		}
		
		$modename = 'Update Driver';
	
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Driver";
			
			if (isset($_POST['confirm']))
			{
				//Delete It
				
				$redir = $siteroot.'/admin/drivers/uninstall?port='.$id;
				
				//Linux Install...
				if ((PHP_OS == "Linux") || (PHP_OS == "Unix"))
				{
					if ($propinfo['address'] == "localhost")
					{
						//Run the process to install the driver...
						$cmd = "sudo /opt/ardi/drivers/ardirmdrv ".$propinfo['port']." localhost".$siteroot;
						ob_start();
						system($cmd);
						ob_get_clean();
						$redir = $siteroot.'/admin/drivers';
					}
				}
			    
			    $db->query("DELETE FROM datadriver WHERE port=".$id);
				
				include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$redir);
				exit;
			}
		}
	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['driver'] = 0;
		$propinfo['port'] = '';		
		$propinfo['address'] = '';	
				
		$modename = "Add New Driver";
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['driver'])) exit;
			
			$port = 0;
			if (isset($_REQUEST['port']))
			{
				if (trim($_REQUEST['port']) != "")
				{
					$port = $_REQUEST['port'];
				}
			}
			
			$addr = "localhost";
			if (isset($_REQUEST['address']))
			{
				if (trim($_REQUEST['address']))
				{
					$addr = $_REQUEST['address'];
				}
			}
			
			$name = $_REQUEST['name'];
			$driver = $_REQUEST['driver'];			
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your driver.";
			else
			{			
				$query = $db->query('SELECT * FROM datadriver WHERE name='.$db->quote($name));
	
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your driver name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				//$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
				//if ($type === FALSE) exit;
				//$options = "";
				
				$portfield = "";
				$portvalue = "";
				
				if ($port != 0)
				{
					$portfield = ",port";
					$portvalue = ",".$portvalue;
				}
				
				$mode = 0;
				if ($driver[0] == 'H')
				{
					$mode = 1;
				}
				$driver = substr($driver,1);
				
				//echo "INSERT INTO drivers (name,driver,address".$portfield.") VALUES (".$db->quote($name).",".$db->quote($driver).','.$db->quote($addr).$portvalue.')';
				$db->query("INSERT INTO datadriver (name,driver,mode,address".$portfield.") VALUES (".$db->quote($name).",".$db->quote($driver).','.$mode.','.$db->quote($addr).$portvalue.')');
				
				if ($port == 0)
				{
					$port = $db->lastInsertId();
				}
				
				$redir = $siteroot.'/admin/drivers/install?port='.$port.'&driver='.$driver;
				
				//Linux Install...
				if ((PHP_OS == "Linux") || (PHP_OS == "Unix"))
				{
					if ($addr == "localhost")
					{
						//Run the process to install the driver...
						$cmd = "sudo /opt/ardi/drivers/ardiinstdrv ".$port." localhost".$siteroot;
						ob_start();
						system($cmd);
						ob_get_clean();
						$redir = $siteroot.'/admin/drivers';
					}
				}
				
				include ($installfolder.'/include/updaterelcache.php');
				header("Location: ".$redir);
				exit;
			}
			else
			{
				echo $errormsg;
				exit;
			}
		}
	}
	
	if ($modename == "Delete Driver")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete the '<?php echo $propinfo['name']?>' driver on <?php echo $propinfo['address'];?>?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add New Driver";
	
	include($installfolder.'/include/tmpl.php');

	T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin/drivers">Driver List</a></li><li><a href="'.$siteroot.'/admin">Administration</a></li>');
?>
	<script>
	
	function UpdateName()
	{
		var v = $('#driverchoice').val();
		var t = "Live";
		if (v[0] == 'H')
		{
			t = "Historian";
		}
		
		fin = $("#driverchoice option:selected").text();
		fin += " " + t + " Driver";
		$('#newname').val(fin);
	}
	</script>
<?php	

	function GetDriverList($f)
	{
		$sources = array();

		global $installfolder;
		$fn = $installfolder.'/data/'.$f;

		$dirs = glob( $fn.DIRECTORY_SEPARATOR.'*',GLOB_ONLYDIR);
		$ln = strlen($fn)+1;

		foreach($dirs as $d)
		{
			$file = $d.DIRECTORY_SEPARATOR.'info.inc';
			
			$src = array();
			
			if (file_exists($file))
			{
				include($file);
				if (count($src) == 0) continue;
				$src['code'] = substr($d,$ln);
				$sources[] = $src;
			}
		}
		
		return $sources;
	}
	
	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
		
        <tr><td><label>Driver : </label></td><td><select name="driver" id="driverchoice" onchange="UpdateName();"><optgroup label="Live Drivers"><?php
		
		$sources = GetDriverList('live');
		
		foreach($sources as $src) 
		{	
			echo '<option value="L'.$src['code'].'"';
			if ($propinfo['driver'] == $src['code'])
			{
				echo ' selected';
			}
			echo '>'.$src['name'].'</option>';
		}
		?>
			</optgroup>
			<optgroup label="Historical Drivers">
			<?php
		
		$sources = GetDriverList('historical');
		
		foreach($sources as $src) 
		{	
			echo '<option value="H'.$src['code'].'"';
			if ($propinfo['driver'] == $src['code'])
			{
				echo ' selected';
			}
			echo '>'.$src['name'].'</option>';
		}
		?>
			</optgroup>
		</select></td></tr>
		<tr><td><label>Name : </label></td>
		<td><input type="text" name="name" id="newname" value="<?php echo $propinfo['name']; ?>" style="width: 80%"/></td></tr>
        <tr><td><label>Address : </label><br/><span style="font-size: smaller;">Leave blank to run on the local server</span></td><td><input type="text" name="address" id="address" value="<?php echo $propinfo['address']; ?>"/></td></tr>
        <tr><td><label>Port Number : </label><br/><span style="font-size: smaller;">Leave blank to automatically allocate</span></td><td><input type="text" name="port" id="port" value="<?php echo $propinfo['port']; ?>"/></td></tr>
       
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>