<?php

	$td = sys_get_temp_dir();
	if (file_exists($td.'/ardipackage'))
	{
		//unlink($td.'/ardibackup');
	}
	else
	{
		mkdir($td.'/ardipackage');
	}
	
	$pth = $td.'/ardipackage';
	global $pth;
	
	if (file_exists($pth.'/package.zip'))
	{
		unlink($pth.'/package.zip');
	}	
	
	if (!isset($_FILES['package']))
	{
		if (!isset($_REQUEST['local']))
		{					
			echo 'File Not Set';
			exit();
		}
	}
	
	if (!isset($_REQUEST['local']))
	{	
		if ($_FILES['package']['error'] != 0)
		{
			if ($_FILES['package']['error'] == 1) echo 'Backup File Too Large';
			exit();
		}
	}
	
	$rlog = "";
	global $rlog;
	
	$rlog = 'Unpacking File...';
	
	$checklist = array();
	
	function Unzip($filename, $outpath, &$checklist)
	{
		global $rlog;
		global $checklist;
		global $pth;
		$outpath .= DIRECTORY_SEPARATOR;
		$path_file = $filename;
		
		$finalpath = str_replace("\\","/",$path_file);
		
		$dir = $outpath;
		
		$ln = strlen($outpath);
		
		$zip = new ZipArchive();
		if ($zip->open($finalpath,ZipArchive::CHECKCONS) !== TRUE)
		{
			echo 'Failed to Open ZIP File';
			return;
		}
		
		for ($i = 0; $i < $zip->numFiles; $i++) {
			$name = $zip->getNameIndex($i);
			if ($name === FALSE) continue;
			 
		    $path_file = str_replace('/',DIRECTORY_SEPARATOR,$name);	 
			 
			$info = pathinfo($path_file);			
			$fname = $info['basename'];
			$new_dir = $info['dirname'];

			$bits = explode(DIRECTORY_SEPARATOR,$new_dir);
			
			$dest = $pth;
			$new_dir = $dest;
			
			echo 'Extracting '.$name.' to '.$dest.'<br/>';
			$zip->extractTo($dest,$name);
			
			$checklist[$name] = $dest.'/'.$name;
 		}
		$zip->close();		
	}
	
	$fn = $_FILES['package']['tmp_name'];
				
	Unzip($fn,$sitefolder,$checklist);
	
	//print_r($checklist);
	
	$rlog .= "<br/>Inspecting Package...<br/>";
	if (isset($checklist['binding']))
	{
		$rlog .= "  This is an AssetBundle model with a binding file.</br>";
	}
	if (isset($checklist['standard.unity3d']))
	{
		$rlog .= "  A standard (Windows/Mac/Web) AssetBundle Is Included</br>";
	}
	if (isset($checklist['android.unity3d']))
	{
		$rlog .= "  An Android AssetBundle Is Included</br>";
	}
	if (isset($checklist['model.obj']))
	{
		$rlog .= "  An OBJ 3D Model has been included</br>";
	}
	if (isset($checklist['drawing.svg']))
	{
		$rlog .= "  An SVG drawing file has been included</br>";
	}
	if (isset($checklist['model.xml']))
	{
		$xmlfile = $checklist['model.xml'];
		$rlog .= "  Opening Manifest File ( ".$xmlfile." ) for More Detail...</br>";
			
		$xml=simplexml_load_file($xmlfile) or die("Error: Cannot create object");
		
		$rlog .= "    Category : ".$xml->category."<br/>";
		$rlog .= "    Type : ".$xml->type."<br/>";
		$rlog .= "    Style : ".$xml->style."<br/>";
		$rlog .= "    Name : ".$xml->name."<br/>";
		
		$name = strtolower($xml->name);
		$category = strtolower($xml->category);
		$type = strtolower($xml->type);
		$style = strtolower($xml->style);
		
		$finalpath = $sitefolder.'/media/models/'.$category;
		$rlog .= "  Installing Into ".$finalpath."<br/>";
		
		if (!file_exists($finalpath))
		{
			mkdir($finalpath);
		}
		$finalpath .= '/'.$type;
		if (!file_exists($finalpath))
		{
			mkdir($finalpath);
		}
		$finalpath .= '/'.$style;
		if (!file_exists($finalpath))
		{
			mkdir($finalpath);
		}
		
		$id = 0;
		//Add to database to establish an ID number...
		global $db;
		
		$svg = "";
		$path = "";
		
		//Find Existing
		$existing = 0;
		$query = $db->query("SELECT id FROM models WHERE category=".$db->quote($xml->category)." AND type=".$db->quote($xml->type)." AND style=".$db->quote($xml->style)." AND model-".$db->quote($xml->name));
		if ($query !== FALSE)
		{
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$rlog .= "Found Existing Model<br/>";
				$existing = $row['id'];
			}
		}
		
		if ($existing == 0)
		{
			$rlog .= "Adding New Model<br/>";
			$db->query("INSERT INTO models (category,type,style,model,obj,svgfile,jpg) VALUES (".$db->quote($xml->category).",".$db->quote($xml->type).",".$db->quote($xml->style).",".$db->quote($xml->name).",'','','')");
			$rlog .= "INSERT INTO models (category,type,style,model,obj,svgfile,jpg) VALUES (".$db->quote($xml->category).",".$db->quote($xml->type).",".$db->quote($xml->style).",".$db->quote($xml->name).",'','','')";
			$id = $db->lastInsertId();
		}
		else
		{
			$id = $existing;
		}
		
		if ($id == 0)
		{
			$rlog .= "ID Failure - New Row Couldn't Be Created<br/>";
			echo $rlog;
			exit();
		}
		//Change path to include ID number...
		
		if (isset($checklist['model.obj'])) 
		{
			if (file_exists($finalpath.'/'.$id.'.obj')) unlink($finalpath.'/'.$id.'.obj');
			copy($checklist['model.obj'],$finalpath.'/'.$id.'.obj');
			$path = $finalpath.'/'.$id.'.obj';
		}
		if (isset($checklist['standard.unity3d']))
		{
			if (file_exists($finalpath.'/'.$id.'.unity3d')) unlink($finalpath.'/'.$id.'.unity3d');
			copy($checklist['standard.unity3d'],$finalpath.'/'.$id.'.unity3d');
			$path = $finalpath.'/'.$id.'.unity3d';
		}
		if (isset($checklist['android.unity3d'])) 
		{
			if (file_exists($finalpath.'/'.$id.'_android.unity3d')) unlink($finalpath.'/'.$id.'_android.unity3d');
			copy($checklist['android.unity3d'],$finalpath.'/'.$id.'_android.unity3d');
		}
		if (isset($checklist['binding'])) 
		{
			if (file_exists($finalpath.'/'.$id.'.binding')) unlink($finalpath.'/'.$id.'.binding');
			copy($checklist['binding'],$finalpath.'/'.$id.'.binding');
		}
		if (isset($checklist['drawing.svg'])) 
		{
			if (file_exists($finalpath.'/'.$id.'.svg')) unlink($finalpath.'/'.$id.'.svg');
			copy($checklist['drawing.svg'],$finalpath.'/'.$id.'.svg');
			$svg = $finalpath.'/'.$id.'.svg';
		}
		
		//Update item with revised paths...
		
		$db->query("UPDATE model SET obj=".$db->quote($path).", svg=".$db->quote($svg)." WHERE id=".$id);
		
		//Include skins (if any)
	}
	
	echo $rlog;
?>