<?php
	
	OnlyShowIf(CheckAdmin());
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
		
	$title = "Measurement Display";
	
	include($installfolder.'/include/tmpl.php');
	include($installfolder.'/model/property.php');

	T('header-basic','title='.$title);	
	
	$rangetype = 'floating';
	$fadeother = true;
	$minrange = 0;
	$maxrange = 0;
	$gradient = '0000FF_0_%25__FF0000_100_%25';
	
	$fn = $sitefolder.'/cache/display/properties/'.$id.'.xml';
	if (file_exists($fn))
	{
		$xml=simplexml_load_file($fn);
		
		$rangetype = $xml->range->attributes()['type'];
		if ($rangetype == "fixed")
		{
			$minrange = $xml->range->attributes()['min'];
			$maxrange = $xml->range->attributes()['max'];
		}
		foreach($xml->option as $x)
		{
			$n = $x->attributes()['name'];
			$v = $x->attributes()['value']; 
			if (($n == 'fadeother') && ($v == 'false'))
			{
				$fadeother = false;
			}
		}		
		foreach($xml->gradient as $x)
		{
			$gradient = $x->attributes()['stops'];
		}
	}
	
	if ($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		$passback = false;
		if (isset($_REQUEST['rangetype']))
		{
			$rt = $_REQUEST['rangetype'];
							
			if (($rt != 'floating') && ($rt != 'zerobased') && ($rt != 'zerocenter') && ($rt != 'fixed')) exit;
			
			$rangetype = $rt;
			if ($rt == "fixed")
			{			
				$minrange = $_REQUEST['minrange'];
				$maxrange = $_REQUEST['maxrange'];
			}
			if (!isset($_REQUEST['fadeothers']))
			{
				$fadeother = false;
			}									
		}
		else
		{
			$passback = true;
			$gradient = $_REQUEST['finalstops'];
		}
				
		
		$fl = "<display>";			
			
		$fl .= "  <range type=\"".$rangetype."\" ";		
		if ($rangetype == "fixed")
		{
			$fl .= 'min="'.htmlentities($minrange).'" max="'.htmlentities($maxrange).'"';
		}
		$fl .= '/> ';
			
		$fl .= "  <gradient stops=\"".$gradient."\"/>";
		
		if ($fadeother == false)
		{
			$fl .= "  <option name=\"fadeother\" value=\"false\"/>";
		}		
					
		$fl .= "</display>";
		
		if (!file_exists($sitefolder.'/cache/display')) mkdir($sitefolder.'/cache/display');
		if (!file_exists($sitefolder.'/cache/display/properties')) mkdir($sitefolder.'/cache/display/properties');
		file_put_contents($sitefolder.'/cache/display/properties/'.$id.'.xml',$fl);
		
		if ($passback == true)
			header("Location: ".$siteroot."/admin/properties/mdisplay?id=".$id);
		else
			header("Location: ".$siteroot."/admin/properties");
		exit;
	}
	
	$defaultrange = $siteroot.'/tools/gradient/index?type=prop&id='.$id.'&t=linear&d=right&r=off&sp='.$gradient;
	if ($rangetype == "fixed")
	{
		$defaultrange .= '&min='.$minrange.'&max='.$maxrange;
	}
	
?>	

<script>
function UpdateLinkRange()
{
	var finalurl = "/plugins/gradient/index.php?type=prop&id=<?php echo $id; ?>&t=linear&d=right&r=off&sp=<?php echo $gradient; ?>";
	finalurl += "&min=" + $('#minrange').val() + "&max=" + $('#maxrange').val();
	
	$('#gradientlink').attr('href',finalurl);
}

function ClearLinkRange()
{
	var finalurl = "/plugins/gradient/index.php?type=prop&id=<?php echo $id; ?>&t=linear&d=right&r=off&sp=<?php echo $gradient; ?>";
	$('#gradientlink').attr('href',finalurl);
}
</script>

<?php
	ST('section','class=content');
		ST('row');
			ST('half');?>
	    <form method="POST"><?php
				ST('box','title=Display Settings');?>
    <input type="submit" class="btn btn-success" value="Save Settings"/>
    <input type="hidden" name="id" value="<?php echo $id; ?>"/><?php 
					SS('footer');
					ST('ftable'); ?>
    
    <tr>
		<td><label>Range Type:</label></td>
		<td><select style="padding: 2px;" id="rangetype" name="rangetype" onchange="if (this.value == 'fixed') { $('#fixedrange').fadeIn(500); UpdateLinkRange(); } else { $('#fixedrange').fadeOut(500); ClearLinkRange(); };"><option value="floating" <?php if ($rangetype == "floating") echo ' selected';?>>Floating</option><option value="zerobased"<?php if ($rangetype == "zerobased") echo ' selected';?>>Zero-Based</option><option value="zerocenter"<?php if ($rangetype == "zerocenter") echo ' selected';?>>Zero-Center</option><option value="fixed"<?php if ($rangetype == "fixed") echo ' selected';?>>Fixed</option></select></td>
	</tr>
	
      
    <tr style="<?php if ($rangetype != 'fixed') echo 'display: none;'; ?>" id="fixedrange">
		<td><label>Default Range:</label></td>
		<td><input type="text" style="width: 5em; line-height: normal;" name="minrange" id="minrange" value="<?php echo $minrange; ?>"/>&nbsp;&nbsp;-&nbsp;&nbsp;<input type="text" style="width: 5em; line-height: normal;" name="maxrange" id="maxrange" value="<?php echo $maxrange; ?>"/></td>
	</tr>

      
    <tr>
		<td><label>Colour Scheme:</label></td>
		<td><a href="<?php echo $defaultrange;?>" id="gradientlink" style="border-bottom:0px; display: block; width: 300px; height: 1.5em; border: 2px solid black; margin-top: 2px; text-decoration: none; background-image: url(/tools/gradient/getgradient?sp=<?php echo $gradient; ?>); background-repeat: repeat-y;">&nbsp;</a></td>
	</tr>	
       
   
	
    <tr>
		<td colspan="2">&nbsp;</td></tr>
		<tr><td>Other:</td>
		<td><input type="checkbox" name="fadeothers" style="margin-right: 8px;"<?php if ($fadeother == true) echo ' checked';?>/>Fade Items Without This Property</td>
	</tr>	
    
    <?php			ET(); ?>
    </form>
<?php
				ET();
			ET();
		ET();
	ET(); ?>