<?php
	
	OnlyShowIf(CheckAdmin());
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$styles = array();
	global $installfolder;
	$fn = $installfolder.'/modules/info';

	$dirs = glob( $fn.DIRECTORY_SEPARATOR.'*');
	$ln = strlen($fn)+1;
	
	function SortModules($a,$b)
	{
		if ($a['friendly'] == $b['friendly']) return 0;
		return ($a['friendly'] < $b['friendly']) ? -1 : 1;
	}

	foreach($dirs as $d)
	{
		$file = $d;
		//echo $file;
		
		$src = array();
		
		if (file_exists($file))
		{
			include($file);
			$src['module'] = strtoupper($modulename);
			$src['friendly'] = $modulefullname;
			$styles[] = $src;
		}
	}
	
	$src = array();
	$src['module'] = 'MEASUREMENT';
	$src['friendly'] = 'An Analogue Measurement';
	$styles[] = $src;
	
	$src = array();
	$src['module'] = 'STATUS';
	$src['friendly'] = 'A Digital Status';
	$styles[] = $src;
	
	usort($styles,"SortModules");
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM properties WHERE id='.$id.' ORDER BY name');
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
		}

		$modename = "Update Property";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Property";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM properties WHERE id=".$id);
				include($installfolder.'/include/updaterelcache.php');
				header("Location: ".$siteroot."/admin/properties/");
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['type'])) exit;
			
			$name = $_REQUEST['name'];
			$type = $_REQUEST['type'];
			$options = "";						
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your relationship.";
			else
			{			
				$query = $db->query('SELECT * FROM properties WHERE name='.$db->quote($name).' AND id <> '.$id);
									
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your relationship name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				if (isset($_REQUEST['energy']))
				{
					if ($_REQUEST['energy'] == 'yes') $options = 'Energy';
				}
	
				if (isset($_REQUEST['display']))
				{
					if ($_REQUEST['display'] == 'ZeroCenter') 
					{
						if ($options != "")
							$options .= '|ZeroCenter';
						else
							$options = 'ZeroCenter';
					}
				}
	
				$fd = array();
				if (isset($_REQUEST['flowsdown']))
				{			
					$fd = $_REQUEST['flowsdown'];
				}				
							
				if (($type != "MEASUREMENT") && ($type != "STATUS")) 
				{
					$fd = array();
					$options = "";
				}
				else
				{
					if (!is_array($fd))
					{
						$fd = array($fd);
					}
					if ($type == "MEASUREMENT")
					{
						$defaults = '|'.$_REQUEST['units'].'|'.$_REQUEST['minrange'].'|'.$_REQUEST['maxrange'].'|'.$_REQUEST['dp'];
						if ($options != "") $options .=':';
						$options .= 'default='.$defaults;
					}
					if ($type == "STATUS") 
					{
						$defaults = '|'.$_REQUEST['zerotext'].'|'.$_REQUEST['onetext'];
						if ($options != "") $options .=':';
						$options .= 'default='.$defaults;
					}
				}
				
				$db->query("UPDATE properties SET name=".$db->quote($name).", typename=".$db->quote($type).', options='.$db->quote($options).' WHERE id='.$id);
					
				$fdlist = implode(',',$fd);
				if ($fdlist == ',') $fdlist = "";
				
				$qry = "SELECT id,options FROM relationships WHERE options<>''";
				if ($fdlist != "")
				{
					$qry .= " OR id IN (".$fdlist.")";
				}
				$qry .= " ORDER BY id";
					
				//Find any relationships that ALREADY flow this...
				$query = $db->query($qry);
		
				$actionlist = array();
				$existingoptions = array();								
					
				if ($query !== FALSE)
				{
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$hit = false;
						
						if (in_array($row['id'],$fd)) $existingoptions[$row['id']] = $row['options'];
						
						$bits = explode('|',$row['options']);
						foreach($bits as $b)
						{
							$pieces = explode('=',$b);
							if ($pieces[0] == 'pass')
							{
								$items = explode(',',$pieces[1]);
								foreach($items as $i)
								{
									if ($i == $id)
									{									
										if (!in_array($row['id'],$fd))
										{
											//Bingo - found this ID in the pass values of a DIFFERENT relationship.										
											
											$bits = array_diff($bits,array($b));
											$newval = implode('|',$bits);
																															
											$final = implode(',',array_diff($items,array($id)));
																													
											if ($final != "")
											{
												if ($newval != "")
												{
													$newval .= "|";
												}
												$newval .= "pass=".$final;
											}
											
											//Queue this ID for removal
											$actionlist[$row['id']] = "UPDATE relationships SET options=".$db->quote($newval)." WHERE id=".$row['id'];
																																									
											$existingoptions[$row['id']] = $newval;
											
										}									
									}
								}
								break;
							}
						}										
					}
				}
					
				foreach($fd as $indx)
				{
					$present = false;
					
					$others = "";
					$bits = explode('|',$existingoptions[$indx]);
					foreach($bits as $b)
					{
						$pieces = explode('=',$b);
						if ($pieces[0] == 'pass')
						{
							$others = $pieces[1];
							$items = explode(',',$pieces[1]);
							if (in_array($id,$items))
							{
								$present = true;
							}
							$bits = array_diff($bits,array($b));
							break;
						}
					}
					
					if ($present == true)
					{
						continue;						
					}
					
					$nv = "pass=".$id;
					if ($others != "") $nv .= ",".$others;
					
					if ((count($bits) > 0) && ($bits[0] == "")) unset($bits[0]);
					$bits[] = $nv;
					
					$result = implode('|',$bits);
					$existingoptions[$indx] = $result;
					
					$actionlist[$indx] = "UPDATE relationships SET options=".$db->quote($result)." WHERE id=".$indx;
				}
				
				//print_r($actionlist);
				
				foreach($actionlist as $act)
				{
					//echo $act.'<br/>';
					$db->query($act);
				}
							
				//}
											
				include($installfolder.'/include/updaterelcache.php');
				//print_r($_REQUEST);
				header("Location: ".$siteroot."/admin/properties");
				exit;
			}
		}

	}
	else
	{
		$propinfo['name'] = '';
		$propinfo['typename'] = 'TEXT';
		$propinfo['options'] = '';
		$modename = "Add Property";
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['type'])) exit;
			
			$name = $_REQUEST['name'];
			$type = $_REQUEST['type'];
			$options = "";
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your property.";
			else
			{			
				$query = $db->query('SELECT * FROM properties WHERE name='.$db->quote($name));
	
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your property name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				$fd = "0";
				if (isset($_REQUEST['flowsdown']))
				{			
					$fd = $_REQUEST['flowsdown'];
				}
				
				if (!is_array($fd))
				{
					$fd = array($fd);
				}
				
				if (isset($_REQUEST['energy']))
				{
					if ($_REQUEST['energy'] == 'Hazardous') $options = 'Energy';
				}
				
				if (isset($_REQUEST['display']))
				{
					if ($_REQUEST['display'] == 'ZeroCenter') 
					{
						if ($options != "")
							$options .= '|ZeroCenter';
						else
							$options = 'ZeroCenter';
					}
				}
				
				if (($type != "MEASUREMENT") && ($type != "STATUS")) 
				{
					$fd = array();
					$options = "";
				}
				else
				{
					if ($type == "MEASUREMENT")
					{
						$defaults = '|'.$_REQUEST['units'].'|'.$_REQUEST['minrange'].'|'.$_REQUEST['maxrange'].'|'.$_REQUEST['dp'];
						if ($options != "") $options .=':';
						$options .= 'default='.$defaults;
					}
					if ($type == "STATUS") 
					{
						$defaults = '|'.$_REQUEST['zerotext'].'|'.$_REQUEST['onetext'];
						if ($options != "") $options .=':';
						$options .= 'default='.$defaults;
					}
				}
				
				$db->query("INSERT INTO properties (name,typename,options) VALUES (".$db->quote($name).",".$db->quote($type).','.$db->quote($options).')');
				
				$id = $db->lastInsertId();			
				
				//print_r($fd);
										
				if (count($fd) > 0)
				{
					foreach($fd as $indx)
					{
						$existingoptions = "";
						$query = $db->query("SELECT id,options FROM relationships WHERE id=".$indx." ORDER BY id");				
						if($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							$existingoptions = $row['options'];
						}
						
						$others = "";
						$bits = explode('|',$existingoptions);
						foreach($bits as $b)
						{
							$pieces = explode('=',$b);
							if ($pieces[0] == 'pass')
							{
								$others = $pieces[1];
								$bits = array_diff($bits,array($b));
								break;
							}
						}
						$nv = "pass=".$id;
						if ($others != "") $nv .= ",".$others;
						
						if ((isset($bits[0])) && ($bits[0] == "")) unset($bits[0]);
						$bits[] = $nv;
						
						$result = implode('|',$bits);
																
						$db->query("UPDATE relationships SET options=".$db->quote($result)." WHERE id=".$indx);	
					}
				}
				
				include($installfolder.'/include/updaterelcache.php');			
				header("Location: ".$siteroot."/admin/properties");
				exit;
			}
		}
	}
	
	if ($modename == "Delete Property")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your property '<?php echo $propinfo['name']?>'?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add/Edit ".$propinfo['name'];
	
	if ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'duplicate'))
	{
		$title = 'Duplicate '.$propinfo['name'];
		$modename = 'Duplicate '.$propinfo['name'];
		
		$ps = strpos($propinfo['name'],'-');
		if ($ps != FALSE)
		{
			$propinfo['name'] = trim(substr($propinfo['name'],0,$ps-1));
		}
		
		$id = 0;
	}
	
	include($installfolder.'/include/tmpl.php');
?>
<script>
function UpdateType()
{
	var v = $('#typename').val();
	if (v == "MEASUREMENT")
	{
		//alert('Fading In!');
		$('.propbox').fadeIn(500);
		$('.measurement').fadeIn(500);
		$('.status').fadeOut(500);
	}
	else
	{
		if (v == "STATUS")
		{
			$('.propbox').fadeIn(500);
			$('.measurement').fadeOut(500);
			$('.status').fadeIn(500);
		}
		else
		{
			$('.propbox').fadeOut(500);
			$('.status').fadeOut(500);
			$('.measurement').fadeOut(500);
		}
	}
}
</script>
<?php

	if (!isset($propinfo['options']))
	{
		$propinfo['options'] = '';
	}
	$split = explode(':',$propinfo['options']);
	$defaults = array();
	foreach($split as $s)
	{
		$bits = explode('=',$s);
		if (count($bits) > 1)
		{
			if ($bits[0] == 'default')
			{
				$defaults = explode('|',$bits[1]);
				break;
			}
		}
	}
	
	$onetext = "On";
	$zerotext = "Off";
	
	$units = 0;
	$min = 0;
	$max = 100;
	$points = 0;
	//print_r($defaults);
	if (isset($defaults[1])) 
	{
		$units = $defaults[1];
		$zerotext = $defaults[1];
	}
	if (isset($defaults[2]))
	{
		$min = $defaults[2];
		$onetext = $defaults[2];
	}
	if (isset($defaults[3])) $max = $defaults[3];
	if (isset($defaults[4])) $points = $defaults[4];
	

	
	T('header-basic','title='.$title.'|backtrace=<li><a href="'.$siteroot.'/admin/properties">Property List</a></li><li><a href="'.$siteroot.'/admin">Administration</a></li>');	

	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
						
    	<tr><td><label>Name : </label></td><td><input type="text" name="name" value="<?php echo $propinfo['name']; ?>"/></td></tr>
        <tr><td><label>Type : </label></td>
        <td><select name="type" id="typename" onChange="UpdateType();" onKeyPress="UpdateType();">
			<?php
			foreach($styles as $st)
			{
				echo '<option value="'.$st['module'].'"';
				if ($propinfo['typename'] == $st['module']) echo ' selected';
				echo '>'.$st['friendly'].'</option>';
			}
			?>
        	<!--<option value="TEXT"<?php if ($propinfo['typename'] == 'TEXT') echo ' selected'; ?>>Plain Text</option>
            <option value="MEASUREMENT"<?php if ($propinfo['typename'] == 'MEASUREMENT') echo ' selected'; ?>>An Analogue Measurement</option>
            <option value="STATUS"<?php if ($propinfo['typename'] == 'STATUS') echo ' selected'; ?>>A Digital Status</option>
            <option value="ROUTINE"<?php if ($propinfo['typename'] == 'ROUTINE') echo ' selected'; ?>>A Routine Maintenance Task</option>-->
		</select></td></tr>
        <?php
					ET();
				ET();
			ET();
			
			ST('half');
				$hidebydefault = " hidebydefault";
				if ($propinfo['typename'] == 'MEASUREMENT') $hidebydefault = "";
				if ($propinfo['typename'] == 'STATUS') $hidebydefault = "";
				ST('box','title=Property Settings|class=propbox'.$hidebydefault.'|id=settings');
					ST('ftable');
		?>
		
		<tr class="measurement"<?php if ($propinfo['typename'] != 'MEASUREMENT') echo ' style="display: none;"';?>><td><label>Default Units : </label></td><td><input type="text" name="units" value="<?php echo $units;?>"/></td></tr> 
		<tr class="measurement"<?php if ($propinfo['typename'] != 'MEASUREMENT') echo ' style="display: none;"';?>><td><label>Default Range : </label></td><td><input type="text" name="minrange" value="<?php echo $min;?>"/> - <input type="text" name="maxrange" value="<?php echo $max;?>"/></td></tr>
		<tr class="measurement"<?php if ($propinfo['typename'] != 'MEASUREMENT') echo ' style="display: none;"';?>><td><label>Default Decimal Places : </label></td><td><input type="text" name="dp" value="<?php echo $points;?>"/></td></tr>		
        <tr class="measurement"<?php if ($propinfo['typename'] != 'MEASUREMENT') echo ' style="display: none;"';?>>
		
        <td><label>Display : </label></td><td><select name="display" id="display">
        	<option value="ZeroBased">Zero is the Minimum Value</option>            
            <option value="ZeroCenter"<?php 
			if (isset($propinfo['options'])) {
			if (strpos($propinfo['options'],"ZeroCenter") !== FALSE) echo ' selected'; }; ?>>Zero is the Average Value</option>
        </select></td></tr>   
		
		<tr class="status"<?php if ($propinfo['typename'] != 'STATUS') echo ' style="display: none;"';?>><td><label>When Zero : </label></td><td><input type="text" name="zerotext" value="<?php echo $zerotext;?>"/></td></tr>
		<tr class="status"<?php if ($propinfo['typename'] != 'STATUS') echo ' style="display: none;"';?>><td><label>When One : </label></td><td><input type="text" name="onetext" value="<?php echo $onetext;?>"/></td></tr>
        
        <tr><td><label>Flow Through:</label></td><td>
		<?php
        $query = $db->query('SELECT id,name,options FROM relationships WHERE style=0 ORDER BY name');
	
		$hit = false;
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['id'] == 6) continue;
			echo '<input type="checkbox" name="flowsdown[]" class="flowbox" value="'.$row['id'].'"';
			//Find 'Pass' option...
			$bits = explode('|',$row['options']);
			foreach($bits as $b)
			{
				$pieces = explode('=',$b);
				if ($pieces[0] == 'pass')
				{
					$items = explode(',',$pieces[1]);
					foreach($items as $i)
					{
						if ($i == $id)
						{
							echo ' checked';
							$hit = true;
						}
					}
				}
			}
			
			echo '/>&nbsp;&nbsp;'.$row['name']."<br/>";
		}?>
        
		</td></tr>
		
		<?php
		$view = "none";
		if ($hit == true) $view = "block";
		?>
		
        <tr id="measuredown"><td>
        <label>Energy : </label></td><td><input type="checkbox" name="energy" value="yes"<?php
		if (isset($propinfo['options'])) {
			if (strpos($propinfo['options'],"Energy") !== FALSE) echo ' checked'; }; ?>/>&nbsp;&nbsp;This is a type of energy</td></tr>    
	
				<?php ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>