<?php
	
	OnlyShowIf(CheckAdmin());
	
	//We might need to change database if we are in a certain situation...
	if (!class_exists("AuthSystem"))
	{
		global $installfolder;
		include($installfolder.'/include/login.php');
	}
	
	$auth = new AuthSystem();
	$dbx = $auth->GetDatabase();
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	function TranslateLevel($level)
	{
		if ($level == "User") return "User";
		if ($level == "Editor") return "Editor";
		if ($level == "Builder")
		{
			if (CheckAdmin())
				return "Builder";
			else 
				return "";
		}
		if ($level == "Superuser")
		{
			if (CheckSuperuser())
				return "Superuser";
			else 
				return "";
		}		
		
		return "";
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $dbx->query('SELECT * FROM users WHERE userid='.$id);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;			
		}

		$modename = "Update User";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete User";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$dbx->query("DELETE FROM users WHERE userid=".$id);
				$dbx->query("DELETE FROM userdata WHERE userid=".$id);
				header("Location: ".$siteroot."/admin/users");
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			//if (!isset($_REQUEST['type'])) exit;
			
			$name = $_REQUEST['name'];
			$email = $_REQUEST['email'];
			$level = TranslateLevel($_REQUEST['level']);
			if ($level == "")
			{
				$errormsg = "Invalid User Access Level";
			}
			else
			{	
				$extravalues = "";
				
				if (isset($_REQUEST['password']))
				{
					if (($_REQUEST['password'] == $_REQUEST['confirm']) && ($_REQUEST['password'] != ""))
					{
						$extravalues = ', pwd = PASSWORD('.$dbx->quote($_REQUEST['password']).')';
					}
				}
			
				$upd = "UPDATE users SET username=".$dbx->quote($name).", token='".$id."', email=".$dbx->quote($email).', basegroup='.$dbx->quote($level).$extravalues.' WHERE userid='.$id;
			
				$dbx->query($upd);
				
				//echo $upd;
				
				header("Location: ".$siteroot."/admin/users");
				exit;
			}
		}

	}
	else
	{
		$propinfo['username'] = '';
		$propinfo['email'] = '';
		$modename = "Add User";
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['email'])) exit;
			
			$name = $_REQUEST['name'];
			$type = $_REQUEST['email'];
			$options = "";
			
			if (trim($name) == "")
			{
				$errormsg = "You must enter a username to create a user";
			}
			
			if (trim($type) == "")
			{
				if (!isset($errormsg)) {
					$errormsg = "You must enter an email address to create a user";
				}
			}
			
			if (isset($_REQUEST['password']))
			{
				if ($_REQUEST['password'] != $_REQUEST['confirm'])
				{
					$errormsg = "Your passwords did not match!";
				}
			}
			
			$query = $db->query('SELECT * FROM users WHERE name='.$db->quote($name));
			if ($query !== FALSE)
			{
				$errormsg = "A user with that user name already exists";
			}
			
			$query = $db->query('SELECT * FROM users WHERE email='.$db->quote($type));
	
			if ($query !== FALSE)
			{
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "A user with that email address already exists";
				}
			}						
			
			if (!isset($errormsg))
			{
			
				$bits = openssl_random_pseudo_bytes(6);
				$hex = bin2hex($bits);
				
				$level = TranslateLevel($_REQUEST['level']);
				if ($level == "")
				{
					$errormsg = "Invalid User Access Level";
				}
				else
				{	
					
					if (isset($_REQUEST['password']))
					{
						$hex = $_REQUEST['password'];
					}
					
					$dbx->query("INSERT INTO users (username,email,pwd,source,basegroup) VALUES (".$dbx->quote($name).",".$dbx->quote($type).',PASSWORD('.$dbx->quote($hex).'),'.$dbx->quote('local').','.$dbx->quote($level).')');
					
					$id = $db->lastInsertId();
					
					$dbx->query("INSERT INTO userdata (userid,property,value) VALUES (".$dbx->quote($id).",'passexpired','yes')");
					
					//Send Email With Default Password...
					
					
					require_once($installbase.'/include/mail.php');
							
					$mail = PrepareMail($type);
											
					$mail->Subject = 'Your ARDI Login';
					
					$mail->Body    = 'Your ARDI account has been created - you can now login.<br/><br/>Your username is <b>'.$name.'</b> and your password is <b>'.$hex.'</b><br/><br/>Note that you will be required to change the password immediately.<br/><br/>You can login (and update your password) at <a href="http://'.$publicservername.'/users/settings.php">http://'.$publicservername.'/users/settings.php</a>';
					
					$mail->AltBody = 'Your ARDI account has been created - you can now login.\r\n\r\nUsername: '.$name.' and your password is '.$hex.'\r\n\r\nNote that you will be required to change the password immediately.\r\n\r\nYou can login at http://'.$publicservername.'/users/settings.php';
					
					if(!$mail->send()) {
					   echo "Mail Error";
					}
					
					header("Location: ".$siteroot."/admin/users");
					exit;
				}
			}
		}
	}
	
	if ($modename == "Delete User")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete the user '<?php echo $propinfo['username']?>'?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add/Edit ".$propinfo['name'];
	
	include($installfolder.'/include/tmpl.php');?>
	
<?php

	T('header-basic','title='.$title);	

	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
						
    	<tr><td><label>Name : </label></td><td><input type="text" name="name" value="<?php echo $propinfo['username']; ?>"/></td></tr>
        <tr><td><label>Email Address : </label></td><td><input type="text" name="email" value="<?php echo $propinfo['email']; ?>"/></td></tr>
        <tr><td><label>Access Level : </label></td><td><select name="level"><option value="User"<?php if ($propinfo['basegroup'] == 'User') echo ' selected';?>>Basic User</option><option<?php if ($propinfo['basegroup'] == 'Editor') echo ' selected';?>>Editor</option><?php if (CheckAdmin()) { ?><option<?php if ($propinfo['basegroup'] == 'Builder') echo ' selected';?>>Builder</option><?php }; ?><?php if (CheckSuperuser()) { ?><option<?php if ($propinfo['basegroup'] == 'Superuser') echo ' selected';?>>Superuser</option><?php }; ?>
        </select></td></tr>
        <tr><td><label>Password : </label></td><td><input type="password" name="password" value=""/></td></tr>
        <tr><td><label>Password (Again) : </label></td><td><input type="password" name="confirm" value=""/></td></tr>
       
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>