<?php

//$editable = true;

if (!isset($_REQUEST['id']))
{
	exit;
}

$itemid = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$exname = $thisasset;

function CopyToZip($path,$zip)
{
	$files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path), RecursiveIteratorIterator::SELF_FIRST);
	foreach ($files as $file)
	{
		$plain = str_replace($source,'',$file);
		//echo 'Backing up '.$plain.' based on '.$file;
		
		$file = str_replace('\\', '/', $file);
		$plain = str_replace('\\', '/', $plain);

		// Ignore "." and ".." folders
		if( in_array(substr($file, strrpos($file, '/')+1), array('.', '..')) )
			continue;

		$file = realpath($file);		
		
		//if ((strlen($plain) >= 13) && (substr($plain,0,13) == 'media/artags/')) continue;
		//if ((strlen($plain) >= 13) && (substr($plain,0,13) == 'media/models/')) continue;
		
		$path_parts = pathinfo($file);
		if (isset($path_parts['extension'])) {
			if ($path_parts['extension'] == 'php') 
			{
				if (strpos($plain,"daq") === FALSE)
				{
					continue;
				}
			}	
		}

		if (is_dir($file) === true)
		{
			echo 'Creating Folder: '.$plain.'/'."<br/>";
			$zip->addEmptyDir($plain . '/');
		}
		else if (is_file($file) === true)
		{
			$zip->addFile($file,$plain);
			echo '  Adding File: '.$plain."<br/>";
		}
	}
}

if ($_SERVER['REQUEST_METHOD'] == 'POST')
{
	if (isset($_REQUEST['rel']))
	{
		$rel = $_REQUEST['rel'];
		
		$alist = array();
		$alist[] = $itemid;
		
		//Get list of assets within this item...
		if ($rel != 0)
		{
			$query = $db->query('SELECT DISTINCT childasset FROM assetrelclosures WHERE parentasset = '.$itemid.' AND relationship='.$rel);

			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$alist[] = $row['childasset'];
			}
		}
		
		$query = $db->query('SELECT DISTINCT parentasset FROM assetrelclosures WHERE childasset IN ('.implode(',',$alist).') AND relationship=3');
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			//echo 'Punching This!';
			$alist[] = $row['parentasset'];
		}
		
		//Create a bundle export file...
		$background = true;
		
		$exportlocation = $sitefolder.'/backup';
		if (!file_exists($exportlocation)) mkdir($exportlocation);
		$exportlocation .= '/'.$itemid;
		if (!file_exists($exportlocation)) mkdir($exportlocation);
		
		$filename = $exportlocation.'/'.$thisasset->name.'.ardi';
		$exportlocation .= '/export.txt';
		
		include($installfolder.'/pages/tools/export/form/run.php');
		
		$zip = new ZipArchive();
		if ($zip->open($filename, ZipArchive::CREATE) !== TRUE)
		{
			echo 'Unable to Compress Backup!';
			exit();
		}
		
		//Go through and add all associated media, bindings etc.
		foreach($alist as $assetid)
		{
			//Check for media associated with an asset...
			if (file_exists($sitefolder.'/media/'.$assetid))
			{
				//Copy media files
				CopyToZip($sitefolder.'/media/'.$assetid,$zip);
			}
			if (file_exists($sitefolder.'/cache/bindings/'.$assetid))
			{
				//Copy binding files
				CopyToZip($sitefolder.'/cache/bindings/'.$assetid,$zip);
			}
			if (file_exists($sitefolder.'/layouts/'.$assetid))
			{
				//Copy layout files
				CopyToZip($sitefolder.'/layouts/'.$assetid,$zip);
			}
		}
		
		//Add 3D models and textures...
		
		
		//Compress file...
		
		$zip->addFile($exportlocation,"content.txt");
		
		$zip->close();
		
		header("Content-Type: application/zip");
		header("Content-Disposition: attachment; filename=\"".$exname->name.".zip\"");
		header("Content-Length: " . filesize($filename));

		readfile($filename);
		//readfile($exportlocation);
		
		unlink($filename);
		unlink($exportlocation);
		exit;
	}
}

$title = $thisasset->name.' Bundle';

global $installfolder;

include('include/tmpl.php');


T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('half');
				ST('boxform','title=Create Asset Bundle'); ?>
					<input type="submit" class="btn btn-success" value="Create"/><?php
					SS('footer');
					?>
					<p>This will create an 'ARDI Bundle' - a copy of this asset and its children which can be re-used by yourselves or others to quickly replicate a complex component.</p>
					<p>To begin, select from the options below and hit 'Create'</p><?php
					ST('ftable'); ?>
						<tr><td><label>Include Children Based On: </label></td><td><select name="rel">
							<option value="0">Do Not Include Children</option>
							<?php
						include($installfolder.'/model/relationship.php');
						$rels = Relationships::GetAll();
						$rset = $thisasset->GetRelationships();
						foreach($rset as $k => $v)
						{
							$children = false;
							foreach($v as $n)
							{
								if ($n['upstream'] == false)
								{
									$children = true;
									break;
								}
							}
							if ($children == false) continue;
							foreach($rels as $rx)
							{
								if ($rx->id == $k)
								{
									echo '<option value="'.$rx->id.'">'.$rx->name.'</option>';
									break;
								}
							}
						}
							?>
						</select></td></tr><?php
						
					ET();
					
				ET();
			ET();
		ET();
	ET(); ?>