<?php
/**
 * Creates a new asset
 *
 * This page can be launched in several different ways...
 *
 *	Without Parent - This is allowed, but a warning appears. Orphaned 
 *    	assets can be an issue
 *
 *	With Parent - Preferred. This also allows you to use importers 
 *		such as the spreadsheet or P&ID importer
 *
 * @author Steven Harding
 */
						
	$childid = 0;
	
	$rel = 0;
	if (isset($_REQUEST['rel']))
	{
		$rel = $_REQUEST['rel'];
	}
	
	if (isset($_REQUEST['child']))
	{
		$childid = $_REQUEST['child'];		
		
		$childdata = array();		
		$query = $db->query('SELECT * FROM assets WHERE id='.$childid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$childdata = $row;
		}	
		
		$query = $db->query('SELECT name FROM relationships WHERE id='.$rel);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$relname = $row['name'];
		}	
	}
	
	if (($rel == 3) && (isset($_REQUEST['name'])) && (isset($_REQUEST['parent'])))
	{
		//OK - go ahead and create the thing, since we already have everything we need.
		$_SERVER['REQUEST_METHOD'] = 'POST';
		$_REQUEST['origin'] = $_REQUEST['parent'];		
		$_REQUEST['desc'] = "";
	}
	
function AssignTags($id)
{
	global $db;
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/closuretables.php');	
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/cacheobject.php');		
	
	$tags = "";
	if (isset($_REQUEST['tags']))
	{
		$tags = $_REQUEST['tags'];
	}
	if ($tags == "") return false;
	
	$tagas = explode(',',$_REQUEST['tags']);

	foreach($tagas as $itm)
	{
		$db->query('INSERT INTO assetrelationships (childasset,parentasset,relationship) VALUES ('.$id.','.$itm.',3)');
	}
	
	$db->query('DELETE FROM assetrelclosures WHERE relationship=3 AND childasset='.$itemid);
				
	RebuildObjectClosureTable($id,3);
	RebuildObjectCacheByID($id);	
	
	return true;
}
	
	$error = "";
		
	if (($_SERVER['REQUEST_METHOD'] == 'POST') && (isset($_REQUEST['name'])))
	{
		//echo 'Processing!';
		$name = $_REQUEST['name'];
		$tags = "";
		$origin = "";
		//$rel = "";

		if (trim($name) == "")
		{
			$error .= "Please choose a valid name.";
		}
		
		if (isset($_REQUEST['origin']))
		{
			$origin = $_REQUEST['origin'];
		}	
		
		if (isset($_REQUEST['relationship']))
		{
			$rel = $_REQUEST['relationship'];
		}				
		
		if (!isset($_REQUEST['desc']))
		{
			if ($error != "") $error .= "<br/>";
			$error .= "Please choose a valid description.";
		}
		else
		{
			if (trim($_REQUEST['desc']) != "")
			{
				$desc = $_REQUEST['desc'];
			}	
			else
			{
				$desc = "";
				//if ($error != "") $error .= "<br/>";
				//$error .= "Please choose a valid description.";
			}
		}
		
		//print_r($_REQUEST);
		
		if ($error == "")
		{
		
			require($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');
		
			/*$db->query("INSERT INTO assets (name,descript,type) VALUES (".$db->quote($name).",".$db->quote($desc).",0)");
			
			//echo "INSERT INTO assets (name,descript,type) VALUES (".$db->quote($name).",".$db->quote($desc).",0)";
			
			$newid = $db->lastInsertId();
			//$newid = 55;*/
			
			if ($origin != "")
			{		
				$newid = CreateAssetAfter($name,$desc,$origin,$rel);
																							
				if ($rel != 3)
				{
					if (AssignTags($newid))
					{
						header('location: '.$siteroot.'/asset/links?id='.$newid);
					}
					else
					{
						header('location: '.$siteroot.'/diagram/'.$newid);
					}
				}
				else
				{
					header('location: '.$siteroot.'/diagram/'.$newid);
				}
				exit;
			}
			else
			{
				if ($childid > 0)
				{
					CreateAssetBefore($name, $desc, 0, $childid,$rel);
				}
				else
				{
					CreateAssetOrphaned($name, $desc);
				}
								
				if ($rel != 3)
				{
					if (AssignTags($newid))
					{
						header('location: /assets/links?id='.$newid);
					}
					else
					{
						header('location: /diagram/'.$newid);
					}
				}
				else
				{
					header('location: /diagram/'.$newid);
				}
				exit;
			}						
		}
	}
		
	$atype = "Asset";
	if ($rel == 3) $atype = "Tag";
		
	$title = 'Create New '.$atype;

	include($installfolder.'/include/tmpl.php');
			
	$parentid = 0;
	if (isset($_REQUEST['parent']))
	{
		$parentid = $_REQUEST['parent'];
				
		$parentdata = array();		
		$query = $db->query('SELECT * FROM assets WHERE id='.$parentid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$parentdata = $row;
		}		
	}
	
	if (isset($_REQUEST['relationship']))
	{
		$relationshipid = $_REQUEST['relationship'];
	}		
	
	$relset = array();
	
	$defaults = array();
	
	$query = $db->query('SELECT id,name,upstreamname,downstreamname FROM relationships WHERE (relationships.style = 3)');
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$relset[] = $row;		
	}
	
	if ($parentid != 0)
	{
		//OK - get default values for the parent fields...
		for($x=0;$x<count($relset);$x++)
		{
			$query = $db->query('SELECT parentasset, assets.name as asname FROM assetrelationships JOIN assets ON (assets.id = parentasset) WHERE childasset='.$parentid.' AND relationship='.$relset[$x]['id'].'');
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$relset[$x]['default'] = $row['parentasset'];
				$relset[$x]['defaultval'] = $row['asname'];
			}
		}
	}
	
?>        
    var ob = $('#tags').select2({			 
            	tags: true,
				ajax: {
					url: '/data/tags.php',
					dataType: 'json',
					data: function (term, page) {
						return { q: term };
					},
					results: function (data, page) {
						return { results: data };
					}
				}                              
		});
         
    <?php foreach($relset as $row)
	{ ?>
	var ob = $('#rel<?php echo $row['id'];?>').select2({
		placeholder: "Search for Asset",
		minimumInputLength: 3,
		ajax: { 
			url: "/data/assetsearch.php",
			dataType: 'json',
			data: function (term, page) {
				return {
					q: term, // search term
					page_limit: 10					
				};
			},
			results: function (data, page) { 
				return {results: data.results};
			}
		},
		dropdownCssClass: "bigdrop", 
		escapeMarkup: function (m) { return m; } 
	});
            
<?php }; ?>       

<?php if (isset($_REQUEST['name'])) { ?> 
	$('#name').val('<?php echo $_REQUEST['name']; ?>');
    $('#desc').focus();
<?php } else { ?>	
    $('#name').focus();   
<?php }; ?>    
    
<?php SS('onload'); ?>

	<script src="/plugins/optrix/fixedtagger.js"></script>
	<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php
	SS('addscripts');?>
	<link rel="stylesheet" href="/plugins/optrix/fixedtagger.css">
	
	<script>
function ReloadTagValues()
{

}
	</script>
<?php

	ST('section','class=content');
		ST('row');
			ST('half'); ?>
				<form method="POST"><?php
				ST('box','title=Details');
					if ($childid != 0)
					{ ?>
			<input type="submit" value="Create Asset" class="btn btn-success"/><input type="hidden" name="child" value="<?php echo $childid; ?>"/><input type="hidden" name="rel" value="<?php echo $rel; ?>"/><?php
					}
					else
					{?>
			<input type="submit" value="Create Asset" class="btn btn-success"/><?php
					};
					
					SS('footer');
					ST('ftable');?>
				<input type="submit" value="Create <?php echo $atype; ?>" class="btn btn-success"/>
				<?php SS('footer'); ?>
	<tr><td><label>Name</label></td><td><input type="text" value="<?php
	if (isset($_REQUEST['name']))
	{
		echo $_REQUEST['name'];
	}
	?>" id="name" name="name"/>
	<?php
	if ($rel == 3) 
	{
			echo '<input type="hidden" value="" name="desc"/>';
			echo '<input type="hidden" value="" name="tags"/>';
	}
	?></td></tr>
    <?php 
	if ($rel != 3) { ?>
    <tr><td><label>Description</label></td><td><textarea style="width: 90%;" id="desc" name="desc"></textarea></td></tr>
	<tr><td><label>Tags</label></td><td><div class="tagcontrol">						
			<div id="addtag"><select id="newtag" class="display: none;"><option></option><?php
			$filter = "";
			
			$query = $db->query('SELECT name,id FROM assets WHERE type=1 '.$filter.'ORDER BY name');
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				echo '<option value="'.$row['id'].'">'.$row['name'].'</option>';
			};
			?></select><a href="javascript://" onclick="AddTag(); return false;"><i class="fa fa-plus-circle"></i></a></div>
			<input type="hidden" name="tags" id="tags" value=""/>
		</div></td></tr>
    <?php	
		};
	?>
    
	<?php 
	if ($parentid != 0) { 
		if ((!isset($rel)) || ($rel == 0)) {?>
    <tr><td><label>Relationship</label></td><td>	
			
		<select name="relationship">
	<?php	
		$query = $db->query('SELECT id,name,upstreamname,downstreamname FROM relationships WHERE (relationships.style <> 2)');
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			//echo '<optgroup label="'.$row['name'].'">';
			echo '   <option value="'.$row['id'].'"';
			if (isset($_REQUEST['rel']))
			{
				if ($row['id'] == $_REQUEST['rel']) echo ' selected';
			}
			echo '> '.$row['name'].': Is '.$row['upstreamname'].' '.$parentdata['name'].'</option>';
			//echo '   <option value="'.$row['id'].'-DOWN">'.$row['downstreamname'].' '.$parentdata['name'].'</option>';
			//echo '</optgroup>';
		}
		
	?>
		</select>		        
	</td></tr>
	       
    <?php
		ET();
	}
	else
	{
		ET();
	}
	
	if ((isset($rel)) && ($rel != 0)) echo '<input type="hidden" name="relationship" value="'.$rel.'"/>';
			
    ?>
	<input type="hidden" name="origin" value="<?php echo $parentid; ?>"/>    
    <?php if ((isset($rel)) && ($rel != 0) && ($rel != 3)) 
	{ 
		$showimporters = true;
	}; ?>
	<?php 
	}
	else
	{
		ET();
		if ($childid != 0)
		{ ?>
			<!--<br/><br/><input type="submit" value="Create Asset"/><input type="hidden" name="child" value="<?php echo $childid; ?>"/><input type="hidden" name="rel" value="<?php echo $rel; ?>"/>
       <br/>--><p style="width: 80%; margin-left: auto; margin-right: auto;">This new asset will be placed in front of another - all of the <?php echo $relname;?> relationships currently assigned to '<?php echo $childdata['name'];?>' will be transferred to this object.</p> <?php
		}
		else
		{?>
		<!--<br/><br/><input type="submit" value="Create Asset"/>        
		<br/>--><p>Please note that your new asset will be <span style=\"font-style: italic;\">orphaned</span> - it won't be related to anything else.<br/>We suggest creating new assets from a parent asset.</p><?php
	}; }; 
	?>
	</form>	
    <?php
				ET();
			ET();
			ST('half');
				ST('box','title=Importers');
					ST('buttonmenu');?>
						<li><a href="/tools/import/spreadsheet" class="btn btn-default">Import From Spreadsheet</a></li>
						<li><a href="/tools/import/diagram" class="btn btn-default">Import From Diagram</a></li><?php
					ET();
				ET();
			ET();
		ET();
	ET();
?>