<?php
/**
 * Removes a relationship BEFORE this item
 *
 * Note that this is not a user page but is instead used internally and
 * linked to.
 *
 * Parameters:
 *		Origin - The first asset
 * 		NewRelTarget - The second asset
 *		Relatonship - The ID of the relationship, followed by a dash (-) 
 *			and then the direction of the relationship (U = Up, D = Down)
 *
 * Note that this operation is NOT trivial. Where possible, create
 * new relationships in their natural order to avoid excessive
 * rebuilding of the closure table.
 *
 * @author Steven Harding
 */
	
	$origin = 0;
	$destination = 0;
	$relationship = "";
	$editing = 0;
	
	if (isset($_REQUEST['origin']))
	{
		$origin = $_REQUEST['origin'];
	}
	
	if (isset($_REQUEST['editing']))
	{
		$editing = $_REQUEST['editing'];
	}
	
	if (isset($_REQUEST['destination']))
	{
		$destination = $_REQUEST['destination'];
	}
			
	if (isset($_REQUEST['relationship']))
	{
		$relationship = $_REQUEST['relationship'];
	}
	
	require_once($installfolder.'/model/relationship.php');
	
	//echo 'LinkAssets: '.$origin.' / '.$destination.' / '.$relationship;
	$itemid = $destination;
		
	if (!isset($relationships))
	{
		require_once($sitefolder.'/cache/relationships/all.inc');
	}

	if (!isset($asset[$itemid]))
	{		
		require_once($sitefolder.'/cache/relationships/'.$itemid.'.inc');
	}
	
	foreach($asset[$itemid]["relationships"][$relationship] as $rl)
	{
		if ($rl["upstream"] == true) 
		{
			Relationships::Remove($rl['target'], $destination, $relationship);
		}
	}
	
	echo 'Removal Complete?';
	exit;
		
	if (isset($_REQUEST['returnto']))
	{
		if ($_REQUEST['returnto'] == 'diagram')
		{
			//header('Location: '.$siteroot.'/diagram/'.$editing."/".$relationship);
			exit;
		}
	}
		
	header('Location: '.$siteroot.'/relationships/'.$editing);
	
	//echo $origin.' - '.$destination.' - '.$relationship;
	
	/*if ($origin == 0) return;	
	if ($destination == 0) return;	
	if ($relationship == "") return;	
	
	$bits = explode('-',$relationship);
	
	$newitem = $origin;
	$olditem = $destination;
	
	if ($bits[1] == 'U')
	{
		$tm = $destination;
		$destination = $origin;
		$origin = $tm;		
	}
			
	//echo $relationship.' - INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES ('.$origin.','.$destination.','.$bits[0].')';
	
	$relationship = $bits[0];
	
	//OK - add basic relationship entry...
	
	$debug = false;
	
	$qry = 'INSERT IGNORE INTO assetrelationships (parentasset,childasset,relationship) VALUES ('.$origin.','.$destination.','.$relationship.')';	
	if ($debug == true) 
		echo $qry.'<br/>';
	else
		$db->query($qry);
	
	//Get my effective depth by looking at matching relationships of both parent and child...
	$parentdepth = -9999;
	$childdepth = -9999;
	$newdepth = -9999;
	
	if ($debug == true) echo 'Checking For Existing Depth...<br/>';
	
	$query = $db->query("SELECT depth FROM assetrelclosures WHERE parentasset=".$origin." AND childasset=".$destination." AND relationship=".$relationship);
					
	$existingrecord = false;
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$newdepth = $row['depth'];
		$existingrecord = true;
	}	

	if ($newdepth == -9999)
	{	
		$query = $db->query("SELECT MAX(depth) as mx FROM assetrelclosures WHERE (childasset=".$origin.") AND relationship=".$relationship);
				
		echo "SELECT MAX(depth) as mx FROM assetrelclosures WHERE (childasset=".$origin.") AND relationship=".$relationship;
				
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$parentdepth = $row['mx'];
			//echo 'New Parent Depth: '.$parentdepth;		
			//if ($parentdepth == "") $parentdepth = -9999;				
		}	
		
		$query = $db->query("SELECT MIN(depth) as mx FROM assetrelclosures WHERE (parentasset=".$destination.") AND relationship=".$relationship);
				
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$childdepth = $row['mx'];
			//if ($childdepth == "") $childdepth = -9999;
		}	
		
		$newdepth = 0;	
	
		if ($childdepth != -9999)
		{
			//This is already attached to other items below, so I'll need to propagate the parent item to all children.
			$newdepth = $childdepth-1;
		}
		
		if ($parentdepth != -9999)
		{
			//My parent is already connected to other things. This doesn't matter so much unless I'm propagating to children, in which case I'll need to proagate these as well...
			$newdepth = $parentdepth+1;
		}
		
		if (($parentdepth != -9999) && ($parentdepth != -9999))
		{
			//Both of the above are true.
			$newdepth = $parentdepth+1;
			$depthnudge = $newdepth - $childdepth;
		}	
		
		if ($debug == true) echo "New Depth: ".$newdepth." (".$parentdepth.", ".$childdepth.")<br/>";
	}	
	else
	{
		if ($debug == true) echo "Existing Closure Record Found - Depth = ".$newdepth.'<br/>';
	}
	
	$downstreamassets = array();
	$downstreamassets[] = $destination;
	
	if ($childdepth != -9999)
	{
		//Get a list of all children of this object...
		if ($debug == true) echo "Trying to load child objects...<br/>";
		if ($debug == true) echo "SELECT childasset FROM assetrelclosures WHERE (parentasset=".$destination.") AND relationship=".$relationship.'<br/>';
		$query = $db->query("SELECT childasset FROM assetrelclosures WHERE (parentasset=".$destination.") AND relationship=".$relationship.' ORDER BY depth');

		$str = "";		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($str != "") $str .= ",";
			$str .= $row['childasset'];
			$downstreamassets[] = $row['childasset'];
			
			if ($debug == true) echo " ".$row['childasset'];
		}	
		if ($debug == true) echo "<br/>";
		
		//Move
		if (isset($depthnudge))
		{						
			if ($depthnudge > 0)
			{
				if ($str != "")
				{
					$qry = "UPDATE assetrelclosures SET depth = depth + ".$depthnudge." WHERE childasset IN (".$str.") AND relationship=".$relationship.' AND depth>'.$newdepth;
					if ($debug == true) 
						echo $qry."<br/>";
					else
						$db->query($qry);
				}
			}			
		}
	}
	
	if ($existingrecord == false)
	{
		$qry = 'INSERT INTO assetrelclosures (parentasset,childasset,relationship,depth) VALUES ('.$origin.','.$destination.','.$relationship.','.($newdepth).')';
		if ($debug == true) 
			echo $qry.'<br/>';
		else
			$db->query($qry);
	}	
	
	//Copy relationship details from the PARENT into the CHILD and all CHILDREN
	foreach($downstreamassets as $dst)
	{
		$qry = "INSERT IGNORE INTO assetrelclosures (parentasset,childasset,relationship,depth) SELECT parentasset,".$dst.",relationship,depth FROM assetrelclosures WHERE childasset=".$origin." AND relationship=".$relationship;
		if ($debug == true) 
			echo $qry."<br/>";
		else
			$db->query($qry);
	}
		
	
	//$db->query('INSERT INTO assetrelclosures (parentasset,childasset,relationship,depth) VALUES ('.$origin.','.$destination.','.$relationship.','.($maxdepth+1).')');
		
	
	//TODO: Urgent - update closures when this item is added as a parent instead of a child.
	
	require_once($_SERVER['DOCUMENT_ROOT'].'/include/cacheobject.php');
	
	RebuildObjectCacheByID($origin);
	RebuildObjectCacheByID($destination);
	
	if (!isset($editing))
	{
		$editing = $origin;
	}
	
	if ($debug == false) header('Location: /assets/relationships.php?id='.$editing);*/
?>
