<?php

if (!isset($_REQUEST['assetid'])) exit;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');
include($installfolder.'/model/relationship.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' Dashboard';

$properties = array();
	
$properties = $thisasset->GetProperties();
$thisasset->GetValues($properties);

include($installfolder.'/include/tmpl.php');
//include($installfolder.'/include/dynamicdata.php');
?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot; ?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot; ?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Dashboard</a>
			<a href="<?php echo $siteroot; ?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Detail</a>
			<a href="<?php echo $siteroot; ?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar'); ?>

<script src="/plugins/optrix/ardiclient.js"></script>
<?php SS('addscripts'); ?>

var connection = new ARDIHMI();
	
//Subscribe Each Dynamic Property
<?php

	foreach($properties as $prop)
	{
		if ($prop->type == "MEASUREMENT")
		{
			if (isset($prop->value['_dynamics']))
			{
				if (in_array("measurement",$prop->value['_dynamics']))
				{?>
	connection.Subscribe("<?php echo $prop->origin;?>:<?php echo $prop->id;?>:measurement",function (val) {
		<?php if ($prop->value['units'] != "") { ?> 
		val = parseFloat(val).toFixed(<?php echo $prop->value['places'];?>) + "<?php echo $prop->value['units'];?>"; <?php } else { ?>
		val = parseFloat(val).toFixed(<?php echo $prop->value['places'];?>);
		<?php }; ?>
		$('#measurement_<?php echo $prop->origin;?>_<?php echo $prop->id;?>').html(val);
	}); <?php
				};
			};
		};
	};

?>

	
connection.Subscribe("Connected",function (val) {
	/*var ob = document.getElementById("conindicator");
	if (val == "Yes")
	{
		ob.style.fill = "green";
	}
	else
	{
		ob.style.fill = "red";
	}*/
});
	
connection.ConnectTo("<?php echo $_SERVER['HTTP_HOST']; ?><?php echo $siteroot;?>");
	
<?php SS('onload');

T('header-basic','title='.$title);

$supports3d = true;

//Show the description
ST('section','class=content');
	ST('row');
		ST('full');		
			//if ($thisasset->description != "")
			//{
			ST('box','title=Description / Full Name');
?><div class="fullassetname"><?php echo $thisasset->GetFullName();?></div>
	<h4><?php 
	echo $thisasset->description;?></h4>
<?php
			ET();
			//}
			/*else
			{
			ST('box');
				echo '<h4>Properties</h4>';
			ET();			
			};*/
		ET();
	ET();
ET();

//Load all properties (to be given to the appropriate Dashboard module)
ST('section','class=content');
	ST('row');	
		ST('full');
			 ?>		    
    	<?php
	
	
	
	//Get a list of all of the dashboard modules
	
	$arr = scandir($installfolder.'/modules/dashboard');
	//print_r($arr);
	foreach($arr as $itm)
	{
		//echo $itm;
		if ($itm == '.') continue;
		if ($itm == '..') continue;
		if ($itm == "update") continue;
		include($installfolder.'/modules/dashboard/'.$itm);
	}
	
	if ($supports3d == true)
	{ 
		T('dashboard','style=info|symbol=fa fa-video-camera|link='.$siteroot.'/3D-VE/'.$itemid.'|title=3D View|value=');		
	}
	
		T('dashboard','style=info|symbol=fa fa-pencil|link='.$siteroot.'/detail/'.$itemid.'|title=Details|value=');		
		
		ET();	
	ET();
ET();
	
ST('section','class=content');
	ST('row');
		ST('full');
			ST('box');?>
				<h4>Relationships</h4><?php
			ET();
		ET();
	ET();

	ST('row');
	
	//Start a new section for the relationships
	
	ST('full');
	$content = "";

	if (!isset($relationships))
	{
		require_once($sitefolder.'/cache/relationships/all.inc');
	}

	if (!isset($asset[$itemid]))
	{		
		require_once($sitefolder.'/cache/relationships/'.$itemid.'.inc');
	}
	
	$present = array();
	$unique = array();
	$hitcount = array();
	
	foreach($asset[$itemid]["relationships"] as $k => $v)
	{			
		foreach($v as $rl)
		{
			if ($rl["upstream"] == true) 
				$nm = "Is ". $relationships[$k]["upname"];
			else
				$nm = $relationships[$k]["downname"];
				
			if ($nm == "Is Tagged As") continue;
				
			$nm = $nm.'|'.$k.'|'.$rl['upstream'].'|'.$relationships[$k]['name'];
						
			if (!in_array($nm,$present))
			{
				$present[] = $nm; 
				$unique[$nm] = $rl["target"];
			}
			else
			{
				unset($unique[$nm]);
			}
		}
	}
		
	sort($present);
	
	//Create dashboard objects for each relationship here.
	
	$rels = Relationships::GetAllRelationships();
		
	foreach($present as $nm) {
		$bits = explode('|',$nm); 
		if (isset($unique[$nm]))
		{
			$link = $siteroot.'/dashboard/'.$unique[$nm];			
		}
		else
		{
			$link = $siteroot.'/rdashboard/'.$itemid.'/'.$bits[1].'/'.$bits[2];
		}		
		
		$colour = "#FFAAAA";
		foreach($rels as $r)
		{
			if ($bits[2] == $r->id)
			{
				$colour = $r->colour;
			}
		}
		
		$dir = 'up';
		if ($bits[2] != '1')		
		{
			$dir = 'down';
		}
		if (isset($unique[$nm]))
		{
			if (!isset($asset[$unique[$nm]]))
			{		
				require_once($sitefolder.'/cache/relationships/'.$unique[$nm].'.inc');
			}		
			T('dashboard','colour='.$colour.'|style=info|symbol=fa fa-angle-'.$dir.'|link='.$link.'|title='.$bits[0].'|value='.$asset[$unique[$nm]]['name']);
		}
		else
		{
			T('dashboard','colour='.$colour.'|style=info|symbol=fa fa-angle-double-'.$dir.'|link='.$link.'|title='.$bits[0].'|value=Multiple Items');
		}
			
    ?>
<?php	};		
	
	if ($supports3d == true)
	{ 
		T('dashboard','style=info|symbol=fa fa-video-camera|link='.$siteroot.'/detail/'.$itemid.'|title=Show In 3D|value=');		
	}
?>
<?php
			ET();
		ET();
	ET();
	
?>