<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');
include($installfolder.'/model/relationship.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$dta = $thisasset->GetProperties();
$thisasset->GetValues($dta);

if ($editable == false) exit;

$title = $thisasset->name.' Flow Control';

global $installfolder;

function RelSorter($a, $b)
{
	if ($a->name == $b->name) return 0;
	if ($a->name > $b->name) return 1;
	return -1;
}

$rels = Relationships::GetAllRelationships();
usort($rels,"RelSorter");

$query = $db->query("SELECT * FROM properties WHERE typename IN ('ISOPOINT','NRPOINT')");
$isopoint = 0;
$nrpoint = 0;

if ($query !== FALSE)
{
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['typename'] == 'ISOPOINT')
			$isopoint = $row['id'];
		else
			$nrpoint = $row['id'];
	}
}	

$isopointvalue = "";
$nrpointvalue = "";

foreach($dta as $prp)
{
	if ($prp->id == $isopoint)
	{
		$isopointvalue = $prp->value;
	}
	
	if ($prp->id == $nrpoint)
	{
		$nrpointvalue = $prp->value;
	}
}

if ($_SERVER['REQUEST_METHOD'] == 'POST')
{
	//Save Isolation Data...
	$iso = "";
	$nr = "";
	
	print_r($_REQUEST);
	
	foreach($rels as $r)
	{
		if ($r->id < 10) continue;
		if ($r->type == "physical")
		{
			if (isset($_REQUEST['isolate_'.$r->id]))
			{
				if ($_REQUEST['isolate_'.$r->id] == "on")
				{
					if ($iso != '') $iso .= ':';
					$iso .= $r->id;
					//echo 'Bing!';
				}
			}
			if (isset($_REQUEST['nr_'.$r->id]))
			{
				if ($_REQUEST['nr_'.$r->id] == "on")
				{
					if ($nr != '') $nr .= ':';
					$nr .= $r->id;
				}
			}
		}
	}
	
	$db->query("DELETE FROM assetvalues WHERE assetid=".$itemid." AND propertyid=".$isopoint);
	if ($iso != "")
	{
		$oldvalue = "";
		
		$bits = explode('|',$oldvalue);
		$state = "";
		if (count($bits) > 1)
		{
			$state = $bits[1];
		}
		
		$value = $iso.'|'.$state;
		
		$db->query("INSERT INTO assetvalues (assetid,propertyid,value) VALUES (".$itemid.",".$isopoint.",".$db->quote($value).")");
		//echo "INSERT INTO assetvalues (assetid,propertyid,value) VALUES (".$itemid.",".$isopoint.",".$db->quote($value).")";
	}
	
	if ($nr != "")
	{
		$oldvalue = "";
		
		$bits = explode('|',$oldvalue);
		$state = "";
		if (count($bits) > 1)
		{
			$state = $bits[1];
		}
		
		$value = $nr.'|'.$state;
		
		$db->query("INSERT INTO assetvalues (assetid,propertyid,value) VALUES (".$itemid.",".$nrpoint.",".$db->quote($value).")");
		//echo "INSERT INTO assetvalues (assetid,propertyid,value) VALUES (".$itemid.",".$nrpoint.",".$db->quote($value).")";
	}
	
	exit;
}



$isoset = array();
$nrset = array();
	
$query = $db->query("SELECT propertyid,value FROM assetvalues WHERE assetid=".$assetid." AND propertyid IN (".$isopoint.','.$nrpoint.')');
	
if ($query !== FALSE)
{
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['propertyid'] == $isopoint)
			$isovalue = $row['value'];
		else
			$nrvalue = $row['value'];
	}
}	

if (is_array($isopointvalue))
{
	$types = explode(':',$isopointvalue['type']);
	foreach($types as $t)
	{
		$isoset[] = $t;
	}
}

if (is_array($nrpointvalue))
{
	$types = explode(':',$nrpointvalue['type']);
	foreach($types as $t)
	{
		$nrset[] = $t;
	}
}

include('include/tmpl.php');

//$title = 'Asset Detail';

?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  

T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('half');
				echo '<form method="POST">';
				ST('box','title=Isolation');
				
				ST('ftable');
				
	
	foreach($rels as $r)
	{
		if ($r->id < 10) continue;
		if ($r->type == "physical")
		{
			echo '<tr><td><input type="checkbox" name="isolate_'.$r->id.'"';
			if (in_array($r->id,$isoset)) echo ' checked';
			echo '/>&nbsp;&nbsp;'.$r->name.'</td></tr>';
		}
		
	}
					ET();
				ET();	
				
				ST('box','title=Non-Return');?>
					<input type="submit" value="Save All Flow Settings" class="btn btn-success"/>
					<input type="hidden" value="<?php echo $itemid; ?>" name="assetid"/><?php
					SS('footer');
					ST('ftable');
	
	foreach($rels as $r)
	{
		if ($r->id < 10) continue;
		if ($r->type == "physical")
		{
			echo '<tr><td><input type="checkbox" name="nr_'.$r->id.'"';
			if (in_array($r->id,$nrset)) echo ' checked';
			echo '/>&nbsp;&nbsp;'.$r->name.'</td></tr>';
		}
		
	}
					ET();
				ET();	
				
				echo '</form>';
			ET();
			include('detail-navigation.php');
		ET();
	ET(); ?>