<?php

//$editable = true;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

$thisasset = new Asset($itemid);
$thisasset->Load();

$title = $thisasset->name.' Relationships';

global $installfolder;

include('include/tmpl.php');

?>
	var assetlist = new Bloodhound({
	  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
	  queryTokenizer: Bloodhound.tokenizers.whitespace,
	  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
	  //local: $.map(assets, function(state) { return { value: state }; })
	});
	 
	// kicks off the loading/processing of `local` and `prefetch`
	assetlist.initialize();
	
	$('#lookitup').typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">No Matching Asset Found</div>'
            ].join('\n'),
			suggestion: function(data){
				return '<p class="searchresult">' + data.text + '<span>' + data.path + '</span></p>';
			}            
        }        
    });
	
	$('#lookitup').on('typeahead:selected',function (evt,item) {    	
        $('#looktarg').val(item.id);
    });<?php
            
    SS('onload');  ?>
	<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php SS('addscripts');

?>
	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/2"><i class="fa fa-circle-o"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle"></i> Detail</a>
			<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Charts</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar');  

T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
		 
			ST('half');
			if ($editable == true) {
				ST('boxform','title=Add New Relationships|action='.$siteroot.'/asset/link');?>
				<input type="hidden" value="<?php echo $itemid; ?>" name="origin"/>
				<input type="submit" value="Add New Relationship" class="btn btn-success"/>
				&nbsp;&nbsp;<a class="btn btn-default" href="<?php echo $siteroot;?>/asset/links?id=<?php echo $itemid;?>">Add Many</a><?php
					SS('footer');
					ST('ftable');?>
				<tr><td><label>Select An Asset</label></td><td><input type="text" name="lookvalue" id="lookitup" style="border: 1px solid black; border-radius: 3px; padding: 3px; position: relative; left: -3px;"/><input type="hidden" name="newreltarget" id="looktarg"/></td></tr>
				<tr><td><label>And A Relationship</label></td><td><select name="relationship"><?php
				$query = $db->query('SELECT id,name,upstreamname,downstreamname FROM relationships WHERE (style != 2) ORDER BY style DESC, name ASC');
				while($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					echo '<optgroup label="'.$row['name'].'">';
					echo '   <option value="'.$row['id'].'-D">Is '.$row['upstreamname'].' This Asset ( '.$row['name'].' )</option>';
					echo '   <option value="'.$row['id'].'-U">'.$row['downstreamname'].' This Asset ( '.$row['name'].' )</option>';
					echo '</optgroup>';
				}
				?></select></td></tr>
<?php				ET();
				ET();
			}
				ST('box','title=Relationships');
				
	$directrels = array();
	
	include($sitefolder.'/cache/relationships/all.inc');
	
	$query = $db->query('SELECT DISTINCT parentasset,assets.name as assetname, upstreamname, relationships.name as relname, type FROM assetrelationships JOIN relationships ON (relationship = relationships.id) JOIN assets ON (parentasset = assets.id) WHERE assetrelationships.childasset = '.$itemid);
	
	//echo 'SELECT DISTINCT parentasset,assets.name as assetname, upstreamname, relationships.name as relname, type FROM assetrelationships JOIN relationships ON (relationship = relationships.id) JOIN assets ON (parentasset = assets.id) WHERE assetrelationships.childasset = '.$itemid.' AND (relationships.style <> 3)';

	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if (!isset($directrels[$row['relname']][$row['upstreamname']])) $directrels[$row['relname']][$row['upstreamname']] = array();
		
		$directrels[$row['relname']][$row['upstreamname']][] = $row['parentasset'].'|'.$row['assetname'];		
	}	
	
	$query = $db->query('SELECT DISTINCT childasset,assets.name as assetname, downstreamname, relationships.name as relname, type FROM assetrelationships JOIN relationships ON (relationship = relationships.id) JOIN assets ON (childasset = assets.id) WHERE assetrelationships.parentasset = '.$itemid.' AND (relationships.style <> 2)');

	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if (!isset($directrels[$row['relname']][$row['downstreamname']])) $directrels[$row['relname']][$row['downstreamname']] = array();
		
		$directrels[$row['relname']][$row['downstreamname']][] = $row['childasset'].'|'.$row['assetname'];
	}	
	
	//print_r($directrels);
	
	$first = true;
	foreach($directrels as $relname=>$detail)
	{
		if ($first == true)			
			$first = false;			
		else						
			echo '<hr/>';
		echo '<p><label>'.$relname.'</label>';

		$relid = "";
		foreach($relationships as $k => $v)
		{
			if ($v['name'] == $relname)
			{
				$relid = $k;
			}
		}
		
		echo '<br/>';
		foreach($detail as $linkname => $linkdetail)
		{			
			echo $linkname.' ';
			$x = 1;
									
			foreach($linkdetail as $vd)
			{
				$bits = explode('|',$vd);
				if ($x > 1)
				{
					if ($x == count($linkdetail))
					{
						echo ' and ';
					}
					else
					{
						echo ', ';
					}
				}
				
				//echo 'Type :'.$relationships[$relid]['type'];
				if (isset($relationships[$relid]['type']))
				{
					if ($relationships[$relid]['type'] == 'logical')
					{
						echo '<a href="/functions/findroute.php?from='.$itemid.'&to='.$bits[0].'"><img src="/img/trace.png" style="position: relative; top: 1px;"/></a>';
					}
				}
				
				echo '<a href="view.php?id='.$bits[0].'">'.$bits[1].'</a>';
				if ($editable == true) echo '<a href="'.$siteroot.'/asset/unlink?asset='.$itemid.'&other='.$bits[0].'&rel='.$relid.'"><i class="fa fa-minus-circle" style="margin-left: 0.4em;"></i></a>';
				$x++;
			}		
			echo '<br/>';	
		}
		echo '</p>';
				
		
	}
				ET();	
			ET();
			include('detail-navigation.php');
		ET();
	ET(); ?>