<?php

if (!isset($_REQUEST['assetid'])) exit;

$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
if ($itemid === FALSE) exit;

include($installfolder.'/model/asset.php');

global $siteroot;

$thisasset = new Asset($itemid);
$thisasset->Load();

//Get the relationship ID

	$rel = -1;
	if (isset($_REQUEST['rel']))
	{
		$rel = $_REQUEST['rel'];
	}
	//if ($rel == -1) $rel = $defaulttree;
	
	//TODO: Tags need to default to 3, not to 2.
	
	if ($rel == 3) $taglist = "";
	
	$envid = 0;
	

$title = $thisasset->name.' Diagram';

include($installfolder.'/include/tmpl.php');
include($installfolder.'/include/dynamicdata.php');

?>
<link rel="stylesheet" href="<?php echo $themefolder; ?>/css/diagram.css">
<?php SS('head'); ?>
<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php SS('addscripts'); ?>

$('#controls').fadeIn(500);
$('#controls').offset($('#selected').offset());


$( window ).resize(function() {
  $('#controls').offset($('#selected').offset());
});

var assetlist = new Bloodhound({
  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
  queryTokenizer: Bloodhound.tokenizers.whitespace,
  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
  //local: $.map(assets, function(state) { return { value: state }; })
});
 
// kicks off the loading/processing of `local` and `prefetch`
assetlist.initialize();

$("#lookitup").typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">Not Found - ',
              '<a href="#" onclick="CreateAsset($(\'#lookitup\').val()); return false;">Add This Asset</a>',
              '</div>'
            ].join('\n'),
			suggestion: function(data){
				return '<p class="searchresult">' + data.text + '<span>' + data.path + '</span></p>';
			}            
        }        
    });
    
    var nm = $('#lookitup').attr('name');    
    
    $("#lookitup").on('typeahead:selected',function (evt,item) {    	
        $('#' + nm + "id").val(item.id);
        SelectedAsset();
    });
    
    $("#lookitup").after('<input type="hidden" name="' + nm + 'id" id="' + nm+ 'id"/>');

<?php SS('onload'); ?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Current Asset</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
			<a href="<?php echo $siteroot;?>/diagram/<?php echo $itemid;?>/<?php echo $rel;?>"><i class="fa fa-circle"></i> Diagram</a>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Dashboard</a>
			<a href="<?php echo $siteroot;?>/detail/<?php echo $itemid;?>"><i class="fa fa-circle-o"></i> Detail</a>
		</li>
	  </ul>
    </li>

<?php SS('sidebar'); ?>

<script>

var insertmode = false;

function CreateIt(ob)
{
	insertmode = false;
	$('#addfunction').html("Add");
	var of = $(ob).offset();
	of.left += 10;
	of.top += 10;
	$('#bgdiv').offset(of);
	$('#bgdiv').fadeIn(500);
	$('#bgdiv').offset(of);
	
	$("#lookitup").focus();
}

function InsertIt(ob)
{
	insertmode = true;
	$('#addfunction').html("Insert");
	var of = $(ob).offset();
	of.left += 10;
	of.top += 10;
	$('#bgdiv').offset(of);
	$('#bgdiv').fadeIn(500);
	$('#bgdiv').offset(of);
	
	$("#lookitup").focus();
}

function SendCut()
{
	$.post("<?php echo $siteroot;?>/asset/cut.php",{'destination': <?php echo $itemid; ?>, 'relationship': <?php echo $rel; ?>},function (data) {
		alert(data)
		//location.reload();
	});
}

function CutWarning(ob)
{
	$('#confirmcontent').html();	
	var of = $(ob).offset();
	of.left += 10;
	of.top += 10;
	$('#confirm').offset(of);
	$('#confirm').fadeIn(500);
	$('#confirm').offset(of);
}

</script>

<?php
T('header-basic','title='.$title);

$supports3d = true;

ST('section','class=content');
	ST('row');
		ST('full');
			ST('box','title=Relationships');
			echo $thisasset->GetFullName(); ?>	
    
	<hr/>
	<ul class="diagramtypes"> 
<?php

	$query = $db->query('SELECT COUNT(*) as cnt FROM assetrelclosures WHERE parentasset='.$itemid);
	
	$justonerow = false;
	global $justonerow;
	
	$childcount = 0;
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$childcount = $row['cnt'];
	}
			
	$rootasset = false;
	if ($childcount > 40)
	{
		if (!isset($_REQUEST['showall']))
		{
			$justonerow = true;
			//echo 'Only One Row Please!';
		}
	}
	else
	{
		$query = $db->query('SELECT rootasset FROM relationships WHERE id='.$rel);
			
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{			
			if (($row['rootasset'] == $itemid) && (!isset($_REQUEST['showall']))) 
			{
				$justonerow = true;
				$rootasset = true;
			}
		}
	}

	//$query = $db->query('SELECT DISTINCT relationships.name, relationships.id FROM relationships JOIN assetrelationships ON (assetrelationships.relationship = relationships.id) WHERE( parentasset='.$itemid.' OR childasset='.$itemid.') AND relationships.style <> 2 ORDER BY relationships.name');	
	
	
	$shownids = array();
	
	if ($rootasset == true)
	{
		$query = $db->query('SELECT DISTINCT name, id, rootasset FROM relationships WHERE style = 2 OR style = 3 ORDER BY name');	
		
		$default = -1;
		while($row = $query->fetch(PDO::FETCH_ASSOC))
		{
			$style= 'default';
			if ($default == -1) $default = $row['id'];
			
			echo '<li style="display: inline; margin-right: 20px;';
			if ($rel == $row['id']) 
			{
				$default = $rel;
				$style='success';
			}
			echo '"><a href="'.$siteroot.'/diagram/'.$row['rootasset'].'/'.$row['id'].'" class="btn btn-'.$style.'">'.$row['name'].'</a></li>';
			$shownids[] = $row['id'];
					
		}
		if ($rel == -1) $rel = $default;
		//$rel = $default;
	}
	else
	{
	
		$query = $db->query('SELECT DISTINCT relationships.name, relationships.id FROM relationships JOIN assetrelationships ON (assetrelationships.relationship = relationships.id) WHERE( parentasset='.$itemid.' OR childasset='.$itemid.') ORDER BY relationships.name');	
		
		$rels = array();
		
		$default = -1;
		while($row = $query->fetch(PDO::FETCH_ASSOC))
		{
			$rels[] = $row;
			$style = "default";
			if ($default == -1) $default = $row['id'];
		}
		if ($rel == -1) $rel = $default;
		
		foreach($rels as $row)
		{	
			echo '<li style="display: inline; margin-right: 20px;';
			$style = "default";
			if ($rel == $row['id']) 
			{
				$default = $rel;
				$style = "success";
				//echo 'font-weight: bold;';
			}			
			echo '"><a href="'.$siteroot.'/diagram/'.$itemid.'/'.$row['id'].'" class="btn btn-'.$style.'">'.$row['name'].'</a></li>';
			$shownids[] = $row['id'];		
		}
		
	}
	
	
	if ($default != $rel)
	{ 
		include($sitefolder.'/cache/relationships/all.inc');?>
		<li style="display: inline; margin-right: 20px; font-weight: bold;"><div class="btn btn-success"><?php echo $relationships[$rel]['name'];?></div></li><?php
	}
	?>
    	<li style="display: inline; margin-right: 20px;"><a href="#" onclick="$('#otherrelations').fadeToggle(250); return false;" class="btn btn-default" >Show All</a></li>
    </ul>
    <div style="display: none; position: relative; top: -2em;" id="otherrelations">
    	<select name="otherrel" id="otherrel" onchange="ChangeRelationship($('#otherrel').val());">
        	<option value="">&lt; Select One &gt;</option>
<?php
			$innie = "";
			foreach($shownids as $shown)
			{
				if ($innie != "") $innie .= ',';
			}
			
			if ($innie != "")
			{
				$qry = 'SELECT name,id FROM relationships WHERE id NOT IN ('.$innie.') ORDER BY name';	
			}
			else
			{
				$qry = 'SELECT name,id FROM relationships ORDER BY name';	
			}
			
			//echo $qry;
			$query = $db->query($qry);	
		
			while($row = $query->fetch(PDO::FETCH_ASSOC))
			{
				echo '  <option value="'.$row['id'].'">'.$row['name'].'</option>';
			}
?>            
        </select>
    </div>		
	
<?php	
			ET(); 
		ET();
		ST('full');
			ST('box'); 
			
    require_once($sitefolder.'/cache/relationships/all.inc');
	global $relationships;
			
	$points = array();
	$indexset = array();
	
	$asset = array();
	global $asset;
	global $rel;
	
	$columns = array();
	global $columns;
		
	$x = 0;
	$y = 0;
	global $x;
	global $y;
		
//<?xml version=\"1.0\" encoding=\"utf-8\" \n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">\r\n		

	$svg = "<svg class=\"diagram\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t width=\"800px\" height=\"400px\" viewBox=\"0 0 800 400\" enable-background=\"new 0 0 800 400\" xml:space=\"preserve\">";
	
	global $svg;
			
	$itm = array();
	$itm['id'] = $itemid;
	$itm['from'] = array();
	$itm['offset'] = 0;
	$columns[0][] = $itm;
			
	if (!isset($asset[$itemid]))
	{		
		require_once($sitefolder.'/cache/relationships/'.$itemid.'.inc');
	}
			
	echo '<!-- Loading Points! -->';
	LoadPoints($itemid,false,0,$itemid);
	LoadPoints($itemid,true,0,$itemid);	
	
	echo '<!--';
	print_r($points);
	echo '-->';
	
	//Get lowest depth...
	$lowest = 0;
	$highest = 0;
	foreach(array_keys($columns) as $k)
	{
		if ($k < $lowest) $lowest = $k;
		if ($k > $highest) $highest = $k;
	}	
	
	//echo 'Diagram Ranges From '.$lowest.' to '.$highest;
	$mult = 120;	
	global $mult;
	
	//OK - Calculate heights for child sequences...
	if (isset($columns[1]))
	{
		for($x=0;$x<count($columns[1]);$x++)
		{
			//GetChildHeight(1,$x);
			GetChildDimensions(1,$x);
		}
	}
	
	if (isset($columns[-1]))
	{
		for($x=0;$x<count($columns[-1]);$x++)
		{
			//GetChildHeight(-1,$x);
			GetChildDimensions(-1,$x);
		}
	}
	
	echo '<!-- ';
	//print_r($columns);
	echo '-->';
	
	function GetChildHeight($col,$indx)
	{
		global $columns;
		
		if (isset($columns[$col][$indx]['height'])) return $columns[$col][$indx]['height'];
		
		$id = $columns[$col][$indx]['id'];
		
		$nxt = $col + 1;
		if ($col < 0) $nxt = $col-1;
		
		if (isset($columns[$nxt]))
		{
			$ttl = 0;
			for($x=0;$x<count($columns[$nxt]);$x++)
			{
				$hits = 0;
				foreach($columns[$nxt][$x]['from'] as $fid)
				{
					if ($fid == $id)
					{
						$v = GetChildHeight($nxt,$x);
						$ttl += $v;
						$hits++;
						//break;
					}
				}
				if ($hits > 1) $ttl = ($ttl / $hits) -1;
				
			}
			if ($ttl == 0) $ttl = 1;
			$columns[$col][$indx]['height'] = $ttl;
			return $ttl;
		}
		else
		{
			$columns[$col][$indx]['height'] = 1;
			return 1;
		}
	}
	
	function GetChildDimensions($col,$indx)
	{
		global $columns;
		
		if (isset($columns[$col][$indx]['height']))
		{
			$bs = array();
			$bs['height'] = $columns[$col][$indx]['height'];
			$bs['depth'] = $columns[$col][$indx]['depth']+1;
			return $bs;
		}
		
		$id = $columns[$col][$indx]['id'];
		
		$nxt = $col + 1;
		if ($col < 0) $nxt = $col-1;
		
		if (isset($columns[$nxt]))
		{
			$ttl = 0;
			$md = 0;
			for($x=0;$x<count($columns[$nxt]);$x++)
			{
				$hits = 0;
				foreach($columns[$nxt][$x]['from'] as $fid)
				{
					if ($fid == $id)
					{
						$v = GetChildDimensions($nxt,$x);
						$ttl += $v['height'];
						if ($v['depth'] > $md) $md = $v['depth'];	
						$hits++;					
					}
				}
				if ($hits > 1) $ttl = ($ttl / $hits) -1;
				
			}
			
			//if ($col == 1) echo '<!-- Total Height = '.$ttl.'-->';
			
			if ($ttl == 0) $ttl = 1;
			
			$columns[$col][$indx]['height'] = $ttl;
			$columns[$col][$indx]['depth'] = $md+1;
			
			$bs = array();
			$bs['height'] = $ttl;
			$bs['depth'] = $md+1;
			return $bs;
		}
		else
		{
			$columns[$col][$indx]['height'] = 1;
			$columns[$col][$indx]['depth'] = 0;
			
			$bs = array();
			$bs['height'] = 1;
			$bs['depth'] = 0;
			return $bs;
		}
	}
	
	
	CalculateOffset($itemid);			
	//FillGaps();
			
	function CalculateOffset($itemid)
	{
		global $columns;
		if (isset($columns[1])) CalculateOffsets(1,$itemid,0);
		if (isset($columns[-1])) CalculateOffsets(-1,$itemid,0);
	}
	
	function CalculateOffsets($col,$itemid,$carryover)
	{
		global $columns;
		global $asset;
		
		$next = $col + 1;
		if ($col < 0) $next = $col-1;
		
		$sofar = $carryover;
		
		echo "\r\n";		
		
		for($x=0;$x<count($columns[$col]);$x++)
		{
			if (isset($columns[$col][$x]['offset'])) continue;
			$hits = false;
			foreach($columns[$col][$x]['from'] as $fid)
			{				
				if ($fid == $itemid)
				{
					$hits = true;
					for($vq=0;$vq<$col;$vq++)
					{
						echo "   ";
					}
					
					//echo '<!-- Item '.$x.' ( '.$columns[$col][$x]['id'].' / '.$asset[$columns[$col][$x]['id']]['name'].' ) on col '.$col.' - ';
					//echo $sofar;
					//echo  ' -->'."\r\n";
					
					if (isset($columns[$next])) 
					{						
						/*for($vq=0;$vq<$col;$vq++)
						{
							echo "   ";
						}
						echo "<!-- Followed ".$asset[$itemid]['name'].' to '.$asset[$columns[$col][$x]['id']]['name'].' -->'."\r\n";*/
						CalculateOffsets($next,$columns[$col][$x]['id'],$sofar);					
					}
					$columns[$col][$x]['offset'] = $sofar;					
					
				}							
				//if ($columns[$col][$x]['height'] > $mxh) $mxh = $columns[$col][$x]['height'];
			}			
			
			if ($hits == true)
			{
				echo "\r\n";
				for($vq=0;$vq<$col;$vq++)
				{
					echo "   ";
				}
				/*echo '<!-- Adding '.$columns[$col][$x]['height'].' ( The Height Of '.$asset[$columns[$col][$x]['id']]['name'].' to '.$col.' ) -->'."\r\n";			*/
				$sofar += ($columns[$col][$x]['height']);
			}		
		}				
	}
	
	//Final task - find the middle to position the root node.
	$maxheight = 0;
	if (isset($columns[1]))
	{
		foreach($columns[1] as $c)
		{
			$m = $c['offset'] + $c['height'];
			if ($m > $maxheight) $maxheight = $m;
		}
	}
	if (isset($columns[-1]))
	{
		foreach($columns[-1] as $c)
		{
			$m = $c['offset'] + $c['height'];
			if ($m > $maxheight) $maxheight = $m;
		}
	}
	
	function FillGaps()
	{
		//Do some basic filling based on depth and height values...
		global $columns;
		
		/*echo '<!-- ';
		print_r($columns);
		echo '-->';	*/
		foreach(array_keys($columns) as $col)
		{
			if ($col > 0) FillGapColumn($col);
		}		
	}
	
	function FillGapColumn($colno)
	{
		global $columns;
		global $itemid;
		$lastoffset = 0;
		for($x=0;$x<count($columns[$colno]);$x++)
		{
			$offset = $columns[$colno][$x]['offset'];
			$gap = $offset - $lastoffset;
			$lastoffset = $columns[$colno][$x]['offset'];
			if ($gap > 1)
			{
				//echo '<!-- Gap ( '.$gap.' ) Detected in Column '.$colno.' at '.$colno.'-->';
				for($q=$x;$q < count($columns[$colno]);$q++)
				{
					if ($columns[$colno][$q]['depth'] <= 1)
					{
						//echo '<!-- Item '.$q.' Has A Zero Depth -->';
						
						//OK - is this connected to something that already has a high offset?
						
						foreach($columns[$colno][$q]['from'] as $fid)
						{
							if ($fid != $itemid)
							{
								$doit = true;
								$f = $fid;//$columns[$colno][$q]['from'];
								for($v=0;$v<count($columns[$colno-1]);$v++)
								{
									if ($columns[$colno-1][$v]['id'] == $f)
									{
										if ($columns[$colno-1][$v]['offset'] >= $columns[$colno][$q]['offset'])
										{
											$doit = false;
											break;
										}
									}
								}
								
								if ($doit == false) continue;
							}
						}
						
						//Bring this item down to fill the gap...
						$columns[$colno][$q]['offset'] -= ($gap-1);
						$lastoffset = $columns[$colno][$q]['offset'];
						break;
					}
				}
			}
		}
	}
	
	function LineTo($x1,$y1,$x2,$y2)
	{
		global $svg;
		global $mult;
		if ($y1 == $y2)
		{
			$svg .= '<line x1="'.$x1.'" y1="'.$y1.'" x2="'.$x2.'" y2="'.$y2.'" stroke="black"/>';				
		}
		else
		{
			//$svg .= '<line x1="'.$x1.'" y1="'.$y1.'" x2="'.$x2.'" y2="'.$y2.'" stroke="red"/>';				
			$half = ($x1 + ($mult / 2));
			$points = $x1.','.$y1.' '.$half.','.$y1.' '.$half.','.$y2.' '.$x2.','.$y2;
			$svg .= '<polyline points="'.$points.'" stroke="black" fill="none"/>';				
		}
		global $svg;
	}
	
	//Draw a full set of lines...
	for($vx=$lowest;$vx<$highest;$vx++)
	{
		$x = $vx - $lowest;
		$y = 0;
		
		//echo 'Drawing Lines @ '.$vx;
						
		foreach($columns[$vx] as $itm)
		{		
			$nxt = $vx+1;			
			
			$x1 = $vx - $lowest;
			$x2 = $vx - ($lowest-1);
			
			/*if ($vx == 0)			
				$y1 = ($maxheight-1) / 2;
			else*/
				$y1 = $itm['offset'];
				
			if ($vx+1 == 0)
			{
				$y2 = $columns[0][0]['offset'];//($maxheight-1) / 2;
				
				LineTo((($x1+0.5) * $mult),(($y1+0.25) * $mult),(($x2+0.5) * $mult),(($y2+0.25) * $mult));
			}
			else
			{
				foreach($columns[$vx+1] as $c)
				{
					$pass = false;
					if ($vx >= 0)
					{ 
						foreach($c['from'] as $fid)
						{
							if ($fid == $itm['id']) $pass = true;
						}
					}
					if ($vx < 0) 
					{
						foreach($itm['from'] as $fid)
						{
							if ($fid == $c['id']) $pass = true;
						}
					}

					if ($pass == true)
					{
						$y2 = $c['offset'];
						LineTo((($x1+0.5) * $mult),(($y1+0.25) * $mult),(($x2+0.5) * $mult),(($y2+0.25) * $mult));
					}
				}
			}
			//$svg .= '<line x1="" y1="" x2="" y2="" stroke="black"/>';
		}
	}
	
function SVGMarkup($sv,$fill,$linewidth)
{
	$sv = str_replace('fill="white"','fill="'.$fill.'"',$sv);
	$sv = str_replace('fill="#FFFFFF"','fill="'.$fill.'"',$sv);
	$sv = str_replace('stroke-width="1"','stroke-width="'.$linewidth.'"',$sv);
	
	return $sv;
}

	//Build a query to get some detail about resource models...
	$inst = "";
	for($vx=$lowest;$vx<=$highest;$vx++)
	{
		foreach($columns[$vx] as $itm)
		{
			if ($inst != "") $inst .= ',';
			$inst .= $itm['id'];
		}
	}
	
	/*$query = $db->query("SELECT assetproperties.assetid, svgfile FROM assetproperties JOIN properties ON (properties.id = propertyid) JOIN assetvalues ON (assetvalues.propertyid = assetproperties.propertyid AND assetvalues.assetid=assetproperties.assetid) JOIN models ON (models.id = assetvalues.value) WHERE assetproperties.assetid IN (".$inst.") AND (properties.typename = 'MODEL') AND svgfile <> ''");*/
	
	$query = $db->query("SELECT assetvalues.assetid, svgfile FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) JOIN models ON (assetvalues.value = models.id) WHERE assetvalues.assetid IN (".$inst.") AND (properties.typename = 'MODEL')");
		
	//echo "SELECT assetvalues.assetid, svgfile FROM assetvalues JOIN properties ON (properties.id = assetvalues.propertyid) JOIN models ON (models.id = assetvalues.value) WHERE assetvalues.assetid IN (".$inst.") AND (properties.typename = 'MODEL')";
					
	$hasmodel = false;
	$svgfiles = array();
	
	$dta = $thisasset->GetProperties();
	$thisasset->GetValues($dta);
	
	foreach($dta as $p)
	{
		if ($p->type == "MODEL")
		{
			if ($p->value['model'] != "")
			{
				$hasmodel = true;
			}
		}
	}
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['svgfile'] != "")
		{
			for($vx=$lowest;$vx<=$highest;$vx++)
			{
				$found = false;
				//foreach($columns[$vx] as $itm)
				for($vy=0;$vy < count($columns[$vx]);$vy++)
				{					
					//print_r($columns[$vx][$vy]);
					if ($columns[$vx][$vy]['id'] == $row['assetid'])
					{
						$columns[$vx][$vy]['svgfile'] = $row['svgfile'];
						//echo 'Setting SVG File for Item '.$itm['id'].'!';
						$found = true;
						break;
					}
				}
				if ($found == true) break;
			}
		}
	}
	
	echo '<!-- Drawing Resources! -->';
	
	//Draw Resources Above Lines
	for($vx=$lowest;$vx<=$highest;$vx++)
	{
		$x = $vx - $lowest;
		$y = 0;
						
		foreach($columns[$vx] as $itm)
		{						
			if (!isset($itm['offset']))			
				$y = ($maxheight-1) / 2;
			else
				$y = $itm['offset'];			
			$fill = "white";								
			
			$adder = "";
			$id = $itm['id'];
									
			if (!isset($asset[$id]))
			{
				require_once($sitefolder.'/cache/relationships/'.$id.'.inc');
			}
			
			if (!isset($asset[$id])) continue;
			
			$points[] = $asset[$id]['name'];
			global $points;
		
			$ymod = 0;
			foreach($asset[$id]["values"] as $k => $v)
			{			
				if ($v['type'] == "MEASUREMENT") 
				{
					$fill = "green";
					$hasproperties = true;
					//echo '<h4>'.$v['name'].'</h4>';
				}
				if ($v['type'] == "STATUS") 
				{
					$fill = "green";					
					//echo '<h4>'.$v['name'].'</h4>';
				}
				if ($v['type'] == "ISOPOINT") 
				{
					$fill = "yellow";
					//echo '<h4>'.$v['name'].'</h4>';
				}				
			}						
			
			//$nm = PrettyUp($asset[$id]['name'],true);
			$nm = $asset[$id]['name'];
			if (($vx == 0) || ($rel == 2)) $nm = $asset[$id]['name'];
			
			$swidth = 1;			
			$link = $siteroot.'/diagram/'.$id.'/'.$rel;
			
			$sel = "";
			if ($vx == 0)
			{
				$swidth = 3;
				$link = '/assets/ddashboard.php?id='.$id;	
				
				$tx = (((($x + 0.5) * $mult))+38);
				
				$svg .= '<line x1="'.((($x+0.5) * $mult)).'" y1="'.((($y+0.25) * $mult)).'" x2="'.$tx.'" y2="'.((($y+0.25) * $mult)).'" stroke="black" stroke-width="1"/>';							
				
				$sel = "selected";
			}
			
			$svg .= '<a xlink:href="'.$link.'">';
																
			if (isset($itm['svgfile']))
			{
				ob_start();
				include($_SERVER['DOCUMENT_ROOT'].$itm['svgfile']);
				//$svg .= '<!-- Including SVG Here! -->';
				$svgx = ob_get_clean();
				
				//$svg .= '<!-- '.$svgx.' -->';
				
				$ps = strpos($svgx,"<svg");
				$ps2 = strpos($svgx,">",$ps+4);
				$svgx = substr($svgx,$ps2+1);
				$ps = strpos($svgx,"</svg>");
				$svgx = substr($svgx,0,$ps);
				
				$svgx = SVGMarkup($svgx,$fill,$swidth);
				
				$svg .= '<g transform="translate('.((($x+0.5) * $mult) - 28).','.((($y+0.25) * $mult)-28).')"';
				if ($sel != "") $svg .= ' id="'.$sel.'"';
				$svg .= '>'.$svgx.'</g>';
			}
			else
			{
				$svg .= '<circle cx="'.(($x+0.5) * $mult).'" cy="'.(($y+0.25) * $mult).'" r="28" stroke="black" stroke-width="'.$swidth.'" fill="'.$fill.'"';
				if ($sel != "") $svg .=' id="'.$sel.'"';
				$svg .= '/>';
			}
			
			$svg .= '</a>';
			
			if ($vx == 0)
			{
				$edt = "";
				//Add Edit Controls...
				if (CheckCreatePermission($itemid))
				{																									
													
					$tx += 10;		
					
					/*$edt .= '    	<rect x="'.($tx-1).'" y="'.(((($y+0.25) * $mult)) - 15).'" rx="5" ry="5" width="24" height="60" fill="#999999" opacity="0.5"/>';												
					
					$edt .= '	<g id="addbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) - 10).')" opacity="0" visible="hidden">';
					$edt .= '     <a xlink:href="create.php?parent='.$itemid.'&rel='.$rel.'">';																																							
					$edt .= '    	<rect x="0" y="0" rx="5" ry="5" width="105" height="20" fill="#999999"/>';												
					$edt .= '    	<text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">ADD NEW</text>';																		
					$edt .= '     </a>';
					$edt .= '	</g>';
					$edt .= '	<image id="addbutton" xlink:href="/images/capbutton-add.png" x="'.($tx).'" y="'.(((($y+0.25) * $mult)) - 10).'" height="20px" width="20px"/>';						

					$edt .= '	<g id="addextbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) + 15).')" opacity="0" visible="hidden">';
					$edt .= '     <a xlink:href="connect.php?parent='.$itemid.'&rel='.$rel.'">';																																							
					$edt .= '    	<rect x="0" y="0" rx="5" ry="5" width="135" height="20" fill="#999999"/>';												
					$edt .= '    	<text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">ADD EXISTING</text>';																		
					$edt .= '     </a>';
					$edt .= '	</g>';
					$edt .= '	<image id="addextbutton" xlink:href="/images/capbutton-link.png" x="'.($tx).'" y="'.(((($y+0.25) * $mult)) + 15).'" height="20px" width="20px"/>';	*/	
																												
					if ($lowest != $vx)
					{				
						$tx = (((($x + 0.5) * $mult))-68);								
												
						/*$edt .= '<g id="insbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) - 10).')" opacity="0" visible="hidden">';						
						$edt .= '  <a xlink:href="create.php?child='.$itemid.'&rel='.$rel.'">';							
						$edt .= '    <rect x="0" y="0" rx="5" ry="5" width="85" height="20" fill="#999999"/>';												
						$edt .= '    <text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">INSERT</text>';																		
						$edt .= '  </a>';
						$edt .= '</g>';
						$edt .= '<image id="insbutton" xlink:href="/images/capbutton-insert.png" x="'.$tx.'" y="'.(((($y+0.25) * $mult)) - 10).'" height="20px" width="20px"/>';	*/
						
						/*$edt .= '    	<rect x="'.($tx-1).'" y="'.(((($y+0.25) * $mult)) - 15).'" rx="5" ry="5" width="24" height="85" fill="#999999" opacity="0.5"/>';												
					
						$edt .= '	<g id="insbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) - 10).')" opacity="0" visible="hidden">';
						$edt .= '     <a xlink:href="create.php?parent='.$itemid.'&rel='.$rel.'">';																																							
						$edt .= '    	<rect x="0" y="0" rx="5" ry="5" width="135" height="20" fill="#999999"/>';												
						$edt .= '    	<text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">INSERT NEW</text>';																		
						$edt .= '     </a>';
						$edt .= '	</g>';
						$edt .= '	<image id="insbutton" xlink:href="/images/capbutton-insert.png" x="'.($tx).'" y="'.(((($y+0.25) * $mult)) - 10).'" height="20px" width="20px"/>';						
	
						$edt .= '	<g id="insextbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) + 15).')" opacity="0" visible="hidden">';
						$edt .= '     <a xlink:href="connect.php?parent='.$itemid.'&rel='.$rel.'">';																																							
						$edt .= '    	<rect x="0" y="0" rx="5" ry="5" width="155" height="20" fill="#999999"/>';												
						$edt .= '    	<text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">INSERT EXISTING</text>';																		
						$edt .= '     </a>';
						$edt .= '	</g>';
						$edt .= '	<image id="insextbutton" xlink:href="/images/capbutton-insertlink.png" x="'.($tx).'" y="'.(((($y+0.25) * $mult)) + 15).'" height="20px" width="20px"/>';	
	
						$edt .= '	<g id="delbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) + 40).')" opacity="0" visible="hidden">';
						$edt .= '     <a xlink:href="connect.php?parent='.$itemid.'&rel='.$rel.'">';																																							
						$edt .= '    	<rect x="0" y="0" rx="5" ry="5" width="65" height="20" fill="#999999"/>';												
						$edt .= '    	<text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">CUT</text>';																		
						$edt .= '     </a>';
						$edt .= '	</g>';
						$edt .= '	<image id="delbutton" xlink:href="/images/capbutton-delete.png" x="'.($tx).'" y="'.(((($y+0.25) * $mult)) + 40).'" height="20px" width="20px"/>';	*/
					}
				};
				
				//Add Dock Controls
				if (CheckEditPermission($itemid))
				{
					if ($rootasset == false)
					{
						$tx = (((($x + 0.5) * $mult))) - 10;	
						
						/*$svg .= '    	<rect x="'.($tx-1).'" y="'.(((($y+0.25) * $mult)) + 45).'" rx="5" ry="5" width="24" height="84" fill="#999999" opacity="0.5"/>';		
																		
						$edt .= '<g id="dashboardbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) + 48).')" opacity="0" visible="hidden">';						
						$edt .= '  <a xlink:href="ddashboard.php?id='.$itemid.'">';							
						$edt .= '    <rect x="0" y="0" rx="5" ry="5" width="128" height="20" fill="#999999"/>';												
						$edt .= '    <text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">DASHBOARD</text>';																		
						$edt .= '  </a>';
						$edt .= '</g>';
						$edt .= '<image id="dashboardbutton" xlink:href="/images/capbutton-gauge.png" x="'.$tx.'" y="'.(((($y+0.25) * $mult)) + 48).'" height="20px" width="20px"/>';
						
						$edt .= '<g id="editbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) + 75).')" opacity="0" visibility="hidden">';						
						$edt .= '  <a xlink:href="view.php?id='.$itemid.'">';							
						$edt .= '    <rect x="0" y="0" rx="5" ry="5" width="85" height="20" fill="#999999"/>';												
						$edt .= '    <text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">DETAIL</text>';																		
						$edt .= '  </a>';
						$edt .= '</g>';
						$edt .= '<image id="editbutton" xlink:href="/images/capbutton-edit.png" x="'.$tx.'" y="'.(((($y+0.25) * $mult)) + 75).'" height="20px" width="20px"/>';
						
						$edt .= '<g id="linkbuttonx" transform="translate('.($tx).','.(((($y+0.25) * $mult)) + 104).')" opacity="0" visibility="hidden">';						
						$edt .= '  <a xlink:href="bulklink.php?id='.$itemid.'">';							
						$edt .= '    <rect x="0" y="0" rx="5" ry="5" width="75" height="20" fill="#999999"/>';												
						$edt .= '    <text x="25" y="15" text-anchor="left" font-size="14" font-family="Arial" stroke="#222222">LINK</text>';																		
						$edt .= '  </a>';
						$edt .= '</g>';
						$edt .= '<image id="linkbutton" xlink:href="/images/capbutton-link.png" x="'.$tx.'" y="'.(((($y+0.25) * $mult)) + 104).'" height="20px" width="20px"/>';*/
					}
				}				
			}
			
			$svg .= '<text x="'.(($x+0.5) * $mult).'" y="'.((($y+0.25) * $mult) + 40).'" stroke-width="1" fill="black" text-anchor="middle" font-size="10" font-family="Arial">'.SVGBreak($nm,25,($x+0.5) * $mult,$y).'</text>';
			$svg .= $adder;
			
			//$y++;
		}
	}	
	
	function SVGBreak($str, $ln, $x, $y)
	{
		$newstr = "";
		if (strlen($str)< $ln) return trim($str);
				
		$lines = 0;
		$diff = "0em";
		
		$str = trim($str);
		while ($str != "")
		{
			//echo 'Splitting String &quot;'.$str.'&quot;';
			
			if (strlen($str)< $ln)
			{
				$newstr .= '<tspan x="'.($x).'" dy="'.$diff.'">'.trim($str).'</tspan>';
				$diff = "1.4em";
				break;
			}
			
			$ps = strpos($str," ");
			if ($ps === FALSE)
			{
				//echo 'Committing Residual...'.$str;
				$newstr .= '<tspan x="'.($x).'" dy="'.$diff.'">'.trim($str).'</tspan>';
				$diff = "1.4em";
				break;
			}
			$psn = $ps;
			while(($psn < $ln) && ($psn !== FALSE))
			{
				$ps = $psn;
				$psn = strpos($str," ",$ps+1);
			}
			
			//echo 'Located Chunk Between 0 and '.$ps;
			
			//$newstr .= '<tspan x="'.($x * 80).'" y="'.(($y + $lines) * 80).'">';
			$newstr .= '<tspan x="'.($x).'" dy="'.$diff.'">';
			$newstr .= trim(substr($str,0,$ps));
			$newstr .= '</tspan>';
			$str = trim(substr($str,$ps+1));
			$lines++;
			$diff = "1.4em";
		}
		return $newstr;
	}
	
	$pointloaded = array();
	global $pointloaded;
	
	function LoadPoints($id,$dir, $depth, $parent)
	{
		global $sitefolder;
		global $asset;
		global $rel;
		global $points;
		global $indexset;
		global $pointloaded;
		
		global $x;
		global $y;
		global $svg;
		global $columns;
		
		if (isset($pointloaded[$id]))
		{
			//return;
		}
		$pointloaded[$id] = 1;
		
		if (!isset($asset[$id]))
		{		
			require_once($sitefolder.'/cache/relationships/'.$id.'.inc');
		}
		
		if (!isset($asset[$id]))
		{
			require($sitefolder.'/cache/relationships/'.$id.'.inc');
		}
				
		if (!isset($asset[$id]))
		{				
			echo '<!-- Asset Not In Cache - '.$sitefolder.'/cache/relationships/'.$id.'.inc'.' -->';
			return;
		}
												
		if ($depth != 0)
		{
			//Is this already present?
			$found = -1;
			if (isset($columns[$depth]))
			{				
				for($x=0;$x<count($columns[$depth]);$x++)
				{
					if ($columns[$depth][$x]['id'] == $id)
					{
						$found = $x;
						break;
					}
				}
			}
			//$found = -1;
			if ($found == -1)
			{			
				$rs = array();
				$rs['id'] = $id;
				$rs['from'] = array();
				$rs['from'][] = $parent;
				$columns[$depth][] = $rs;
			}
			else
			{
				$columns[$depth][$found]['from'][] = $parent;
			}
		};
				
		$any = false;
		
		global $justonerow;
		
		//echo '...'.$justonerow.'='.$dir;
		//if ($dir == true) echo 'Up!';
		
		if (($justonerow == true) && ($dir == false) && ($depth >= 1)) return;
								
		if (isset($asset[$id]["relationships"][$rel]))
		{
			foreach($asset[$id]["relationships"][$rel] as $rl)
			{
				if ($rl["upstream"] == $dir)
				{										
					$d = $depth;
					if ($dir == false) 
						$d++;
					else
						$d--;
						
					LoadPoints($rl["target"],$dir,$d,$id);
					$any = true;
				}
			}
		}													
	}	
	
	if (isset($edt)) $svg .= $edt;
	
	$requiredimagewidth = ((count($columns)) * $mult);
	$requiredimageheight = ($maxheight * $mult) + ($mult * 0.5);
	
	//$requiredimagewidth += 40;
		
	//$requiredimageheight *= 2;
	
	if ($justonerow == true)
	{
		$requiredimagewidth += $mult;
		
		$w = $mult/2;
		$h = (($maxheight-1) * $mult);
		//$svg .= '<a xlink:href="dpid.php?id='.$itemid.'&rel='.$rel.'&showall=true"><rect x="'.(count($columns) * $mult).'" y="32" width="'.($w).'" height="'.$h.'" stroke="silver" stroke-width="1" fill="#EEEEEE"/></a>';
		
		$x = (count($columns) * $mult) + 24;
		$y = (($h/2)) + 32;
		
		$svg .= '<a xlink:href="'.$siteroot.'/diagram/'.$itemid.'/'.$rel.'&showall=true"><text text-anchor="middle" x="'.$x.'" y="'.$y.'" transform="rotate(90 '.$x.' '.$y.')" stroke="silver">';
		if ($maxheight > 2) 
			$svg .='More Items';
		else
			$svg .='More';
		$svg .='</text></a>';
	}
		
	if ($requiredimageheight < 80) $requiredimageheight = 80;
		
	$svg = str_replace("800",$requiredimagewidth,$svg);
	$svg = str_replace("400",$requiredimageheight,$svg);

	$y = $requiredimageheight - 25;
	$x = ($requiredimagewidth / 2);

	$bump = 80;
	if (($bump * 4) > $requiredimagewidth)
	{
		$bump = $requiredimagewidth / 6;
	}	
	
	if (($lowest == 0) && ($highest == 0))
	{
		$y += 40;
	}

	$svg .= '<line x1="'.($x - $bump).'" x2="'.($x + $bump).'" y1="'.$y.'" y2="'.$y.'" stroke="silver" stroke-width="1"/>';
	
	$svg .= '<text x="'.($x - ($bump+10)).'" y="'.($y+2).'"  stroke-width="1" fill="black" text-anchor="end" font-size="10" font-family="Arial">'.$relationships[$rel]["upname"].'</text>';
	
	$svg .= '<text x="'.($x + ($bump+10)).'" y="'.($y+2).'"  stroke-width="1" fill="black" text-anchor="start" font-size="10" font-family="Arial">'.$relationships[$rel]["downname"].'</text>';

	$svg .= "</svg>";		
		
	echo '<div class="diagram" style="position: relative; top: 0px; left: 0px;">';
    echo $svg; ?>
       
</div>


 <div style="width: 100px; height: 120px; display: block; position: absolute; top: 50px; z-index: 50; display: none;" id="controls">
 
 	<?php
		
	 $rightoffset = 70;
	 if ($highest == 0) $rightoffset = 60; 
	 
	 $first = false;
	 if ($lowest == 0) $first = true;
	 
	 if ($default != $rel) $first = false;
	 if (CheckCreatePermission($itemid)) {
	 if ($first == false) { ?>
 	<div style="position: absolute; left: -37px; width: 30px; height: 110px; border-radius: 5px; top: 12px;">	
	    <a href="#" onclick="InsertIt(this); return false;" style="border: none; margin-top: 10px;"><img src="/images/capbutton-insert.png" title="Insert New Asset" style="width: 24px; margin-top: 5px;"/></a><br/>   		    
        <a href="#" onclick="CutWarning(this); return false;" style="border: none; margin-top: 0px; position: relative;" class="imgdeletecontrol"><img src="/images/capbutton-delete.png" title="Cut Link" style="width: 24px;"/></a>
    </div><?php }; ?>
    
    <div style="position: absolute; left: <?php echo $rightoffset;?>px; width: 30px; height: 72px; border-radius: 5px; top: 12px;">	
    <a href="#" onclick="CreateIt(this); return false;" style="border: none; margin-top: 10px;"><img src="/images/capbutton-add.png" title="Add New Asset" style="width: 24px; margin-top: 5px;"/></a><br/>    	
    </div>
	<?php }; ?>
    
     <div style="position: absolute; left: -10px; top: 75px; width: 80px; height: 60px; line-height: normal;">	
     	<div style="background-image: url(/images/pointerbgarrow.png); width: 80px; height: 16px;"></div>
        <div style="background-image: url(/images/pointerbg.png); width: 120px; border-bottom-left-radius: 5px; border-bottom-right-radius: 5px;padding-bottom: 5px;" class="diagramoptions">
        <a href="<?php echo $siteroot;?>/dashboard/<?php echo $itemid; ?>" class="btn btn-primary">DASHBOARD</a>
        <a href="<?php echo $siteroot;?>/detail/<?php echo $itemid; ?>" class="btn btn-success">DETAILS</a>
		<?php
			if ($thisasset->hasmeasurements()) {
		?>
		<a href="<?php echo $siteroot;?>/chart/<?php echo $itemid; ?>" class="btn btn-success">CHARTS</a>
        <?php }; ?>
		<?php if (($envid != 0) || ($hasmodel == true)) { ?><a href="<?php echo $siteroot;?>/3D-VE/<?php echo $itemid; ?>" class="btn btn-success">3D</a>
		<?php }; ?>
        </div>
        
     	
    </div>
 </div>

<?php
if (CheckCreatePermission($itemid))
{		?>
<div id="bgdiv">

	<table>
		<tr><td>
    	Asset To <span id="addfunction">Add</span>...</td>
		<td style="text-align: right;">
		<!--<a href="#" class="btn btn-default" onclick="$('#bgdiv').fadeOut(500); return false; return false;"><i class="fa fa-circle-o"></i>Cancel</a>-->
		<a href="#" onclick="$('#bgdiv').fadeOut(500); return false;" class="closebutton">X</a></td></tr>
    </table>
	<div class="assetfield">
	    <input id="lookitup" name="result" type="text"/>
	</div>
	<div class="assetfield">
        <a href="#" class="btn btn-default" onclick="Browser(); return false;"><i class="fa fa-circle-o"></i>Browse</a>
		<a href="#" class="btn btn-default" onclick="RecentList(); return false;"><i class="fa fa-circle-o"></i>Recent</a>
		<a href="#" class="btn btn-default" onclick="CreateAsset($('#lookitup').val()); return false;"><i class="fa fa-circle-o"></i>Create</a>
		<a class="btn btn-default" href="<?php echo $siteroot;?>/tools/import?parent=<?php echo $itemid;?>&rel=<?php echo $rel;?>"><i class="fa fa-circle-o"></i>Import</a>
		<!--
        <a href="#" onclick="RecentList(); return false;"><div class="recentbutton actionbutton">
        	&nbsp;
        </div></a>
        <a href="#" onclick="CreateAsset($('#lookitup').val()); return false;"><div class="insertbutton actionbutton">&nbsp;      	
        </div>
        <a href="#" onclick="$('#bgdiv').fadeOut(500); return false;"><div class="cancelbutton actionbutton">
        	X
        </div></a><br/><br/>-->        
    </div>   
    
</div>

<div style="z-index: 80; opacity: 0.95; position: absolute; top: 0px; left: 0px; display: none; padding: 12px; background-color: #303030" id="confirm">

	<p style="font-weight: bold; color: white; font-size: small; text-align: left; margin: 0px; line-height: normal;">
    	Are you sure you want to delete these relationships?
    </p>
	<div style="text-align: left; padding-top: 10px; line-height: normal;">
    	<a href="#" onclick="$('#confirm').fadeOut(500); return false;" class="btn btn-success">No - Cancel</a>&nbsp;&nbsp;<a href="#" onclick="SendCut(); return false;" class="btn btn-default">Yes - Continue</a>
    </div> 
    
</div>

<?php }; ?>

<script>

function Browser()
{
	$('.assetfield').remove('#lookupbrowser');
	$('#lookitup').after('<div id="lookupbrowser" class="lookupbrowser" style="display: none;"><h3>Browser</h3><hr/>Loading Details...</div>');
	$('#lookupbrowser').show(500);
	BrowserUpdate(0,0,'');
}

function RecentList()
{
	$('.assetfield').remove('#lookupbrowser');
	$('#lookitup').after('<div id="lookupbrowser" class="lookupbrowser" style="display: none;"><h3>Tag Matches</h3><hr/>Loading Options...</div>');
	$('#lookupbrowser').show(500);
	RecentListUpdate();
}

function CloseBrowser()
{
	$('#lookupbrowser').hide(500);
	SelectedAsset();
}

function ClearBrowser()
{
	$('#lookupbrowser').hide(500);
	$("#" + $('#lookitup').attr('name') + "id").val(0);
	$('#lookitup').val("");
}

function BrowserUpdate(relno,ident,name)
{	
	$('#lookitup').val(name);
	$.post('<?php echo $siteroot;?>/data/browse.php',{ id: ident, rel:relno },function (data) {
		$('#lookupbrowser').html(data);
	})
	$('#' + $('#lookitup').attr('name') + "id").val(ident);
}

function RecentListUpdate()
{		
	$.post('<?php echo $siteroot;?>/data/recent.php',{},function (data) {
		$('#lookupbrowser').html(data);
	})	
}

function Recent(name,id)
{
	$('#lookitup').val(name);
	$('#' + $('#lookitup').attr('name') + "id").val(id);
	CloseBrowser();
}

function CreateAsset(str)
{
	if (insertmode == false)
	{
		window.location="<?php echo $siteroot;?>/asset/create?name=" + encodeURIComponent(str) + "&parent=<?php echo $itemid; ?>&rel=<?php echo $rel;?>";
	}
	else
	{
		window.location="<?php echo $siteroot;?>/asset/create?name=" + encodeURIComponent(str) + "&child=<?php echo $itemid; ?>&rel=<?php echo $rel;?>";
	}
}

function SelectedAsset()
{
	if (insertmode == false)
	{		
		var v = $('#' + $('#lookitup').attr('name') + "id").val();	
	
		$('#bgdiv').fadeOut(500);
		window.location="<?php echo $siteroot;?>/asset/link?origin=<?php echo $itemid;?>&newreltarget=" + v + "&relationship=<?php echo $rel; ?>&returnto=diagram&editing=<?php echo $itemid; ?>";
	}
	else
	{
		var v = $('#' + $('#lookitup').attr('name') + "id").val();	
	
		$('#bgdiv').fadeOut(500);
		window.location="<?php echo $siteroot;?>/asset/link?origin=<?php echo $itemid;?>&newreltarget=" + v + "&relationship=<?php echo $rel; ?>&returnto=diagram&editing=<?php echo $itemid; ?>";
	}
}

function ChangeRelationship(id)
{
	//alert('Changing Relationship to ' + id);
	window.location = '<?php 

/*function change_query ( $url , $array ) {
    $url_decomposition = parse_url ($url);
    $cut_url = explode('?', $url);
    $queries = array_key_exists('query',$url_decomposition) ? $url_decomposition['query']:false;
    $queries_array = array ();
    if ($queries) {
        $cut_queries   = explode('&', $queries);
        foreach ($cut_queries as $k => $v) {
            $tmp = explode('=', $v);
            if (sizeof($tmp ) < 2) $tmp[1] = true;
            $queries_array[$tmp[0]] = $tmp[1];
        }
    }
    $newQueries = array_merge($queries_array,$array);
    return $cut_url[0].'?'.http_build_query($newQueries);
}

	$domain = $_SERVER['HTTP_HOST'];
	$url = "http://" . $domain . $_SERVER['REQUEST_URI'];
	$arr = array();
	$arr['rel'] = 'xxxdxxx';
	$newquery = change_query($url,$arr);
	echo str_replace("'';",";",str_replace('xxxdxxx',"' + id + '",$newquery));*/
	echo $siteroot.'/diagram/'.$itemid.'/';
	?>' + id;
}

</script>

<?php		ET();
		ET();
	ET();
ET();
	
?>