<?php
/**
 * Duplicates an existing asset (and optionally a number of its children, too).
 *
 * @author Steven Harding
 */
		
	function str_replace_first($search, $replace, $subject) {
 	   $pos = strpos($subject, $search);
	    if ($pos !== false) {
	        $subject = substr_replace($subject, $replace, $pos, strlen($search));
	    }
	    return $subject;
	}
				
	$debugmode = false;
	
	$xnudge = 0;
	$ynudge = 0;
	$znudge = 0;
	if (isset($_REQUEST['xnudge'])) $xnudge = $_REQUEST['xnudge'];
	if (isset($_REQUEST['ynudge'])) $ynudge = $_REQUEST['ynudge'];
	if (isset($_REQUEST['znudge'])) $znudge = $_REQUEST['znudge'];
	
	if ($debugmode == false) ob_start();
	
	$ultimateparent = 0;
		
	if ($_SERVER['REQUEST_METHOD'] == "POST")
	{
		$id = $_REQUEST['id'];
		$times = $_REQUEST['qty'];
		
		$driverupdates = array();
		$cacheupdates = array();
		
		//Load property details...
		$query = $db->query('SELECT id,typename,name FROM properties ORDER BY id');
		 
		$props = array();   				
    	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$props[] = $row;
		}
		
		//Gather information about the asset(s) to be duplicated....
		echo 'Gathering Information for Duplication...';
		
		if (!isset($relationships))
		{
			require_once($sitefolder.'/cache/relationships/all.inc');
			global $relationships;
		}
				
		
		//Get the item in question...
		$query = $db->query('SELECT * FROM assets WHERE id='.$id);
		    				
    	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$detail = $row;
			if (!isset($asset[$id]))
			{		
				require_once($sitefolder.'/cache/relationships/'.$id.'.inc');				
			}
		}
		
		$children = array();
		$internalids = array();
		
		$pl = array();
		$children[] = $detail;
		
		//Get child assets...
		$query = $db->query('SELECT assets.name, assets.id, assets.descript,assets.type FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$id);
		    		
		global $asset;		
		
    	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			//echo 'SELECT assets.name, assets.id, assets.descript,assets.type FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$id;
			$aid = $row['id'];
			$children[] = $row;
			$internalids[] = $aid;
			if (!isset($asset[$aid]))
			{		
				require_once($sitefolder.'/cache/relationships/'.$aid.'.inc');
			}
		}
		
		global $asset;
		
		$links = array();
		
		//Get data links
		
		$query = $db->query('SELECT * FROM datalinks WHERE assetid='.$id);
		    				
    	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$links[] = $row;
		}
		
		$query = $db->query('SELECT datalinks.* FROM assetrelclosures JOIN datalinks ON (assetrelclosures.childasset = datalinks.assetid) WHERE parentasset='.$id);
		    				
    	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$links[] = $row;
		}
		
		$values = array();
		
		foreach($children as $ch)
		{
			$values[$ch['id']] = array();
			$query = $db->query('SELECT * FROM assetvalues WHERE assetid='.$ch['id']);
		    				
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$values[$ch['id']][] = $row;
			}
		}
		
		//OK - now let's also look at our friend the closure table...
		
		//NOTE - If we ever get an out of memory exception, this little bugger will be the culprit!
		
		$closures = array();
		foreach($children as $ch)
		{
			$query = $db->query('SELECT * FROM assetrelclosures WHERE childasset='.$ch['id']);
								
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$closures[] = $row;
			}
		}
		
		//print_r($closures);
		
		//Figure out string substitutions for names...
		
		$original = $asset[$id]['name'];
		echo '<br/><br/>Checking For Incrementable Numbers on '.$original.'<br/>';		
		
		$p = strpos($original,'#');
		if ($p !== FALSE)
		{			
			if (substr($original,$p+1,1) > 0)
			{
				//Hello there - we have a number.
				$ep = strpos($original,' ',$p);
				if ($ep === FALSE)
				{
					$ep = strlen($original) - $p;
				}				
				$finalnumber = substr($original,$p+1,$ep);
				echo 'Final Incrementable Number: '.$finalnumber.'<br/><br/>';
			}
		}		
		
		if (isset($finalnumber))
		{
			$renumberstring = '#'.$finalnumber;			
		}
		
		
		
		
		//Perform the actual duplication
		for($iter = 0; $iter < $times; $iter++)
		{
			$idmapping = array();			
			
			if (isset($renumberstring))
			{
				$newnumbervalue = (0+$finalnumber+$iter+1);
				$newnumber = '#'.$newnumbervalue;
				echo '[ Number For This Pass - '.$newnumber.' ]<br/>';
			}
			
			foreach($children as $ch)
			{
				$chid = $ch['id'];
				$newname = $ch['name'];
				$newdesc = $ch['descript'];
				if (isset($newnumber))
				{					
					$newname = str_replace($renumberstring,$newnumber,$ch['name']);
					$newdesc = str_replace($renumberstring,$newnumber,$ch['descript']);
					echo '<br/> - NEW ASSET NAME: '.$newname.'<br/>';
				}
				
				echo '<br/> - CREATE ASSET BASED ON "'.$ch['name'].'" (# '.$chid.')<br/>';
				$q = "INSERT INTO assets (name,descript,type) VALUES (".$db->quote($newname).",".$db->quote($newdesc).",".$ch['type'].")";
				if ($debugmode == true)
				{
					echo $q."<br/>"; $assid = $chid + 50;
				}
				else
				{
					$db->query($q); $assid=$db->lastInsertId();
				}
				
				$cacheupdates[] = $assid;
				
				$idmapping[$chid] = $assid;
				echo 'Adding ID Mapping Element...';
				
				foreach($values[$chid] as $row)
				{
					$val = $row['value'];
					foreach($props as $p)
					{
						if ($p['id'] == $row['propertyid'])
						{
							if ($p['typename'] == 'TAG')
							{
								if (isset($newnumber))
								{
									$val = str_replace("_".$finalnumber,"_".$newnumbervalue,$val);
								}
							}
							if ($p['typename'] == 'LOCATION')
							{
								$bits = explode('|',$val);	
								$pieces = explode(',',$bits[0]);
								$val = ($pieces[0]+($xnudge * ($iter+1))).','.($pieces[1]+($ynudge * ($iter+1))).','.($pieces[2]+($znudge * ($iter+1))).'|'.$bits[1].'|'.$bits[2];							
								echo '<br/> --- NUDGING POSITION - '.$row['value'].' TO '.$val.'<br/>';
							}
						}
					}
					echo '<br/> --- ASSIGN VALUE '.$row['propertyid'].' = '.$val.'<br/>';
					$q = "INSERT INTO assetvalues (assetid,propertyid,value) VALUES (".$assid.",".$row['propertyid'].",".$db->quote($val).")";
					if ($debugmode == true)
						echo $q."<br/>";
					else
						$db->query($q);
				}
			}
			
			$linked = array();
			
			echo '<br/>';
			
			foreach($children as $ch)
			{
				$chid = $ch['id'];
				
				$rf = $idmapping[$chid];
																															
				foreach($asset[$chid]['relationships'][2] as $rel)
				{					
					if (!isset($idmapping[$rel['target']]))
					{
						$targ = $rel['target'];
						echo '<br/> --- ASSIGN PARENT LOCATION RELATIONSHIP BETWEEN '.$rf.' ( '.$ch['name'].' ) AND '.$targ.'<br/>';
						$q = "INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES (".$targ.",".$rf.",2)";
						if ($debugmode == true)						
							echo $q."<br/>";
						else
							$db->query($q);
						
						if (!in_array($targ,$cacheupdates)) $cacheupdates[] = $targ;
						
						$ultimateparent = $chid; 
						
						continue;
					}
					
					$targ = $idmapping[$rel['target']];
					
					echo '<br/> --- ASSIGN LOCATION RELATIONSHIP BETWEEN '.$rf.' ( '.$ch['name'].' ) AND '.$targ.' - ';
					
					if ($rel['upstream'] == 1) 
					{
						$qd = $chid.'-'.$rel['target'];
						if (!in_array($qd,$linked))
						{
							echo 'Upstream<br/>';
							$linked[] = $qd;
							
							$q = "INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES (".$targ.",".$rf.",2)";
							if ($debugmode == true)
								echo $q."<br/>";
							else
								$db->query($q);
						}
						else
							echo 'Already Created<br/>';
					}
					else
					{
						$qd = $rel['target'].'-'.$chid;
						if (!in_array($qd,$linked))
						{
							echo 'Downstream<br/>';
							$linked[] = $qd;		
							$q = "INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES (".$rf.",".$targ.",2)";
							if ($debugmode == true)							
								echo $q."<br/>";
							else
								$db->query($q);					
						}
						else
							echo 'Already Created<br/>';
					}
				}
			}
			
			echo '<br/>';
			
			foreach($children as $ch)
			{
				$chid = $ch['id'];
				
				$rf = $idmapping[$chid];
				
				$linked = array();
												
				foreach($asset[$chid]['relationships'] as $k => $v)
				{
					if ($k == 2) continue;									
					
					foreach($v as $rel)
					{						
						$t = $rel['target'];
						
						if (!isset($asset[$t]))
						{
							require_once($sitefolder.'/cache/relationships/'.$t.'.inc');
						}
						
						if (!in_array($t,$internalids))						
							echo ' --- ASSIGN EXTERNAL RELATIONSHIP BETWEEN '.$rf.' ( '.$ch['name'].' ) AND '.$rel['target'].' ( '.$asset[$t]['name'].' ) - ';							
						else
						{
							$t = $idmapping[$t];
							echo ' --- ASSIGN INTERNAL RELATIONSHIP BETWEEN '.$rf.' ( '.$ch['name'].' ) AND '.$t.' ( '.$asset[$rel['target']]['name'].' ) - ';							
						}
						
						if ($rel['upstream'] == 1) 
						{
							$qd = $chid.'-'.$rel['target'];
							if (!in_array($qd,$linked))
							{
								echo 'Upstream<br/>';
								$linked[] = $qd;
								
								$q = "INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES (".$t.",".$rf.",".$k.")";
								if ($debugmode == true)								
									echo $q."<br/>";
								else
									$db->query($q);
									
								if (!in_array($t,$cacheupdates)) $cacheupdates[] = $t;
							}
							else
								echo 'Already Created<br/>';
						}
						else
						{
							$qd = $rel['target'].'-'.$chid;
							if (!in_array($qd,$linked))
							{
								echo 'Downstream<br/>';
								$linked[] = $qd;		
								$q = "INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES (".$rf.",".$t.",".$k.")";
								if ($debugmode == true)								
									echo $q."<br/>";
								else								
									$db->query($q);		
									
								if (!in_array($t,$cacheupdates)) $cacheupdates[] = $t;												
							}
							else
								echo 'Already Created<br/>';
						}
					}
				}								
			}
			
			echo '<br/>';
			
			foreach($children as $ch)
			{
				$chid = $ch['id'];
				
				$rf = $idmapping[$chid];
				
				echo ' -- UPDATING CLOSURE TABLE FOR '.$ch['name'].' / '.$chid.' / '.$rf.'<br/>';							
				
				foreach($closures as $clo)
				{
					if ($clo['childasset'] == $chid)
					{
						$child = $idmapping[$chid];
						
						$parent = $clo['parentasset'];
						if (in_array($parent,$internalids))
						{
							$parent = $idmapping[$parent];
						}
						
						$q = "INSERT INTO assetrelclosures (parentasset,childasset,depth,relationship) VALUES (".$parent.",".$child.",".$clo['depth'].','.$clo['relationship'].")";
						if ($debugmode == true)								
							echo $q."<br/>";
						else								
							$db->query($q);								
					}
				}
			}
			
			echo '<br/>';
			
			foreach($links as $lnk)
			{
				$rf = $idmapping[$lnk['assetid']];
				
				$addr = $lnk['address'];
				if (isset($renumberstring))
				{
					$addr = str_replace_first("[".$finalnumber."]","[".(0+$finalnumber+$iter+1)."]",$addr);
				}
				
				echo '<br/> -- ADDING DATA LINK FOR '.$rf.' ( '.$asset[$lnk['assetid']]['name'].' ) TO  '.$addr.'<br/>';
				$q = "INSERT INTO datalinks (sourceid,assetid,propertyid,node,mode,address,transform) VALUES (".$lnk['sourceid'].','.$rf.','.$lnk['propertyid'].','.$db->quote($lnk['node']).','.$lnk['mode'].','.$db->quote($addr).','.$db->quote($lnk['transform']).")";
				if ($debugmode == true)				
					echo $q."<br/>";
				else
					$db->query($q);
					
				if (!in_array($lnk['sourceid'],$driverupdates))
				{
					$driverupdates[] = $lnk['sourceid'];
				}
			}
			echo '<br/>';
			
			//Check for a BINDING file in case an assetbundle is involved at any point....
			
			foreach($children as $ch)
			{
				$fn = $sitefolder.'/cache/bindings/'.$ch['id'].'.xml';
				if ($debugmode == true) echo 'Checking Bindings For '.$fn;
				if (file_exists($fn))
				{
					//Duplicate File...
					if ($debugmode == true) echo ' - Located<br/>';
					//echo '  Saving To '.$sitefolder.'/cache/bindings/'.$idmapping[$ch['id']].'.xml<br/><br/>';
					$content = file_get_contents($fn);
					
					//echo 'Converting '.htmlspecialchars($content);
					foreach($idmapping as $k=>$v)
					{
						$content = str_replace('boundasset="'.$k,'boundasset="'.$v,$content);
					}
					//echo '<br/><br/> To <br/>';
					//echo htmlspecialchars($content);
					
					file_put_contents($sitefolder.'/cache/bindings/'.$idmapping[$ch['id']].'.xml',$content);
				}
				else
				{
					if ($debugmode == true) echo ' - No Binding File<br/>';
				}
			}
			
			//Create Duplication Diff...
			$content = "<?php \r\n";			
			$content .= "?>";		
			
			$fld = $sitefolder.'/cache/dupdiff';
			if (!file_exists($fld))
			{
				mkdir($fld);
			}
			file_put_contents($sitefolder.'/cache/dupdiff/'.$id.'.inc',$content);	
			
			//Assign duplication link...
			$dupid = 0;
			$query = $db->query('SELECT id FROM relationships WHERE name=\'Duplicate\'');			
		    				
			if ($query !== FALSE)
			{
				while($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$dupid = $row['id'];
				}
			}
			
			if ($dupid == 0)
			{
				echo ' --- NO DUPLICATE RELATIONSHIP FOUND - CREATING NEW ONE<br/><br/>';
				
				$db->query("INSERT INTO relationships (name,upstreamname,downstreamname,flags,rootasset,options,colour,style) VALUES ('Duplicate','A Copy Of','Was Duplicated By',0,0,'','',1)");
				
				//echo "INSERT INTO relationships (name,upstreamname,downstreamname,flags,rootasset,options,colour,style) VALUES ('Duplicate','A Copy Of','Was Duplicated By',0,0,'','',1)";
				
				$dupid = $db->lastInsertId();
			}
			
			$t = $idmapping[$id];
			echo '<br/> --- ASSIGN DUPLICATE RELATIONSHIP BETWEEN '.$id.' ( '.$asset[$id]['name'].' ) AND '.$t.'<br/>';
			$q = "INSERT INTO assetrelationships (parentasset,childasset,relationship) VALUES (".$id.",".$t.",".$dupid.")";
			if ($debugmode == true)
				echo $q."<br/>";
			else
				$db->query($q);		
			
			//print_r($children);
												
		}
		
		//OK - it's time to get busy rebuilding everything that must be rebuilt - most importantly the cache for all of the new items as well as any referenced items.			
		
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/cacheobject.php');
		
		unset($closures);
		
		foreach($cacheupdates as $cu)
		{
			//Reload Cache...
			if ($debugmode == true)
			{
				echo '<br/> -- REBUILDING OBJECT CACHE FOR '.$cu.'<br/>';
			}
			else
			{
				RebuildObjectCacheByID($cu);
			}
		}
				
		foreach($driverupdates as $drv)
		{
			//Request Driver Reconfiguration...
			
			//echo "SELECT DISTINCT datadriver.address,port FROM datasources JOIN datadriver ON (datadriver.port = datasources.gatewayport) WHERE datasources.assetid=".$drv;			
			
			$query = $db->query('SELECT DISTINCT datadriver.address,port FROM datasources JOIN datadriver ON (datadriver.port = datasources.gatewayport) WHERE datasources.assetid='.$drv);
						
		 	$toreload = array();
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$ip = $row['address'];
				if ($ip == "") $ip = "localhost";
				$port = $row['port'];						
				
				//$url = "http://" + $ip + ":" + $port + "/reload?id=".$drv;
				
				/*if ($debugmode == true)
				{
					echo '<br/> -- RELOADING DATA DRIVER '.$drv.' on port '.$port.'<br/>';
				}
				else*/
				if (true)
				{
					$ip = gethostbyname($ip);
					$client = stream_socket_client("tcp://".$ip.":".$port,$err,$errmsg);
					fwrite($client,"reload|".$drv);
					fclose($client);
					/*//Send Request via CURL
					$ch = curl_init();
			 
					curl_setopt($ch, CURLOPT_URL, $url);    
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($ch, CURLOPT_TIMEOUT, 3);
					$output = curl_exec($ch);
			 
					// Close the cURL resource, and free system resources
					curl_close($ch);*/
				}
			}
		}
		
		$r = ob_get_clean();
		unset($r);
		
		if ($debugmode != true)
		{
			if ($ultimateparent == 0)
			{
				$ultimateparent = $id;
			}
			header('Location: '.$siteroot.'/diagram/'.$ultimateparent);
		}
		exit;
	}
		
$title="Duplicate Asset";
		
include($installfolder.'/include/tmpl.php');

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		
		ST('half');
			ST('boxform','title=Options');?>
				<input type="hidden" value="<?php echo $_REQUEST['id']; ?>" name="id"/>
    <button type="submit" class="btn btn-success">Duplicate Asset</button><?php
				SS('footer');
				ST('ftable');
?>	
	  
       
    <tr><td><label>Quantity to Create:</label></td><td><input type="text" name="qty" value="1" style="margin-left: 20px;"/></td></tr>
    <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
    	<tr><td>Position Nudge (x):</td><td><input type="text" style="width: 100px;margin-left: 20px;" name="xnudge" value="4.5"/></td></tr>
        <tr><td>Position Nudge (y):</td><td><input type="text" style="width: 100px;margin-left: 20px;" name="ynudge" value="0"/></td></tr>
        <tr><td>Position Nudge (z):</td><td><input type="text" style="width: 100px;margin-left: 20px;" name="znudge" value="0"/></td></tr>
    
	<!--<table>    	
    	<tr><td><input type="checkbox" id="propertyvalues"  style="margin-right: 10px;" checked/>Duplicate Location Children</td></tr>
        <tr><td><input type="checkbox" id="propertyvalues"  style="margin-right: 10px;" checked/>Copy Property Values</td></tr>
        <tr><td><input type="checkbox" id="datalinks"  style="margin-right: 10px;" checked/>Copy Data Links</td></tr>
        <tr><td><input type="checkbox" id="nudge"  style="margin-right: 10px;" checked/>Nudge Location</td></tr>
        <tr><td><input type="checkbox" id="external"  style="margin-right: 10px;" checked/>Keep External Relationships</td></tr>
	</table>
    <h3>Numeric Options</h3>
    <table>        
        <tr><td><input type="checkbox" id="nudge"  style="margin-right: 10px;" checked/>Change Numbers in Names and Descriptions</td></tr>
        <tr><td><input type="checkbox" id="nudge"  style="margin-right: 10px;" checked/>Change Numbers in Data Links</td></tr>
	</table>-->
    
    </form>
</div>

    <?php
				ET();
			ET();
		ET();
	ET();
ET();
?>