<?php
/**
 * Displays detailed isolation status information
 *
 * @author Steven Harding
 */
 
	//$editable = true;

	$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
	if ($itemid === FALSE) exit;

	include($installfolder.'/model/asset.php');

	$thisasset = new Asset($itemid);
	$thisasset->Load();

	$title = $thisasset->name." Isolation Status";
	
	include($installfolder.'/include/tmpl.php');
	include($installfolder.'/model/property.php');

	T('header-basic','title='.$title);	
	
	ST('section','class=content');
		ST('row');
			ST('half');
				ST('box','title=Current Status');
   
    //include($installfolder.'/include/isocheck.php');
	
	GetActiveSources($itemid);
	
	$state = "Not Isolated";
	if (count($results) == 0)
	{
		echo '<h4>This asset appears to be isolated</h4>';
	}
	else
	{
		echo '<h4>This asset is currently being supplied by...</h4><blockquote>';
		foreach($results as $res)
		{
			if ($res['id'] == $itemid)
			{
				echo 'Itself<br>';
				continue;
			}
			
			echo '<a href="/dashboard/'.$res['id'].'">'.$res['name'].'</a>';
			echo '<a href="/route/'.$itemid.'/'.$res['id'].'"><i class="fa fa-share-alt" style="position: relative; top: 1px; margin-left: 0.5em;"></i></a>';
			echo '<br/>';
			
		}
		echo '</blockquote>';
	}
   		ET();
	ET();

	ST('half');
		ST('box','title=Points');
	
	include($installfolder.'/include/isofind.php');
	
	$results = array();
	
	GetIsolationPoints($itemid);

	$source = "";
	$ip = "";
	$protection = "";
	$issource = false;
	foreach($results as $res)
	{
		if ($res['type'] == 'Self-Source')
		{
			if ($issource == false)
			{
				echo '<h4>Source</h4>This may contain stored energy.<br/>';
				$issource = true;
			}
		}
	
		if ($res['type'] == "Isolation Point")
		{
			$ip .= '<a href="/dashboard/'.$res['id'].'">'.$res['name'].'</a><br/>';
		}
		
		if ($res['type'] == "Source")
		{
			$source .= '<strong><a href="/dashboard/'.$res['id'].'">'.$res['name'].'</a></strong><br/>';
		}
	}
	
	if ($source != "")
	{
		echo '<h4>Can Not Be Isolated From</h4>';
		echo '<p>'.$source.'</p>';		
	}
	
	if ($ip != "")
	{
		echo '<h4>Local Isolation Points</h4>';
		echo '<p>'.$ip.'</p>';		
	}
	
	
			ET();
		ET();
	ET();
ET(); ?>