<?php
/**
 * Displays a 'live' graph of process values
 *
 * This module requires that your have a Consolidation server running
 *
 * @author Steven Harding
 */
	
	$minoffset = 0;
	$maxoffset = 0;
	
	//Filtering Match List...
	$bx = array_keys($matches);
	foreach($bx as $n)
	{
		if ($n < $minoffset) $minoffset = $n;
		if ($n > $maxoffset) $maxoffset = $n;
	}
	
	function GetColour($int)
	{
		switch($int)
		{
		case 0:
			return '#00FF00';
		case 1:
			return '#FF0000';
		case 2:
			return '#0000FF';
		case 3:
			return '#FFFF00';
		case 4:
			return '#FF00FF';
		case 5:
			return '#00FFFF';
		case 6:
			return '#FFFFFF';
		case 7:
			return '#888888';
		}
	}
	
	function NumberCode($int)
	{
		return chr($int + ord('A'));
	}
	
	$indx = 0;
	$done = array();
	$lines = array();
	foreach($matches as $offset => $v)
	{
		foreach($v as $q)
		{
			$code = $q['originid'].':'.$q['propertyid'].':measurement';
			if (!in_array($code,$done))
			{
				$done[] = $code;
				$bit = array();
				$bit['code'] = $code;
				$bit['colour'] = GetColour($indx);
				$bit['symbol'] = NumberCode($indx);
				$bit['name'] = $q['assetname'];
				$indx++;
				$lines[] = $bit;
			}
			$q['line'] = count($lines)-1;
		}
	}
	
	$profile = 1;
	if (isset($_REQUEST['profile']))
	{
		$profile = $_REQUEST['profile'];
		$profile = filter_var($profile,FILTER_VALIDATE_INT);
		if ($profile === FALSE) exit;
	}
	
	$query = $db->query('SELECT * FROM profiles WHERE id='.$profile);

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$profdata = $row;
	}
	
	if (!isset($profdata))
	{
		exit();
	}
	
	$profilename = $profdata['name'];
	$port = $profdata['reqport'];
	$shost = $profdata['address'];
	
	$vx = $_SERVER['HTTP_HOST'];
	$ps = strpos($vx,'/');
	if ($ps !== FALSE)
	{
		$vx = substr($vx,0,$ps);
	}
	$host = $vx;
		
	if (($shost != '') && ($shost != 'localhost'))
	{
		$host = $shost;
	}
	
	//Get details from item #1...
	$match = $matches[array_keys($matches)[0]];
	//print_r($match);
	$propid = $match[0]['propertyid'];
	$thisasset = new Asset($match[0]['assetid']);
	$lprop = $thisasset->GetLocalProperties();
	$thisasset->GetValues($lprop);
	
	$defaults = array();
	foreach($lprop as $p)
	{
		if ($p->id == $propid)
		{
			$defaults = $p;
			break;
		}
	}

	$title = 'Live Trend';

	global $installfolder;

	include('include/tmpl.php');
	
	$isdynamic = false;
	
	?>

	<li class="active treeview">
	  <a href="/">
		<i class="fa fa-photo"></i> <span>Chart Assets</span>
	  </a>
	  <ul class="treeview-menu">
		<li>
		<?php
		$dn = array();
		foreach($matches as $xn)
		{
			foreach($xn as $v)
			{?>
			<a href="<?php echo $siteroot;?>/dashboard/<?php echo $v['assetid'];?>/2"><i class="fa fa-circle-o"></i> <?php echo $v['assetname'];?></a><?php
				$dn[] = $v['assetid'];
			} 	
		}?>
		</li>
	  </ul>
    </li>

<?php SS('sidebar'); 

	//$template->StartSection('onload');
	
	$hostname = $_SERVER['HTTP_HOST'];
	$hostname = explode(':',$hostname)[0];
	
	$min = $defaults->value['min'];
	$max = $defaults->value['max'];
	$units = $defaults->value['units'];
	$places = $defaults->value['places'];
	
	if ($min == $max)
	{
		$min = 0;
		$max = $defaults->value['measurement']*2;
	}
	
	
		//$points = explode('_',$_REQUEST['points']);
		//$points = array();
		//$points[0] = ;
	?>
	$.plot($("#chartelement"), dataset, chartoptions);
	update();
	GetData();
	
	var connection = new ARDIHMI();
	
	/* <?php print_r($matches); ?> */
	
	<?php 
	$indx = 0;
	foreach($lines as $ln)
	{ ?>
	connection.Subscribe("<?php echo $ln['code']; ?>",function (val) {
		Value<?php echo $ln['symbol']; ?> = val;
		var vx = parseFloat(val).toFixed(<?php echo $places; ?>);
		$('.currentvalue<?php echo strtolower($ln['symbol']); ?>').html(vx + '<?php echo $units;?>');
	});
	<?php
		$indx++;
	}
	?>
	
	connection.ConnectTo("<?php echo $_SERVER['HTTP_HOST']; ?><?php echo $siteroot;?>");
<?php	
	SS('onload');?>
	<script src="/plugins/flot/jquery.flot.js"></script>
	<script src="/plugins/flot/jquery.flot.time.js"></script>
	<script src="/plugins/flot/jquery.flot.axislabels.js"></script>
	<script src="/plugins/optrix/ardiclient.js"></script>
<?php
	SS('addscripts');?>
<?php
	SS('head');
	
	T('header-basic','title='.$title);


	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title=Live Chart');
				
		SS('footer');
	
?>  

<script>

	
	
	/*function Subscribe()
	{
		$.get('http://<?php echo $host;?>:<?php echo $port;?>/subscribe?codes=<?php echo $code;?>&format=json',{ },function (data) {
			Subscription = data.id;
			Value = Math.round(data.items[0].value * 1<?php echo str_repeat('0',$places);?>) / 1<?php echo str_repeat('0',$places);?>;
			$('#currentvalue').html(Value + '<?php echo $units;?>');
			setTimeout(Subdate, updateInterval);
		});
	}
	
	function Subdate()
	{
		$.get('http://<?php echo $host;?>:<?php echo $port;?>/update?id=' + Subscription + '&format=json',{ },function (data) {
			Subscription = data.id;
			if ((data.items) && (data.items.length > 0))
            {
            	Value = Math.round(data.items[0].value * 1<?php echo str_repeat('0',$places);?>) / 1<?php echo str_repeat('0',$places);?>;
				$('#currentvalue').html(Value + '<?php echo $units;?>');
            }
			setTimeout(Subdate, updateInterval);
		});
	}*/

    dataset = [
	<?php
	for($x=0;$x<count($lines);$x++)
	{ 
		$ln = $lines[$x]; ?>
		{ label: "<?php echo $ln['name'];?>", data: data<?php echo strtolower($ln['symbol']);?>, color: "<?php echo $ln['colour'];?>" }
	<?php
		if ($x < count($lines)-1) echo ',';
	}?>
    ];

    function update() {
        GetData();
		
		dataset = [
	<?php
	for($x=0;$x<count($lines);$x++)
	{ 
		$ln = $lines[$x]; ?>
			{ label: "<?php echo $ln['name'];?>", data: data<?php echo strtolower($ln['symbol']);?>, color: "<?php echo $ln['colour'];?>" }
	<?php
		if ($x < count($lines)-1) echo ',';
	}?>
		];

        $.plot($("#chartelement"), dataset, chartoptions)
        setTimeout(update, updateInterval);
    }

<?php
	for($x=0;$x<count($lines);$x++)
	{ 
		$ln = $lines[$x]; ?>
var data<?php echo strtolower($ln['symbol']); ?> = [];
	<?php
	}?>

var totalPoints = 100;
var updateInterval = 1000;
var now = new Date().getTime();

var Subscription = "";

<?php
	for($x=0;$x<count($lines);$x++)
	{ 
		$ln = $lines[$x]; ?>
var Value<?php echo $ln['symbol']; ?> = "";
	<?php
	}?>
 
function GetData() {
	
	<?php
	for($x=0;$x<count($lines);$x++)
	{ 
		$ln = $lines[$x]; ?>
	if (data<?php echo strtolower($ln['symbol']);?> == null) return;
    data<?php echo strtolower($ln['symbol']);?>.shift(); //to remove first item of array
 
    while (data<?php echo strtolower($ln['symbol']);?>.length < totalPoints) {    
        var y = 0+Value<?php echo $ln['symbol'];?>;
        var temp = [now += updateInterval, y]; //data format [x, y]
 
        data<?php echo strtolower($ln['symbol']);?>.push(temp);
    }
	<?php
	}?>
}

var chartoptions = {
    series: {
        lines: {
            show: true,
            lineWidth: 2,
            fill: false
        }
    },
    xaxis: {
        mode: "time",
        tickSize: [2, "second"],
        tickFormatter: function (v, axis) {
            var date = new Date(v);

            if (date.getSeconds() % 20 == 0) {
                var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
                var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
                var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();

                return hours + ":" + minutes + ":" + seconds;
            } else {
                return "";
            }
        },
        axisLabel: "Time",
        axisLabelUseCanvas: true,
        axisLabelFontSizePixels: 12,
        axisLabelFontFamily: 'Verdana, Arial',
        axisLabelPadding: 10
    },
    yaxis: {
        min: <?php echo $min;?>,
        max: <?php echo $max;?>,        
        tickSize: <?php echo round(($max - $min) / 10); ?>,
        tickFormatter: function (v, axis) {            
           return v + "<?php echo $units; ?>";
        },
        axisLabel: "--",
        axisLabelUseCanvas: true,
        axisLabelFontSizePixels: 12,
        axisLabelFontFamily: 'Verdana, Arial',
        axisLabelPadding: 6
    },
    legend: {        
		show: false,
        labelBoxBorderColor: "#fff"
    },
    grid: {                
        backgroundColor: "#000000",
        tickColor: "#008040"
    }
};

</script>
              

		<div id="chartelement" style="width:80%;height:350px; margin-left: auto; margin-right: auto;"></div>
		<br/>
		
		<?php
		$wd = count($matches);
		$ht = 0;
		$cols = array();
		$x = 0;
		$ttl = 0;
		foreach($matches as $k => $v)
		{
			$cols[$k] = $x;
			if (count($v) > $ht) $ht = count($v);
			$x++;
			$ttl += count($v);
		}
		
		$cellwidth = 100 / $wd;
		
		echo '<table style="margin-left: auto; margin-right: auto; border: silver; width: 80%">';
		if ($mode == "vertical")
		{
			$cellwidth = 100 / $ttl;
		
			//Very simple table, since structure is flat...
			echo '<tr>';
			foreach($matches as $k => $v)
			{
				foreach($v as $d)
				{
					$code = $d['originid'].':'.$d['propertyid'].':measurement';
					//OK - find a suitable line...
					foreach($lines as $l)
					{
						if($l['code'] == $code)
						{
							$line = $l;
							break;
						}
					}
					echo '<td style="padding: 10px; background-color: #EEEEEE; text-align: center; border-right: 1px solid white; width: '.$cellwidth.'%;">'.$d['assetname'].'<h3 style="color: '.$line['colour'].'" class="currentvalue'.strtolower($line['symbol']).'">[ ]</h3></td>';
				}
			}
			echo '</tr>';
		}
		else
		{
			//Complex, multi-layerd structure...
			$x = 0;
			
			for($x = 0;$x<$ht;$x++)
			{
				echo '<tr>';
				foreach($matches as $k => $v)
				{
					if (isset($v[$x]))
					{
						$code = $v[$x]['originid'].':'.$v[$x]['propertyid'].':measurement';
						//OK - find a suitable line...
						foreach($lines as $l)
						{
							if($l['code'] == $code)
							{
								$line = $l;
								break;
							}
						}
						echo '<td style="padding: 10px; background-color: #EEEEEE; text-align: center; border-right: 1px solid white; width: '.$cellwidth.'%;">'.$v[$x]['assetname'].'<h3 style="color: '.$line['colour'].'" class="currentvalue'.strtolower($line['symbol']).'">[ ]</h3></td>';
					}
					else
					{
						echo '<td>&nbsp;</td>';
					}
				}
				echo '</tr>';
			}
		}

		echo '</table>';
		?>
		<!--Current Value(s)
		<h3><span id="currentvaluea">Waiting</span> / <span id="currentvalueb">Waiting</span></h3>-->
  
    <?php
	//}
	
?>