<?php
/**
 * Displays a 'live' graph of process values
 *
 * This module requires that your have a Consolidation server running
 *
 * @author Steven Harding
 */
	$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
	if ($itemid === FALSE) exit;
	
	$assetid = $itemid;

	include($installfolder.'/model/asset.php');

	$thisasset = new Asset($itemid);
	$thisasset->Load();
	
	if (isset($_REQUEST['prop']))
	{
		$property = $_REQUEST['prop'];
	}
	
	if (!isset($property)) exit;
	$propid = $property;
	
	$query = $db->query('SELECT * FROM properties JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE assetid='.$itemid.' AND properties.id = '.$property);

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$propdata = $row;
	}

	$title = $thisasset->name.' '.$propdata['name'].' Historical Trends';

	global $installfolder;

	include('include/tmpl.php');
	
	$isdynamic = false;
	
	$query = $db->query('SELECT * FROM datalinks WHERE assetid='.$itemid.' AND propertyid = '.$property.' AND node=\'measurement\'');

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$dynamic = $row;
		$isdynamic = true;
	}

	$code = $itemid.":".$property.":measurement";

	$values = explode('|',$propdata['value']);
	$units = $values[1];
	$min = 0;
	$max = 100;
	
	$profile = 1;
	
	$places = "";
	if ($values[2] != "") $min = $values[2];
	if ($values[3] != "") $max = $values[3];
	if (isset($values[4]))
	{		
		$places = $values[4];
	}
	
	if ($places == "")
	{
		$places = 2;
	}

	//$template->StartSection('onload');
	
	$hostname = $_SERVER['HTTP_HOST'];
	$hostname = explode(':',$hostname)[0];
	
	if ($isdynamic == false) {
	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title='.$propdata['name'].' @ '.$thisasset->name);?>
				
				<h3>This asset is not linked to live data, so it can not be charted.</h3><?php
	}
	else
	{
	?>
	dataset = [
        { label: "Measurement", data: data, color: "#00FF00" }
	];	
    
    var optionSet2 = {
        startDate: moment().startOf('day'),
        endDate: moment().endOf('day'),
        showDropdowns: true,
        timePicker: true,
        opens: 'left',
        ranges: {
               'Today': [moment().startOf('day'), moment().endOf('day')],
               'Yesterday': [moment().subtract(1, 'days').startOf('day'), moment().subtract(1, 'days').endOf('day')],
               'Last 7 Days': [moment().subtract(6, 'days').startOf('day'), moment().endOf('day')],
               'Last 30 Days': [moment().subtract(29, 'days').startOf('day'), moment().endOf('day')],
               'This Month': [moment().startOf('month'), moment().endOf('month').endOf('day')],
               'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
                }
     };

     $('#range span').html(moment().startOf('day').format('MMMM D, YYYY') + ' - ' + moment().endOf('day').format('MMMM D, YYYY'));

	var cb = function(start, end, label) {         
         $('#range span').html(start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY'));
         UpdateChart(start,end);
     }

	//alert('Initiating!')
    $('#range').daterangepicker(optionSet2, cb);
	
	UpdateChart(moment().startOf('day'),moment().endOf('day'));
<?php	
	SS('onload');?>
	<script src="/plugins/flot/jquery.flot.js"></script>
	<script src="/plugins/flot/jquery.flot.time.js"></script>
	<script src="/plugins/flot/jquery.flot.axislabels.js"></script>
	
	<script src="/plugins/daterangepicker/moment.js"></script>
	<script src="/plugins/daterangepicker/daterangepicker.js"></script>
<?php
	SS('addscripts');?>
	<link rel="stylesheet" href="/plugins/daterangepicker/daterangepicker-bs3.css">
<?php
	SS('head');
	
	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title='.$propdata['name'].' @ '.$thisasset->name);
				
		$query = $db->query('SELECT gatewayport FROM datalinks JOIN datasources ON ( datalinks.sourceid = datasources.assetid ) WHERE datalinks.assetid='.$itemid.' AND propertyid='.$property.' AND node='.$db->quote('measurement').' AND datalinks.mode=0');
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$sourceport = $row['gatewayport'];
			}
		}
		?>
		<a href="#" id="exportlink" class="btn btn-success">Export</a>&nbsp;&nbsp;<?php
		if (isset($sourceport)) 
		{ ?>
		
				<a href="<?php echo $siteroot; ?>/measurement/<?php echo $assetid; ?>/<?php echo $propid; ?>" class="btn btn-default">Show Live</a>&nbsp;&nbsp;<?php }; ?>
				<a href="<?php echo $siteroot; ?>/dashboard/<?php echo $thisasset->id;?>" class="btn btn-default">Asset Dashboard</a>
<?php
		SS('footer');
	
?>  

<script>

	var data = [];
var totalPoints = 100;
var now = new Date().getTime();

var Value = "";
 
dataset = [
        { label: "Measurement", data: data, color: "#00FF00" }
];

var chartoptions = {
    series: {
        lines: {
            show: true,
            lineWidth: 1.2,
            fill: true
        }
    },
    xaxis: {
        mode: "time",
        tickSize: [8, "hour"],
        tickFormatter: function (v, axis) {
            var date = new Date(v);

            //if (date.getSeconds() % 20 == 0) {
                var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
                var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
                var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();

                return hours + ":" + minutes + ":" + seconds;
            //} else {
            //    return "";
            //}
        },
        axisLabel: "Time",
        axisLabelUseCanvas: true,
        axisLabelFontSizePixels: 12,
        axisLabelFontFamily: 'Verdana, Arial',
        axisLabelPadding: 10
    },
    yaxis: {
        min: <?php echo $min;?>,
        max: <?php echo $max;?>,        
        tickSize: <?php echo round((($max - $min) / 10)); ?>,
        tickFormatter: function (v, axis) {           
		      return v + "<?php echo $units; ?>";
        },
        axisLabel: "<?php echo $propdata['name'];?>",
        axisLabelUseCanvas: true,
        axisLabelFontSizePixels: 12,
        axisLabelFontFamily: 'Verdana, Arial',
        axisLabelPadding: 6
    },
    legend: {        
		show: false,
        labelBoxBorderColor: "#fff"
    },
    grid: {                
        backgroundColor: "#000000",
        tickColor: "#008040"
    }
};

stime = 0
etime = 0

function UpdateChart(start,end) {	

	$('#chartelement').fadeOut(250);
	stime = start
	etime = end

	//alert("/api/gethistory?id=<?php echo $itemid;?>&start=" + start + "&end=" + end + "&property=<?php echo $property;?>&node=measurement");
	
	$.get("<?php echo $siteroot;?>/api/gethistory?id=<?php echo $itemid;?>&start=" + start + "&end=" + end + "&property=<?php echo $property;?>&node=measurement&profile=<?php echo $profile;?>&qry=<?php echo rand(0,999999); ?>",null,function (data) {		
		//alert('Loading Data...');	
		GetData(data);
	}).error(function(XMLHttpRequest, textStatus) {
		alert('Load Failure - ' + textStatus);
	});
}
 
function GetData(content) {
				
	dataset = [
        { label: "Measurement", data: content.records, color: "#00FF00" }
	];	
			
	if ((content.records == null) || (content.records.length <= 1))
	{
		//alert('No Data Available For That Period');
		
		//$.plot($("#chartelement"), dataset, chartoptions);
		
		$("#chartelement").html('<div><h4>Sorry, but no historical data was found within that span of time.</div>');
		$('#chartelement').css('height','auto');
		$('#chartelement').fadeIn(250);
		$('#exportlink').attr('href','<?php echo $siteroot; ?>/measurements/exporthistory?id=<?php echo $itemid; ?>&prop=<?php echo $property; ?>&start=' + stime + '&end=' + etime);
		
		diff = (etime - stime) / 1000;
		return;
	}
	else
	{			
		$('#chartelement').css('height','400px');
		diff = (content.records[content.records.length-1][0] - content.records[0][0]) / 1000;
	}
	
	
	units = 'minute';
	amount = 1;
	
	//console.log("Chart Difference : " + diff);
	
	if (diff > 259200)
	{
		units = 'day';
		amount = diff / 86400;
		amount /= 8.0;
		//if (amount < 1) amount = 1;				
	}	
	else
	{
		if (diff > 600)
		{
			units = 'hour';
			amount = diff / 3600;
			amount /= 8.0;
			//if (amount < 1) amount = 1;
		}
	}
			
	chartoptions.xaxis.tickSize = [amount,units];	
	
	$.plot($("#chartelement"), dataset, chartoptions);
	$('#chartelement').fadeIn(250);
	
	//alert('Generated Chart!');
	
	$('#exportlink').attr('href','<?php echo $siteroot; ?>/measurements/exporthistory?id=<?php echo $itemid; ?>&prop=<?php echo $property; ?>&start=' + stime + '&end=' + etime);
    
}

</script>
             
	<div id="range" class="" style="background: #fff; cursor: pointer; padding: 5px 10px; border: 1px solid #ccc; margin-left: auto; margin-right: auto; width: 425px;">
                  <i class="glyphicon glyphicon-calendar fa fa-calendar"></i>
                  <span></span> <b class="caret"></b>
               </div>

		<div id="chartelement" style="width:90%;height: 400px; margin-left: auto; margin-right: auto; text-align: center;"></div>
  
    <?php
	}
	
?>