<?php
/**
 * Displays a 'live' graph of process values
 *
 * This module requires that your have a Consolidation server running
 *
 * @author Steven Harding
 */
	$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
	if ($itemid === FALSE) exit;
	
	$assetid = $itemid;

	include($installfolder.'/model/asset.php');

	$thisasset = new Asset($itemid);
	$thisasset->Load();
	
	if (isset($_REQUEST['prop']))
	{
		$property = $_REQUEST['prop'];
	}
	
	if (!isset($property)) exit;
	$propid = $property;
	
	$profile = 1;
	if (isset($_REQUEST['profile']))
	{
		$profile = $_REQUEST['profile'];
		$profile = filter_var($profile,FILTER_VALIDATE_INT);
		if ($profile === FALSE) exit;
	}
	
	$query = $db->query('SELECT * FROM profiles WHERE id='.$profile);

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$profdata = $row;
	}
	
	if (!isset($profdata))
	{
		exit();
	}
	
	$profilename = $profdata['name'];
	$port = $profdata['reqport'];
	$shost = $profdata['address'];
	
	$vx = $_SERVER['HTTP_HOST'];
	$ps = strpos($vx,'/');
	if ($ps !== FALSE)
	{
		$vx = substr($vx,0,$ps);
	}
	$host = $vx;
		
	if (($shost != '') && ($shost != 'localhost'))
	{
		$host = $shost;
	}
	
	$query = $db->query('SELECT * FROM properties JOIN assetvalues ON (assetvalues.propertyid = properties.id) WHERE assetid='.$itemid.' AND properties.id = '.$property);

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$propdata = $row;
	}

	$title = $thisasset->name.' '.$propdata['name'].' '.$profilename.' Live Trend';

	global $installfolder;

	include('include/tmpl.php');
	
	$isdynamic = false;
	
	/*$query = $db->query('SELECT * FROM datalinks WHERE assetid='.$itemid.' AND propertyid = '.$property.' AND node=\'measurement\'');

	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$dynamic = $row;
		$isdynamic = true;
	}*/

	$code = $itemid.":".$property.":measurement";
	
	//include($installfolder.'/model/asset.php');
	
	
	$propid = $property;
	$thisasset = new Asset($itemid);
	$lprop = $thisasset->GetLocalProperties();
	$thisasset->GetValues($lprop);
	
	$defaults = array();
	foreach($lprop as $p)
	{
		if ($p->id == $propid)
		{
			$defaults = $p;
			break;
		}
	}

	$values = $defaults->value;
	
	if(isset($values['_dynamics'])) 
	{
		//$dynamic = $row;
		$isdynamic = true;
	}
	
	$units = $values['units'];
		
	$min = 0;
	$max = 100;
	
	$places = "";
	$min = $values['min'];
	$max = $values['max'];
	$places = $values['places'];
	
	if ($min == $max)
	{
		$min = 0;
		$max = $values['measurement'] * 2;
	}
	
	if ($places == "")
	{
		$places = 2;
	}

	//$template->StartSection('onload');
	
	$hostname = $_SERVER['HTTP_HOST'];
	$hostname = explode(':',$hostname)[0];
	
	if ($isdynamic == false) {
	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title='.$propdata['name'].' @ '.$thisasset->name);?>
				
				<h3>This asset is not linked to live data, so it can not be charted.</h3><?php
	}
	else
	{
	?>
	$.plot($("#chartelement"), dataset, chartoptions);
	update();
	GetData();
	Subscribe();
<?php	
	SS('onload');?>
	<script src="/plugins/flot/jquery.flot.js"></script>
	<script src="/plugins/flot/jquery.flot.time.js"></script>
	<script src="/plugins/flot/jquery.flot.axislabels.js"></script>
<?php
	SS('addscripts');?>
<?php
	SS('head');
	
	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('full');
				ST('box','title='.$propdata['name'].' @ '.$thisasset->name);
				
		$query = $db->query('SELECT gatewayport FROM datalinks JOIN datasources ON ( datalinks.sourceid = datasources.assetid ) WHERE datalinks.assetid='.$itemid.' AND propertyid='.$property.' AND node='.$db->quote('measurement').' AND datalinks.mode=1');
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$sourceport = $row['gatewayport'];
			}
		}
		if (isset($sourceport)) 
		{ ?>
		
				<a href="<?php echo $siteroot; ?>/history/<?php echo $assetid; ?>/<?php echo $propid; ?>" class="btn btn-default">Show History</a>&nbsp;&nbsp;<?php }; ?>
				<a href="<?php echo $siteroot; ?>/dashboard/<?php echo $thisasset->id;?>" class="btn btn-default">Asset Dashboard</a>
<?php
		
		SS('footer');
	
?>  

<script>

	
	
	function Subscribe()
	{
		$.get('http://<?php echo $host;?>:<?php echo $port;?>/subscribe?codes=<?php echo $code;?>&format=json',{ },function (data) {
			Subscription = data.id;
			Value = Math.round(data.items[0].value * 1<?php echo str_repeat('0',$places);?>) / 1<?php echo str_repeat('0',$places);?>;
			$('#currentvalue').html(Value + '<?php echo $units;?>');
			setTimeout(Subdate, updateInterval);
		});
	}
	
	function Subdate()
	{
		$.get('http://<?php echo $host;?>:<?php echo $port;?>/update?id=' + Subscription + '&format=json',{ },function (data) {
			Subscription = data.id;
			if ((data.items) && (data.items.length > 0))
            {
            	Value = Math.round(data.items[0].value * 1<?php echo str_repeat('0',$places);?>) / 1<?php echo str_repeat('0',$places);?>;
				$('#currentvalue').html(Value + '<?php echo $units;?>');
            }
			setTimeout(Subdate, updateInterval);
		});
	}

    dataset = [
        { label: "CPU", data: data, color: "#00FF00" }
    ];

    function update() {
        GetData();
		
		dataset = [
			{ label: "CPU", data: data, color: "#00FF00" }
		];

        $.plot($("#chartelement"), dataset, chartoptions)
        setTimeout(update, updateInterval);
    }

var data = [];
var totalPoints = 100;
var updateInterval = 1000;
var now = new Date().getTime();

var Subscription = "";
var Value = "";
 
function GetData() {
	if (data == null) return;
    data.shift(); //to remove first item of array
 
    while (data.length < totalPoints) {    
        var y = 0+Value;
        var temp = [now += updateInterval, y]; //data format [x, y]
 
        data.push(temp);
    }
}

var chartoptions = {
    series: {
        lines: {
            show: true,
            lineWidth: 1.2,
            fill: true
        }
    },
    xaxis: {
        mode: "time",
        tickSize: [2, "second"],
        tickFormatter: function (v, axis) {
            var date = new Date(v);

            if (date.getSeconds() % 20 == 0) {
                var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
                var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
                var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();

                return hours + ":" + minutes + ":" + seconds;
            } else {
                return "";
            }
        },
        axisLabel: "Time",
        axisLabelUseCanvas: true,
        axisLabelFontSizePixels: 12,
        axisLabelFontFamily: 'Verdana, Arial',
        axisLabelPadding: 10
    },
    yaxis: {
        min: <?php echo $min;?>,
        max: <?php echo $max;?>,        
        tickSize: <?php echo round(($max - $min) / 10); ?>,
        tickFormatter: function (v, axis) {            
           return v + "<?php echo $units; ?>";
        },
        axisLabel: "<?php echo $propdata['name'];?>",
        axisLabelUseCanvas: true,
        axisLabelFontSizePixels: 12,
        axisLabelFontFamily: 'Verdana, Arial',
        axisLabelPadding: 6
    },
    legend: {        
		show: false,
        labelBoxBorderColor: "#fff"
    },
    grid: {                
        backgroundColor: "#000000",
        tickColor: "#008040"
    }
};

</script>
              

		<div id="chartelement" style="width:80%;height:350px; margin-left: auto; margin-right: auto;"></div>
		<br/>
		Current Value
		<h3 id="currentvalue">Waiting</h3>
  
    <?php
	}
	
?>