<?php

function badrequest($message) {
    $protocol = (isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0');
    header($protocol . ' ' . 400 . ' Bad Request');
    echo '<h1>Bad request</h1>';
    echo '<p>', $message, '</p>';
    exit;
}

function hex2rgb($hex) {
   $hex = str_replace("#", "", $hex);

   if(strlen($hex) == 3) {
      $r = hexdec(substr($hex,0,1).substr($hex,0,1));
      $g = hexdec(substr($hex,1,1).substr($hex,1,1));
      $b = hexdec(substr($hex,2,1).substr($hex,2,1));
   } else {
      $r = hexdec(substr($hex,0,2));
      $g = hexdec(substr($hex,2,2));
      $b = hexdec(substr($hex,4,2));
   }
   $rgb = array($r, $g, $b);
   //return implode(",", $rgb); // returns the rgb values separated by commas
   return $rgb; // returns an array with the rgb values
}

/*function rgb_to_hsv(r, g, b):
    maxc= max(r, g, b);
    minc= min(r, g, b);
    v= maxc
    if minc == maxc then return (0, 0, v)
    diff= maxc - minc
    s= diff / maxc
    rc= (maxc - r) / diff
    gc= (maxc - g) / diff
    bc= (maxc - b) / diff
    if r == maxc then
        h= bc - gc
    else if g == maxc then
        h= 2.0 + rc - bc
    else
        h = 4.0 + gc - rc
    h = (h / 6.0) % 1.0 //comment: this calculates only the fractional part of h/6
    return (h, s, v)

function hsv_to_rgb(h, s, v):
    if s == 0.0 then return (v, v, v)
    i= int(floor(h*6.0)) //comment: floor() should drop the fractional part
    f= (h*6.0) - i
    p= v*(1.0 - s)
    q= v*(1.0 - s*f)
    t= v*(1.0 - s*(1.0 - f))
    if i mod 6 == 0 then return v, t, p
    if i == 1 then return q, v, p
    if i == 2 then return p, v, t
    if i == 3 then return p, q, v
    if i == 4 then return t, p, v
    if i == 5 then return v, p, q*/

function lerp($a,$b,$perc)
{
	return round($a + (($b-$a) * $perc));
}
	
function collerp($rgb1,$rgb2,$perc)
{
	$r = lerp($rgb1[0],$rgb2[0],$perc);
	$g = lerp($rgb1[1],$rgb2[1],$perc);
	$b = lerp($rgb1[2],$rgb2[2],$perc);
	return array($r,$g,$b);
}

    try {
        //Check to see if this file is already cached....
		
		$sp = $_REQUEST['sp'];
	
		$fn = $sitefolder.'/media/display/responses/gradient_'.$sp.'.png';
		if (file_exists($fn))
		{
			ob_start();
			readfile($fn);
			$dta = ob_get_clean();
			
			header('Cache-control: public, max-age='.(60*60*24*30));
			header('Expires: '.gmdate(DATE_RFC1123,time()+60*60*24*30));
			header("Content-Type: image/png");
			header("Content-Length: " . strlen($dta));
			header('Content-Disposition: inline; filename="gradienttexture.png"');			
			
			echo $dta;
			exit;
		}
	
		$bits = explode('_',$sp);
		
		$stops = array();
		for($x=0;$x<count($bits);$x+=4)
		{
			$st = array();
			$st['color'] = $bits[$x];
			$st['point'] = $bits[$x+1] / 100;
			$stops[] = $st;
		}
				
		$indx = 0;
		$prevstop = $stops[0];
		if($prevstop['point'] > 0)
		{
			$nextstop = $stops[0];
			$prevstop['point'] = 0;
		}
		else
		{
			$indx = 1;
			$nextstop = $stops[1];
		}
		
		$prevpoint = $prevstop['point'];
		$prevcolor = hex2rgb($prevstop['color']);
		
		$nextpoint = $nextstop['point'];
		$nextcolor = hex2rgb($nextstop['color']);
		
		$img = imagecreatetruecolor(300,16);
		for($x=0;$x<300;$x++)
		{
			$perc = $x / 300;
			if ($perc >= $nextpoint)
			{
				$prevcolor = $nextcolor;
				$prevstop = $nextstop;
				$prevpoint = $nextpoint;
				
				$indx++;
				
				if ($indx >= count($stops))
				{
					$nextstop = $prevstop;
					$nextcolor = $prevcolor;
					$nextpoint = 100;
				}
				else
				{				
					$nextstop = $stops[$indx];
					$nextcolor = hex2rgb($nextstop['color']);
					$nextpoint = $nextstop['point'];
				}
			}
			
			$p2perc = $perc - $prevpoint;
			$p2perc /= ($nextpoint - $prevpoint);
						
			$cl = collerp($prevcolor,$nextcolor,$p2perc);
			
			//echo 'PA = '.$prevcolor[0].','.$prevcolor[1].','.$prevcolor[2].' - '.$nextcolor[0].','.$nextcolor[1].','.$nextcolor[2].' @ '.$p2perc.' = '.$cl[0].','.$cl[1].','.$cl[2].'<br/>';
			
			$colour = imagecolorallocate($img,$cl[0],$cl[1],$cl[2]);
			imageline($img,$x,0,$x,15,$colour);
		}
		
		ob_start();
		imagepng($img);
		$dta = ob_get_clean();
		
		header('Cache-control: public, max-age='.(60*60*24*30));
        header('Expires: '.gmdate(DATE_RFC1123,time()+60*60*24*30));
        header("Content-Type: image/png");
        header("Content-Length: " . strlen($dta));
        header('Content-Disposition: inline; filename="gradienttexture.png"');
		
		echo $dta;
		
		$xn = $sitefolder.'/media/display';
		if (!file_exists($xn))
		{
			mkdir($xn);
		};
		$xn = $xn.'/responses';
		if (!file_exists($xn))
		{
			mkdir($xn);
		};
		
		$fp = fopen($fn, 'w');
		fwrite($fp, $dta);
		fclose($fp);
		
		imagedestroy($img);

        //fallback to live generation if cache file is not writable
        //$gradient->renderGradient();
    }
    catch(Exception $e) {
        badrequest($e->getMessage());
    }
