<?php
/** Reads a spreadsheet file 
* This module reads a CSV file and creates assets, data bindings and relationships based on the content.
**/


	//Prepare all of the local variables...
	
	$debugmode = true;
	$mdonly = false;
	
	$debug = true;
	$errorscan = true;
	global $errorscan;
	
	$findfailures = array();
	$errors = array();
	
	$properties = array();
	$relationships = array();
	
	$merge = false;
	if (isset($_REQUEST['mode']))
	{
		if ($_REQUEST['mode'] == 'merge')
		{
			$merge = true;
		}
	}
	
	//This function saves a property record.
	function CommitProperty($info)
	{
		global $db;
		global $errorscan;
		$options = '';
		if (isset($info['options']))
		{
			$options = $info['options'];
		}
		$type = 'TEXT';
		if (isset($info['type']))
		{
			$type = $info['type'];
		}
		//exit;
		
		$qry = 'SELECT COUNT(*) as cnt FROM properties WHERE name='.$db->quote($info['name']);
		$query = $db->query($qry);
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['cnt'] > 0) return;
		}
				
		$qry = 'INSERT INTO properties (name,typename,options,builtin) VALUES ('.$db->quote($info['name']).','.$db->quote(strtoupper($type)).','.$db->quote($options).',0)';
		if ($errorscan == true)
			echo $qry;
		else
			$db->query($qry);

	}
	
	//This function saves a relationship record.
	function CommitRelationship($info)
	{
		global $db;
		global $errorscan;
		
		//print_r($db->errorInfo());
		
		$upstream = '';
		if (isset($info['upname']))
		{
			$upstream = $info['upname'];
		}
		$downstream = '';
		if (isset($info['downname']))
		{
			$downstream = $info['downname'];
		}
		$type = 'physical';
		if (isset($info['style']))
		{
			$type = $info['style'];
		}
		$style = 0;
		if ($type == "logical") $style = 1;
		
		$qry = 'SELECT COUNT(*) as cnt FROM relationships WHERE name='.$db->quote($info['name']);
		$query = $db->query($qry);
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['cnt'] > 0) return;
		}
		
		$qry = 'INSERT INTO relationships (name,upstreamname,downstreamname,style) VALUES ('.$db->quote($info['name']).','.$db->quote($upstream).','.$db->quote($downstream).','.$style.')';
		if ($errorscan == true)
			echo $qry.'<br/>';
		else
		{
			//echo " - ".$qry.'<br/>';
			$db->query($qry);
			//print_r($db->errorInfo());
			if ($db->lastInsertId() == 0)
			{
				echo 'Request Failed!<br/>';
			}
		}
		//exit;
	}
	
	//If 'Commit' is enabled, this is the real thing and database updates should be made.
	if (isset($_REQUEST['commit']))
	{
		if (strpos($_REQUEST['commit'],'/') !== FALSE) exit;
		if (strpos($_REQUEST['commit'],'\\') !== FALSE) exit;
		$finalfilename = $sitefolder.'/cache/tmp/form.txt';
		
		if (file_exists($finalfilename))
		{
			$errorscan = false;
			$debug = false;
		}
		else
		{
			exit;
		}
	}
	
	if (isset($exportlocation))
	{
		$finalfilename = $exportlocation;
	}
	
	//Prepare Output
	$parentrel = 2;
	if (isset($_REQUEST['parentrelationship']))
	{
		$parentrel = $_REQUEST['parentrelationship'];
	}
	else
	{
		$_REQUEST['parentrelationship'] = $parentrel;
	}
	
	if (!class_exists('Relationship'))
		include($installfolder.'/model/relationship.php');
	
	if (($errorscan == true) || ($debug == false))
	{
		ob_start();
		echo 'Starting Test...';
	}
	
	if (!function_exists("LogEvent"))
	{	
		include($installfolder.'/include/logging.php');
	}

	if (!isset($finalfilename))
	{
		//Get the file & check validity
		if ($_FILES["content"]["error"] > 0) 
		{
			echo "Error: " . $_FILES["content"]["error"] . "<br>";
			exit;
		}
		else
		{	
			//Sanity-check the file size
			if (($_FILES["content"]["size"] / 1024) > 10240)
			{
				echo 'Error: File To Large';
				unlink($_FILES["content"]["tmp_name"]);
				exit();
			}
			
			//Check for a suitable extension
			$ext = pathinfo ( $_FILES["content"]["name"],PATHINFO_EXTENSION);		
			
			if ((trim(strtolower($ext)) != "txt") && (trim(strtolower($ext)) != "csv"))
			{
				echo 'Error: Incorrect File Extension. Forms should be uploaded as TXT files';
				unlink($_FILES["content"]["tmp_name"]);
				exit();
			}
			
			//Copy the file into a local temp folder and remove the original
			$dirname = $sitefolder.'/cache/tmp';
			if (!file_exists($dirname))
			{
				mkdir($dirname);
			}
			
			if (!file_exists($dirname)) mkdir($dirname);
			
			$finalfilename = $sitefolder.'/cache/tmp/form.txt';
			
			$fname = $dirname. '/form.txt';
			move_uploaded_file($_FILES["content"]["tmp_name"],$fname);
		};
	}
	else
	{
		$fname = $finalfilename;
	}
	
	//Get a list of profile names (query optimisation)
		
	$idmapping = array();
	$profilelookup = array();
	$query = $db->query('SELECT name,id FROM profiles ORDER BY name ASC');

	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$profilelookup[$row['name']] = $row['id'];
	}
		
		
		//Begin the import
		echo 'Loading Form Contents...<br/><br/>';
		
		$file = fopen($fname,"r");
	
		echo 'Opened File';
		
		$addmode = 'asset';
		
		//Load names of properties and relationships
		
		$loadedmd = false;
		
		$bindings = array();
		$relbindings = array();
		
		$bindings = array();
		$assetdetails = array();
		$relations = array();
		
		$indx = 0;
		
		$lastpos = array();
		$changed = array();
		
		$propcount = 0;
		$relcount = 0;
		$bindcount = 0;
		
		$datasources = array();
		
		//Get the expected next property number.
		//Note that these values aren't used as such - they are just there to differentiate EXISTING and NEW assets during a merge operation.
		
		$importid = 100;
		$query = $db->query('SELECT MAX(ID) as mx FROM assets');
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$importid = $row['mx']+1;
		}
		
		$createdprops = array();
		$createdrels = array();
		
		$references = array();
		
		//Load the contents of each line of the file...
		
		$lineno = 0;
		while(!feof($file))
  		{

			$lines = fgetcsv($file,0,"\t");
			$lineno++;

			//Filter out blank lines and nonsense.
			if (count($lines) <= 2) 
			{
				continue;
			}
			
			
			//Reset the 'Changed Columns'
			$validchanges = false;
			for($x=0;$x<count($lines);$x++)
			{
				$changed[$x] = false;
			}
			
			//Find if particular columns have changed...
			for($x=0;$x<count($lines);$x++)
			{
				if (trim($lines[$x]) != "")
				{
					$lastpos[$x] = $lines[$x];
					$changed[$x] = true;
					$validchanges = true;
				}
				else
				{
					if (isset($lastpos[$x]))
					{
						if ($validchanges == false)
						{
							$changed[$x] = false;
							$lines[$x] = $lastpos[$x];
						}
					}
				}
			}
			
			//If no changes have occured, go to the next line
			
			if ($validchanges == false) continue;
			
			if ($changed[0] == false)
			{
				//If the asset name has NOT changed...
				
				if ($addmode == "relationship")
				{
					//Load a relationship asset...
					if ($changed[1] == false)
					{
						echo 'Relationship '.$lines[1].' Attribute '.$lines[2].' = '.$lines[3].'<br/>';
						$rinfo[$lines[2]] = $lines[3];
					}
					else
					{
						CommitRelationship($rinfo);
						$relcount++;
						$createdrels[] = $rinfo['name'];
						echo 'Reached A New Relationship';
						$rinfo = array();
						$rinfo['name'] = $lines[1];
						$rinfo[$lines[2]] = $lines[3];
					}
					continue;
				}
				if ($addmode == "property")
				{
					//Load a property asset
					if ($changed[1] == false)
					{
						echo 'Property '.$lines[1].' Attribute '.$lines[2].' = '.$lines[3].'<br/>';
						$pinfo[$lines[2]] = $lines[3];
					}
					else
					{
						CommitProperty($pinfo);
						$createdprops[] = $pinfo['name'];
						$propcount++;
						$pinfo = array();
						$pinfo['name'] = $lines[1];
						$pinfo[$lines[2]] = $lines[3];
						echo 'Reached A New Property';
					}
					continue;
				}
			}
			else
			{
				//If the asset name HAS changed...
				
				//Save the existing asset
				if (isset($as))
				{
					$assetdetails[$as['id']] = $as;
				}
				
				//Check to see if this is a special asset type...
				if ($addmode == "property")
				{
					CommitProperty($pinfo);
					$createdprops[] = $pinfo['name'];
					$propcount++;
				}
				
				if ($addmode == "relationship")
				{
					CommitRelationship($rinfo);
					$createdrels[] = $rinfo['name'];
					$relcount++;
				}
				
				$addmode = "asset";
				
				if ($lines[0] == "_property")
				{
					$addmode = "property";
				}
				
				if ($lines[0] == "_relationship")
				{
					$addmode = "relationship";
				}
				
				if ($addmode == "asset")
				{
					//Load metadata (property and relationship names), as these may have been created in earlier lines.
					if ($loadedmd == false)
					{
						$query = $db->query('SELECT name,id,typename,options FROM properties ORDER BY name ASC');
		
						while($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							$properties[$row['id']]['name'] = $row['name'];
							$properties[$row['id']]['type'] = $row['typename'];
							
							$properties[$row['id']]['defaults'] = array();
							
							$split = explode(':',$row['options']);
							foreach($split as $q)
							{
								$px = explode('=',$q);
								if (count($px) > 1)
								{
									if ($px[0] == 'default')
									{
										$properties[$row['id']]['defaults'] = explode('|',$px[1]);
									}
								}
							}
						}	
						
						$query = $db->query('SELECT name,id FROM relationships ORDER BY name ASC');
					
						while($row = $query->fetch(PDO::FETCH_ASSOC)) 
						{
							$relationships[$row['id']] = $row['name'];
						}	
						$loadedmd = true;
					}
					
					//Check to see if the asset exists already during a merge...
					$exists = false;
					if ($merge == true)
					{
						if (($lines[1] == "id") || ($lines[1] == "_id"))
						{
							$as['id'] = $lines[2];
							$as['refid'] = $lines[2];
						
							$aid = filter_var($lines[2],FILTER_VALIDATE_INT);
							
							$query = $db->query('SELECT COUNT(*) as Cnt FROM assets WHERE id='.$aid);
							
							if($row = $query->fetch(PDO::FETCH_ASSOC)) 
							{
								if ($row['Cnt'] > 1)
								{
									$exists = true;
									
									$as['exists'] = true;
									$as['realid'] = $aid;
									echo '<br/><br/>Found Existing Asset: ' . $lines[0]."<br/>";
								}
							}	
						}
					}
					
					//Set the name and ID of our new asset...
					
					$as = array();
					$as['name'] = $lines[0];
					$as['id'] = $importid;
					$importid++;
					
					if (count($assetdetails) == 0)
					{
						if (isset($_REQUEST['name']))
						{
							$as['name'] = $_REQUEST['name'];
						}
					}
					
					if (isset($as['realid']))
					{
						$idmapping[$as['id']] = $as['realid'];
					}
					
					if ($exists == false)
					{
						echo '<br/><br/>Creating New Asset: ' . $as['name']."<br/>";
					}
				}
				
				if ($addmode == "relationship")
				{
					//Do I already have a relationship with that name?
					//echo 'Relationship!<br/>';
					$rinfo = array();
					$rinfo['name'] = $lines[1];
					$rinfo[$lines[2]] = $lines[3];
					continue;
				}
				
				if ($addmode == "property")
				{
					//Do I already have a property with that name?
					//echo 'property<br/>';
					$pinfo = array();
					$pinfo[$lines[2]] = $lines[3];
					$pinfo['name'] = $lines[1];
					continue;
				}
			}	
			
			if ($changed[1] == true)
			{
				if (($lines[1] == 'desc') || ($lines[1] == 'description'))
				{
					$as['desc'] = $lines[2];
					continue;
				}
				
				if (($lines[1] == 'id') || ($lines[1] == '_id'))
				{
					$as['id'] = $lines[2];
					$as['refid'] = $lines[2];
					continue;
				}
				if ($lines[1] == '_type')
				{
					if ($lines[2] == "tag")
					{
						$as['_type'] = 1;
						$query = $db->query('SELECT id FROM assets WHERE name='.$db->quote($as['name']));
						
						if ($query !== FALSE)
						{
							if($row = $query->fetch(PDO::FETCH_ASSOC)) 
							{
								$as['realid'] = $row['id'];
								$idmapping[$as['id']] = $as['realid'];
								//$query->close();
							}	
						}
					}
					if ($lines[2] == "root")
						$as['_type'] = 2;
					continue;
				}
			}
			
			$found = false;
			
			//Find a matching property name...
		
			foreach($properties as $propid => $prop)
			{
				if ($lines[1] == "Location")
				{
					continue;
				}
				if ($prop['name'] == $lines[1])
				{
					$done = false;
					if ((!isset($lines[3])) || ($lines[3] == ""))
					{
						$done = true;
						$as['properties'][$propid]['_'] = $lines[2];
					}
					
					if ($done == false)
					{
						
						if ($lines[3][0] == '>')
						{
							echo 'Loading Binding!';
						
							//OK - time to get a binding going...
							$bnd = array();
							$dta = explode('>',$lines[3]);
							$bnd['profile'] = $dta[1];
							if (($dta[2][0] == 'L') || ($dta[2][0] == 'l'))
								$bnd['live'] = true;
							else
								$bnd['live'] = false;
								
							$bnd['source'] = $dta[3];
							$bnd['address'] = $dta[4];
							$bnd['asset'] = $lines[0];
							$bnd['node'] = strtolower($lines[2]);
							$bnd['property'] = $propid;
							$bnd['transform'] = "";
							$bnd['line'] = $lineno;
							
							$bindings[] = $bnd;
							$as['properties'][$propid][strtolower($lines[2])] = '0';
						}
						else
						{
							$as['properties'][$propid][strtolower($lines[2])] = $lines[3];
						}
					}
					echo '  Found Property Value - '.$lines[1].' = '.$lines[2].'<br/>';
					$found = true;
					break;
				}
			}
			
			if ($found == true) continue;
			
			//Find a matching relationship name...
			foreach($relationships as $k => $v)
			{
				if ($v == $lines[1])
				{
					if (!isset($as['relationships'][$lines[1]]))
					{
						$as['relationships'][$lines[1]] = array();
					}
					$as['relationships'][$lines[1]][] = $lines[2];
					
					if (!isset($relations[$as['id']]))
					{
						$relations[$as['id']] = array();
					}
					
					unset($id);
					$ps = strpos($lines[2],'(');
					if ($ps !== FALSE)
					{
						$psx = strpos($lines[2],')');
						if ($psx !== FALSE)
						{
							$id = trim(substr($lines[2],$ps+1,$psx-($ps+1)));
							$lines[2] = $id;
						}
					}
					
					$rel = array();
					if (isset($id))
						$rel['targetid'] = $id;
					else
					{
						//Convert the name to an ID (if possible)...
						$found = false;
						foreach($assetdetails as $ad)
						{
							if ($ad['name'] == $lines[2])
							{
								$rel['targetid'] = $ad['id'];
								break;
							}
						}
						if (!isset($rel['targetid']))
						{
							$rel['target'] = $lines[2];
						}
					}
					
					$rel['line'] = $lineno;
					$rel['relationship'] = $k;
					$relations[$as['id']][] = $rel;
					
					echo '  Found Relationship Value - '.$lines[1].' = '.$lines[2].'<br/>';
					$found = true;
					break;
				}
			}
			
			if ($found == true) continue;
			
			//Special Property Names...
			if ($lines[1] == "_source")
			{
				//Define data sourceid
				//echo 'Marking Asset as a Data Source<br/>';
				$bits = explode('>',$lines[2]);
				echo 'Adding Data Source - Profile '.$bits[0].', Mode '.$bits[1].', Driver '.$bits[2].', Address '.$bits[3].'<br/>';
				
				$bits[4] = $as['id'];
				$datasources[] = $bits; 
				$found = true;
			}
			
			if ($lines[1] == "_reference")
			{
				//Define a reference
				
				unset($aid);
				$ps = strpos($lines[2],'(');
				if ($ps !== FALSE)
				{
					$psx = strpos($lines[2],')');
					if ($psx !== FALSE)
					{
						$aid = trim(substr($lines[2],$ps+1,$psx-($ps+1)));
						$lines[2] = $aid;
					}
				}
				
				unset($bid);
				$ps = strpos($lines[3],'(');
				if ($ps !== FALSE)
				{
					$bid = trim(substr($lines[3],0,$ps));
					$lines[3] = $bid;
				}
				
				echo 'Creating Asset Reference To Asset '.$lines[2].', property '.$lines[3];
				
				$ar = array();
				$ar['on'] = $as['id'];
				$ar['to'] = $lines[2];
				$ar['prop'] = $lines[3];
				$references[] = $ar;
				$found = true;
			}
			
			//Don't report errors if the name matches a property or relationship that has been added.
			//  (This filter is for TESTING ONLY - the items appear in the correct metadata tables if they've been properly added)
			if ($found == false)
			{
				foreach($createdprops as $cp)
				{
					if ($cp == $lines[1])
					{
						$found = true;
						break;
					}
				}
			}
			
			if ($found == false)
			{
				foreach($createdrels as $cp)
				{
					if ($cp == $lines[1])
					{
						$found = true;
						break;
					}
				}
			}
			
			//Raise an error if we couldn't figure out what on earth a given input actually was.
			if ($found == false)
			{
				if (!in_array($lines[1],$findfailures))
				{
					$errors[] = 'Unable To find property or relationship \''.$lines[1].'\'.';
					$findfailures[] = $lines[1];
				}
				echo 'Unknown Property or Relationship: '.$lines[1].'<br/>';
			}
			
		}
		
		//Save the asset we were just working on.
		
		if (isset($as))
		{
			$assetdetails[$as['id']] = $as;
		}
		
		//Close the file
		
		fclose($file);
		
		//If importing Metadata only, this is a good point to stop.
		
		if (isset($_REQUEST['metadata']))
		{
			if (($_REQUEST['metadata'] == 1) || ($_REQUEST['metadata'] == 'on'))
			{
				$errors[] = "OK";
				$mdonly = true;
			}
		}
		
		if (count($errors) == 0)
		{
		
		$assetcount = 0;
		$propertycount = 0;
		
		$newassetid = 10000;
		
		//For each discovered asset...
		foreach($assetdetails as $ky => $ass)
		{
			//Create the asset itself...
			
			$existing = false;
			if (!isset($ass['realid']))
			{
				
				$desc = "";
				if (isset($ass['desc'])) $desc = $ass['desc'];
				$type = 0;
				if (isset($ass['_type']))
				{
					$type = $ass['_type'];
				}
				$qry = "INSERT INTO assets (name,descript,type) VALUES (".$db->quote($ass['name']).",".$db->quote($desc).",".$type.")";
				
				$assetcount++;
			
				if ($debug == false)
					$db->query($qry);
				else
					echo $qry.'<br/>';
												
				$id = $db->lastInsertId();
				if ($debug == true)
				{
					$id = $newassetid;
					$newassetid++;
				}
				
			}
			else
			{
				$id = $ass['realid'];
				$existing = true;
			}
				
			$assetdetails[$ky]['realid'] = $id;		
			$idmapping[$ky] = $id;
				
			if (isset($ass['properties']))
			{
				//Create property records		
				foreach($ass['properties'] as $k => $v)
				{	
					if (isset($v['_']))
					{
						$propertycount++;
						$qry = "INSERT INTO assetvalues (assetid, propertyid, value) VALUES (".$id.",".$k.",".$db->quote($v['_']).")";
					
						if ($debug == false)
						{
							$ast = new Asset($id);
							$ast->SetProperty($k,$v['_']);
						}
						else
							echo $qry.'<br/>';
					}
					else
					{
						//Loading property inputs to format correctly...
						
						if (isset($properties[$k]))
						{
						
							$typename = $properties[$k]['type'];
							
							$fn = $_SERVER['DOCUMENT_ROOT'].'/modules/inputs/'.strtolower($typename).'.php';
							if (file_exists($fn))
							{
								include($fn);				
							}
							
							$vx=0;
								
							$result = "";
							for($vx=0;$vx<count($inputs);$vx++)
							{
								if (isset($v[$inputs[$vx]['name']]))
								{
									if ($vx > 0) $result .= "|";
									$result .= $v[$inputs[$vx]['name']];
								}
								else
								{
									if (isset($inputs[$vx]['default']))
									{
										if ($vx > 0) $result .= "|";
										$result .= $inputs[$vx]['default'];
									}
									else
									{
										if ($vx > 0) $result .= "|";
									}
								}
							}
							
							$propertycount++;
							$qry = "INSERT INTO assetvalues (assetid, propertyid, value) VALUES (".$id.",".$k.",".$db->quote($result).")";
				
							if ($debug == false)
							{
								$ast = new Asset($id);
								$ast->SetProperty($k,$result);
							}
							else
								echo $qry.'<br/>';
								
						}
					}						
				}	
			}			
		}
		
		//Add 'Property References' between objects.
		//echo 'Processing References: ';
		//print_r($references);
		foreach($references as $refs)
		{
			$id = $refs['on'];
			if (isset($idmapping[$id]))
			{
				$id = $idmapping[$id];
			}
			
			$targ = $refs['to'];
			$tid = 0;
			foreach($assetdetails as $ad)
			{
				if ($ad['name'] == $targ)
				{
					$tid = $ad['id'];
					break;
				}
				if ($ad['refid'] == $targ)
				{
					$tid = $ad['refid'];
					break;
				}
			}
			
			if ($tid == 0)
			{
				//Get something from the EXISTING data...
				$query = $db->query('SELECT id FROM assets WHERE name='.$db->quote($targ));

				if($row = $query->fetch(PDO::FETCH_ASSOC))
				{
					$tid = $row['id'];
				}	
			}
			else
			{
				if (isset($idmapping[$tid])) $tid = $idmapping[$tid];
			}
			
			if ($tid == 0)
			{
				echo 'Invalid Data Link Source<br/>';
				continue;
			}
			
			$pid = 0;
			$targ = $refs['prop'];
			
			//Get Property Id...
			foreach($properties as $k => $v)
			{
				//echo 'Comparing '.$v['name'].' to '.$targ.'<br/>';
				if ($v['name'] == $targ)
				{
					$pid = $k;
					break;
				}
			}
			
			if (($pid == 0) || ($tid == 0))
			{
				if (!in_array($targ,$createdprops))
				{
					$errors[] = "Unable to find reference target";
					echo 'Reference Target Not Found - '.$pid.' - '.$tid.'<br/>';
				}
			}
			else
			{
				$qry = "INSERT INTO assetreferences (parentasset, childasset, childproperty) VALUES (".$id.','.$tid.','.$pid.")";
		
				if ($debug == false)
					$db->query($qry);
				else
					echo $qry.'<br/>';
			}
		}
		
		//Add Data Sources...
		foreach($datasources as $ds)
		{
			//Translate Options
			$port = 0;
			$mo = 1;
			$pro = 1;
			
			if ($ds[1] != 'hist')
			{
				$mo = 0;
			}
			
			foreach($profilelookup as $a => $b)
			{
				if ($b == $ds[0])
				{
					$pro = $a;
					break;
				}
			}
			
			//Try and find a suitable running driver...
			$query = $db->query('SELECT port FROM datadriver WHERE driver='.$db->quote($ds[2]).' AND mode='.$mo);
	
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$port = $row['port'];
			}
		
			//This is a data source! Create it here.
			//$bits = explode('|',$v);
			$qry = "INSERT INTO datasources (assetid, driver, address,profile,mode,gatewayport) VALUES (".$ds[4].",".$db->quote($ds[2]).",".$db->quote($ds[3]).",".$pro.",".$mo.",".$port.")";
	
			if ($debug == false)
				$db->query($qry);
			else
				echo $qry.'<br/>';
				
			
		}
		
		//echo 'Bindings: ';
		//print_r($bindings);
		
		//print_r($_REQUEST);
		
		//Create all data links
		foreach($bindings as $fb)
		{
			$src = $fb['source'];
			unset($sourceid);
			
			$bindcount++;
			
			//Does this exist in the imported data?
			foreach($assetdetails as $ad)
			{
				if ($ad['name'] == $src)
				{
					$sourceid = $ad['id'];
				}
			}
			
			if (!isset($sourceid))
			{
				//No source found - check database
				$query = $db->query('SELECT name,id FROM assets WHERE name='.$db->quote($src));
	
				if($row = $query->fetch(PDO::FETCH_ASSOC))
				{
					$sourceid = $row['id'];
				}	
			}
			
			$overridden = false;
			if (isset($_REQUEST['ovr_'.$fb['line']]))
			{
				$sourceid = $_REQUEST['ovr_'.$fb['line']];
				$overridden = true;
				//echo 'Using Override Source ID!';
				if ($sourceid == 0)
				{
					unset($sourceid);
				}
				else
				{
					//OK - format this puppy correctly....
					$stm = 'ovr_'.$fb['line'];
					$lv = strlen($stm);
					$param = array();
					$conflict = array();
					foreach($_REQUEST as $rk => $rv)
					{
						if (strlen($rk) > $lv)
						{
							if (substr($rk,0,$lv) == $stm)
							{
								$nm = substr($rk,$lv+1);
								if (isset($_REQUEST[$nm])) 
								{
									if (!isset($conflict[$nm]))
									{
										$conflict[$nm] = $_REQUEST[$nm];
									}
								}
								$param[substr($rk,$lv+1)] = $rv;
								//echo substr($rk,$lv+1).' = '.$rv.'<br/>';
							}
						}
					}
					
					//print_r($param);
					foreach($param as $rk => $rv)
					{
						$_REQUEST[$rk] = $rv;
					}
					
					$profile = 1;
					$mode = 0;
					$style = "live";
					if ($fb['live'] == false) 
					{
						$style="historical";
						$mode = 1;
					}
					
					//Get data source driver...
					$qry = 'SELECT driver FROM datasources WHERE assetid='.$sourceid.' AND mode='.$mode.' AND profile='.$profile;
					$query = $db->query($qry);
					if($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$driver = $row['driver'];
					}
					
					include($installfolder.'/data/'.$style.'/'.$driver.'/encode.php');
					//echo 'New Address: '.$internal;
					$fb['address'] = $internal;
					
					foreach($param as $rk => $rv)
					{
						if (!isset($conflict[$rk]))
						{
							unset($_REQUEST[$rk]);
						}
						else
						{
							$_REQUEST[$rk] = $conflict[$rk];
						}
					}
				}
			}
			
			if (isset($sourceid))
			{
				$mode = 0;
				if ($fb['live'] == false) $mode = 1;
				
				//Find a source ID that works well...
				$tid = 0;
				foreach($assetdetails as $ad)
				{
					if ($ad['name'] == $fb['asset'])
					{
						$tid = $ad['id'];
						break;
					}
				}
				
				if ($tid == 0)
				{
					//Get something from the EXISTING data...
					$query = $db->query('SELECT id FROM assets WHERE name='.$db->quote($fb['asset']));
	
					if($row = $query->fetch(PDO::FETCH_ASSOC))
					{
						$tid = $row['id'];
					}	
				}
				else
				{
					if (isset($idmapping[$tid])) $tid = $idmapping[$tid];
				}
				
				if ($tid == 0)
				{
					echo 'Invalid Data Link Source<br/>';
					continue;
				}
				
				$qry = "INSERT INTO datalinks (sourceid,assetid, propertyid, node, address, transform, profile, mode) VALUES (".$sourceid.",".$tid.",".$fb['property'].",".$db->quote($fb['node']).",".$db->quote($fb['address']).",".$db->quote($fb['transform']).",".$profilelookup[$fb['profile']].",".$mode.")";
			
				if ($debug == false)
					$db->query($qry);
				else
					echo $qry.'<br/>';
				$bindcount++;
			}
			else
			{
				if ($overridden = false)
					$errors[] = 'Unable To find suitable data source for an asset.';
			}
		}
		
		//Create all relationships...
		$toprocess = array();
	
		$linkcount = 0;
		
		foreach($relations as $k => $v)
		{
			//echo $k;
			//print_r($v);
			foreach($v as $itm)
			{
				$tid = 0;
				if (isset($itm['targetid'])) $tid = $itm['targetid'];
				
				if (isset($itm['target']))
				{
					//echo $assetdetails[$k]['name'].' is a '.$itm['relationship'].' child of '.$itm['target'].'<br/>';
					foreach($assetdetails as $ad)
					{
						if ($ad['name'] == $itm['target'])
						{
							$tid = $ad['name'];
							break;
						}
					}
				}
				
				if ($tid == 0)
				{
					//Get something from the EXISTING data...
					$query = $db->query('SELECT id FROM assets WHERE name='.$db->quote($ad['name']));
	
					if($row = $query->fetch(PDO::FETCH_ASSOC))
					{
						$tid = $row['id'];
					}	
				}
				else
				{
					if (isset($idmapping[$tid])) $tid = $idmapping[$tid];
				}
				
				if ($itm['relationship'] == $_REQUEST['parentrelationship'])
				{
					$assetdetails[$k]['hasbase'] = true;
				}
				
				//echo 'Checking Override '.'ovr_'.$itm['line'].'_in'.'<br/>';
				if (isset($_REQUEST['ovr_'.$itm['line'].'_in']))
				{
					//echo 'Using Override Item ID';
					$tid = $_REQUEST['ovr_'.$itm['line'].'_in'];
				}
				
				if ($tid != 0)
				{
					$linkcount++;
					//Bingo - this is attached to an existing database asset! Link it, and use it as the root of the next phase...			
					if ($debug == false)
						Relationships::Add($tid,$idmapping[$k],$itm['relationship']);
					else
						echo 'Linking Existing Item '.$tid.' and '.$idmapping[$k].' ('.$k.')<br/>';
				}	
				else
				{
					if ($debug == true)
						echo 'Invalid Relationship In '.$assetdetails[$k]['name'].' - Can Not Find A Matching Asset<br/>';
					
					$errors[] = 'Invalid Relationship In '.$assetdetails[$k]['name'].' - Can Not Find A Matching Asset<br/>';
				}
					
			}
		}
				
		//Try to get a rough sequence to avoid excessive database updates
		/*$depth = 0;
		$changes = true;
		while($changes == true)
		{
			$changes = false;
			$thispass = array();
			
			foreach($toprocess as $k => $tp)
			{
				foreach($tp as $p)
				{
					if (!isset($toprocess[$p['internal']])) continue;
					if ($p['queue'] <= $toprocess[$p['internal']]['queue'])
					{
						$p['queue'] = $toprocess[$p['internal']]['queue'] + 1;
						$changes = true;
					}
				}
			}
			
			$depth++;
			if ($depth > 20)
			{
				$err = true;
				break;
			}
		}*/
		
		if (isset($err))
		{
			echo 'Possible Circular Reference';
		}
		
		echo '<br/><br/>';
		
		//print_r($toprocess);
		
		//Save new relationships
		foreach($toprocess as $k => $tp)
		{
			/*echo 'Processing...'.$k;
			print_r($tp);
			echo '<br/>';*/
			
			foreach($tp as $p)
			{
				$relcount++;				
				if ($debug == false)
					Relationships::Add($assetdetails[$p['internal']]['id'],$assetdetails[$k]['id'],$p['type']);				
				else
					echo 'Linking New Item '.$assetdetails[$p['internal']]['id'].' ( '.$p['internal'].' ) and '.$assetdetails[$k]['id'].' ( '.$k.' ) via '.$p['type'].'<br/>';
			};
			
		}
		}
		
		include ($installfolder.'/include/updaterelcache.php');
		
		/*foreach($assetdetails as $ad)
		{
			if (!isset($ad['hasbase']))
			{
				if ($debug == false) Relationships::Add($_REQUEST['parentbase'],$ad['id'],$_REQUEST['parentrelationship']);				
				//require($installfolder.'/pages/asset/link.php');
			}
		}*/
		
		//$errorscan = false;
		//$cx = ob_get_clean();
		//echo $cx;
		//exit;
		if ($errorscan == true)
		{
			if (isset($exportlocation))
			{
				print_r($_REQUEST);
				$cx = ob_get_clean();
				echo $cx;
				exit;
			}
		}
		if ($errorscan == true)
		{
			$ok = true;
			if ((count($errors) > 0) && ((count($errors) > 1) || ($errors[0] != "OK"))) $ok = false;
			$content = ob_get_clean();
			
			$title = "Import File Check";

			require_once($basefolder.'/include/tmpl.php');
			
			T('header-basic','title='.$title);

			ST('section','class=content');
				ST('row');
					ST('half');
						ST('boxform','title=Import Test Results');
						if ($ok == true) echo '<input type="submit" class="btn btn-default" value="Import Assets"/>&nbsp;&nbsp;';
						echo '<a href="/" class="btn btn-default">Cancel</a>';
						echo '<input type="hidden" name="commit" value="1"/>';
						echo '<input type="hidden" name="metadata" value="';
						if ($mdonly == true) 
							echo 'on';
						else
							echo 'off';
						echo '"/>';
						echo '<input type="hidden" name="mode" value="'.$_REQUEST['mode'].'"/>';
						SS('footer');
			
			if ($ok == false)
			{
				echo '<h3>There Are Errors In Your Import File</h3>';
				
				echo '<ul>';
				foreach($errors as $err)
				{
					echo '<li>'.$err."</li>";
				}
				echo '</ul>';
				$ok = false;
			}
			else
			{
				echo '<h3>Press &quot;Import&quot; To Finalise</h3>';
				echo '<p><strong>This will create...</strong><ul>';
				echo '<li>'.$relcount.' Relationships</li>';
				echo '<li>'.$propcount.' Properties</li>';
				if ($mdonly == false) { 
				echo '<li>'.$assetcount.' Assets, with '.$propertycount.' values ( '.$bindcount.' linked to external data ) and</li>';
				echo '<li>'.$linkcount.' Connections</li>';
				};
				echo '</ul>';
			};
						ET();
					ET();
					ST('half');
						ST('box-collapsible','title=Details|collapsed=1');
							echo $content;
						ET();
					ET();
				ET();
			ET();
		}
		else
		{
			echo 'Import Complete!';
			header('Location: '.$siteroot.'/');
		}
	
?> 