<?php

	header("Content-Type: application/vnd.google-earth.kml+xml");
	
	include($_SERVER['DOCUMENT_ROOT'].'/include/dataaccess.php');
	include($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
	
	$query = $db->query("SELECT id FROM properties WHERE typename='GPS'");
		    				
    if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$gpsprop = $row['id'];
	}
	
	if (!isset($gpsprop))
	{
		$title = "No GPS Property";
		include($installfolder.'/include/tmpl.php');
		PageError('No GPS Property','There is no GPS location property in your ARDI database. A system administrator should be able to add the \'GPS\' property.');
		exit;
	}

	$assetset = array();
	$query = $db->query("SELECT id,name,value FROM assets JOIN assetvalues ON (assetvalues.assetid = assets.id) WHERE assetvalues.propertyid = ".$gpsprop);
	
	//echo "SELECT id,name,value FROM assets JOIN assetproperties ON (assetproperties.assetid = assets.id) WHERE assetproperties.propertyid = ".$gpsprop;
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$assetset[$row['id']] = $row;
	}
	
	if (count($assetset) == 0)
	{
		$title = "No GPS Assets";
		include($installfolder.'/include/tmpl.php');
		PageError('No Assets with GPS','You have no assets with a GPS coordinate property. Give some assets a location and try again.');
		exit;
	}
	
	//$done = array($itemid);
	$done = array();
	global $done;

	
	/*function LoadPoints($id,$dir, $depth, $parent,$parentloc)
	{
		global $asset;
		global $rel;
		global $done;
		
		if (($depth > 0) && (in_array($id,$done))) return;
		
		$done[] = $id;
		
		if (!isset($asset[$id]))
		{		
			require_once($sitefolder.'/cache/relationships/'.$id.'.inc');
		}
		
		$loc = $parentloc;
		
		//echo '<!--Moving To '.$id.'-->';
		if ($depth != 0)
		{
			$valarray = GetValueByType($id,'GPS');
			
			if ((count($valarray) != 0) && ($valarray['latitude'] != ""))
			{
				$loc = $valarray['latitude'].','.$valarray['longitude'];
			?>
			<Placemark>
		<name><?php echo $asset[$id]['name'];?></name>
		<description> <![CDATA[
        
          <p><a href="http://<?php echo $_SERVER['SERVER_NAME'].'/assets/ddashboard.php?id='.$id;?>">View Dashboard</a><br/>
		  <a href="http://<?php echo $_SERVER['SERVER_NAME'].'/assets/dpid.php?id='.$id;?>">View Diagram</a></p>
		  
        ]]>
		</description>
		
		<Point>
		  <coordinates><?php echo $loc;?></coordinates>
		</Point>
		
	  </Placemark>
	  <Placemark>
		<styleUrl>#relLine</styleUrl>
		<LineString>
			<extrude>1</extrude>
			<tessellate>1</tessellate>
			<altitudeMode>relative</altitudeMode>
			<coordinates> <?php echo $parentloc;?>,
			  <?php echo $loc;?>
			</coordinates>
		</LineString>
	  </Placemark>
	  <?php
			}
		}
		
		if (($rel == 0) && ($depth == 0))
		{
			foreach($asset[$id]['relationships'] as $k => $v)
			{
				foreach($v as $rl)
				{
					LoadPoints($rl['target'],$dir,$depth+1,$id,$loc);
				}
			}
		}
		else
		{
			if (isset($asset[$id]['relationships'][$rel]))
			{
				foreach($asset[$id]['relationships'][$rel] as $rl)
				{
					if ($rl['upstream'] == $dir) LoadPoints($rl['target'],$dir,$depth+1,$id,$loc);
				}
			}
		}
		
	}*/
	
?><?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.1">
  <Document>
    <name>ARDI Asset Map</name>
    <description><![CDATA[This map shows all large items in your ARDI database]]></description>

    <Style id="relLine">
      <LineStyle>
        <color>ffff0000</color>
        <width>4</width>
      </LineStyle>
    </Style>

	<?php
	foreach($assetset as $as)
	{
		$ast = new Asset($as['id']);?>
		<Placemark>
		<name><?php echo $as['name'];?></name>
		<description> <![CDATA[
        
          <p><a href="http://<?php echo $_SERVER['SERVER_NAME'].$siteroot.'/dashboard/'.$as['id'];?>">View Dashboard</a><br/>
		  <a href="http://<?php echo $_SERVER['SERVER_NAME'].$siteroot.'/diagram/'.$as['id'];?>">View Diagram</a></p>
		  
        ]]>
		</description>
		
		<Point>
		<?php
		$bits = explode("|",$as['value']); 
		$lat = $bits[0];
		$lon = $bits[1];?>
		
		  <coordinates><?php echo $lon; ?>,<?php echo $lat; ?>,0</coordinates>
		</Point>
		
	  </Placemark><?php
	} ?>	

  </Document>
</kml>