<?php

require_once($installfolder.'/include/simpletest/autorun.php');
require_once($installfolder.'/model/asset.php');
require_once($installfolder.'/include/creator.php');
//require_once($installfolder.'/include/deletor.php');

function CheckAssetExists($name)
{
	global $db;
	
	$query = $db->query("SELECT id FROM assets WHERE name='".$name."'");

	$id = -1;
	$already = false;
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($already == false)
		{
			$already = true;
			$id = $row['id'];
		}
		else
		{
			echo 'Excessive Results!';
			$id = -1;
			return false;
		}
	}	
	
	return $id;
}

function CheckDirectRelationship($assetid, $toid)
{
	return true;
}

function CheckClosureTable($assetid, $list)
{
	return true;
}

class TestAssetCreationFunctions extends UnitTestCase
{	
	public $itemid = 0;
	
	/**
	* Ensure that basic addition of new assets works correctly.
	*/
	function testAssetCreationBasic() {   
		global $db;     
		
		echo 'Asset Creation - Simple<br/>';
		
		$_SESSION['userid'] = 1;
        $this->assertEqual(CheckAssetExists('Building A'),-1);	
		
		//echo 'Adding Item..';
		$this->itemid = CreateAssetAfter('Building A','A Single Building On Site',5,2);
		//echo 'Created New Asset '.$this->itemid;
        $this->assertNotEqual(CheckAssetExists('Building A'),-1);	
		
		//Load Direct Relationships...
		$rellist = array();
		$query = $db->query("SELECT * FROM assetrelationships WHERE childasset=".$this->itemid);
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$rellist[] = $row;
			}
		}
		
		//print_r($rellist);
		
		$this->assertTrue(count($rellist) == 1);
		$this->assertTrue($rellist[0]['parentasset'] == 5);
		
		//Load Closures
		$rellist = array();
		$query = $db->query("SELECT * FROM assetrelclosures WHERE childasset=".$this->itemid);
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$rellist[] = $row;
			}
		}
		
		//print_r($rellist);
		$this->assertTrue(count($rellist) == 2);
		$this->assertTrue(($rellist[0]['parentasset'] == 5) || ($rellist[1]['parentasset'] == 5));
    }	
	
	/**
	* Ensure that basic deletion of existing assets works correctly.
	*/
	function testAssetDeletionBasic() {   
		global $db;     
		$this->assertNotEqual(CheckAssetExists('Building A'),-1);

		echo 'Asset Erasure - End Of Chain<br/>';		
		
		$ast = new Asset($this->itemid);
		$ast->Delete();
		$this->assertEqual(CheckAssetExists('Building A'),-1);	       
    }	
	
	/**
	* Ensure that basic addition of new assets works correctly.
	*/
	function testClosureTables() {    
	   
		global $db; 
		
		echo 'Asset Basic Closure Table Maintenance<br/>';
		
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');
        $this->assertEqual(CheckAssetExists('First Asset'),-1);	
		$this->itemone = CreateAssetAfter('First Asset','This is the first in a sequence',5,2);
        $this->assertNotEqual(CheckAssetExists('First Asset'),-1);	
		
		$this->assertEqual(CheckAssetExists('Second Asset'),-1);	
		$this->itemtwo = CreateAssetAfter('Second Asset','This is the second in a sequence',$this->itemone,2);
        $this->assertNotEqual(CheckAssetExists('Second Asset'),-1);	
		
		$this->assertEqual(CheckAssetExists('Third Asset'),-1);	
		$this->itemthree = CreateAssetAfter('Third Asset','This is the third in a sequence',$this->itemtwo,2);
        $this->assertNotEqual(CheckAssetExists('Third Asset'),-1);	
		
		$this->assertEqual(CheckAssetExists('Fourth Asset'),-1);	
		$this->itemfour = CreateAssetAfter('Fourth Asset','This is the fourth and final asset in the sequence',$this->itemthree,2);
        $this->assertNotEqual(CheckAssetExists('Fourth Asset'),-1);	
						
		//Load Closures
		$rellist = array();
		$query = $db->query("SELECT * FROM assetrelclosures WHERE childasset=".$this->itemthree);
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$rellist[] = $row;
			}
		}
		
		//print_r($rellist);
		
		$hits = array();
		$this->assertTrue(count($rellist) == 4);
		foreach($rellist as $itm)
		{
			if ($itm['parentasset'] == 5) 
			{
				$this->assertTrue($itm['depth'] == 1);
			}
			if ($itm['parentasset'] == $this->itemone) 
			{
				$this->assertTrue($itm['depth'] == 2);
			}
			if ($itm['parentasset'] == $this->itemtwo) 
			{
				$this->assertTrue($itm['depth'] == 3);
			}
			$hits[] = $itm['parentasset'];
		}
		$this->assertTrue(in_array(5,$hits) && in_array($this->itemone,$hits) && in_array($this->itemtwo,$hits));
    }	
	
	/**
	* Insert an asset midway between two existing assets
	*/	
	
	/*function testAssetCreationInsert() {       
		global $db; 
        $this->assertEqual(CheckAssetExists('Inserted Asset'),-1);	
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');
		$this->itemid = CreateAssetBefore('Inserted Asset','This has been squeezed into place!',5,$this->itemone,1);
        $this->assertNotEqual(CheckAssetExists('Inserted Asset'),-1);	
		
		//Load Closures for the New Asset
		$rellist = array();
		$query = $db->query("SELECT * FROM assetrelclosures WHERE childasset=".$this->itemid);
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$rellist[] = $row;
			}
		}
						
								
		$this->assertTrue(count($rellist) == 2);
		$this->assertTrue(($rellist[0]['parentasset'] == 5) || ($rellist[1]['parentasset'] == 5));
		$this->assertTrue(($rellist[0]['parentasset'] == 2) || ($rellist[1]['parentasset'] == 2));
		
		$rellist = array();
		$query = $db->query("SELECT * FROM assetrelclosures WHERE childasset=".$this->itemthree);
		if ($query !== FALSE)
		{
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$rellist[] = $row;
			}
		}		
		
		$hits = array();
		$this->assertTrue(count($rellist) == 5);
		foreach($rellist as $itm)
		{
			if ($itm['parentasset'] == 5) 
			{
				$this->assertTrue($itm['depth'] == 1);
			}
			if ($itm['parentasset'] == $this->itemid) 
			{
				$this->assertTrue($itm['depth'] == 2);
			}
			if ($itm['parentasset'] == $this->itemone) 
			{
				$this->assertTrue($itm['depth'] == 3);
			}
			if ($itm['parentasset'] == $this->itemtwo) 
			{
				$this->assertTrue($itm['depth'] == 4);
			}
			$hits[] = $itm['parentasset'];
		}
		$this->assertTrue(in_array(2,$hits) && in_array(5,$hits) && in_array($this->itemid,$hits) && in_array($this->itemone,$hits) && in_array($this->itemtwo,$hits));
    }*/
}

?>