<?php
require_once($installfolder.'/include/simpletest/autorun.php');
require_once($installfolder.'/include/simpletest/web_tester.php');

//session_start();

class TestConfiguration extends WebTestCase
{
	//This test case checks to see if a backup is executed as expected.
	function testBlankDB() {        	
		global $db;	
		global $installfolder;
		global $sitefolder;
		$empty = file_get_contents($installfolder.'/sites/blankdb.sql');
		
		if (strpos($sitefolder,'/_test') === FALSE)
		{
			$this->assertTrue(false);
			return;
		}
		else
		{
			$this->assertTrue(true);
		}
		
		
		//Drop all tables...
		$sql = "SET FOREIGN_KEY_CHECKS = 0; 
		SET GROUP_CONCAT_MAX_LEN=32768;
		SET @tables = NULL;
		SELECT GROUP_CONCAT('`', table_name, '`') INTO @tables
		  FROM information_schema.tables
		  WHERE table_schema = (SELECT DATABASE());
		SELECT IFNULL(@tables,'dummy') INTO @tables;
		
		SET @tables = CONCAT('DROP TABLE IF EXISTS ', @tables);
		PREPARE stmt FROM @tables;
		EXECUTE stmt;
		DEALLOCATE PREPARE stmt;
		SET FOREIGN_KEY_CHECKS = 1;";
		
		$db->query($sql);
		
		$db->query($empty);
		
		$query = $db->query("SELECT COUNT(*) as Cnt FROM assets");
		
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$acount = $row['Cnt'];
		}
		
		$this->assertTrue($acount == 4);
		
		$files = glob($sitefolder.'/cache/relationships/*'); // get all file names
		foreach($files as $file){ // iterate files
		  if(is_file($file))
			unlink($file); // delete file
		}
		
    }	
	
	function TestBasicUpdateCache()
	{
		global $siteroot;
		global $db;    	
		global $sitefolder;		
		global $installfolder;
		@unlink($sitefolder.'/cache/relationships/all.inc');
		@unlink($sitefolder.'/cache/relationships/properties.inc');
		
		$this->assertFalse(file_exists($sitefolder.'/cache/relationships/all.inc'));
		$this->assertFalse(file_exists($sitefolder.'/cache/relationships/properties.inc'));
		
		$background = true;
		include($installfolder.'/pages/admin/tools/cacherebuild.php');
		
		$this->assertTrue(file_exists($sitefolder.'/cache/relationships/all.inc'));
		$this->assertTrue(file_exists($sitefolder.'/cache/relationships/properties.inc'));
	}
	
	function TestWebUpdateCache()
	{	
		global $siteroot;
		global $sitefolder;
		$this->get('http://localhost'.$siteroot.'/admin/tools/cacherebuild');
		
		$this->assertResponse(401);
		
		$this->assertTrue(file_exists($sitefolder.'/cache/relationships/5.inc'));
	}
}