<?php

include($installfolder.'/include/simpletest/autorun.php');
include($installfolder.'/model/asset.php');
require_once($installfolder.'/include/creator.php');
require_once($installfolder.'/include/deletor.php');

function PostForm($url,$params)
{
	global $siteroot;
	
	$fields_string = "";
	$fields = array();
	$bits = explode('^',$params);
	foreach($bits as $b)
	{
		$p = explode('=',$b);
		$fields[$p[0]] = $p[1];
	}
	$url = 'http://localhost'.$siteroot.$url;

	//url-ify the data for the POST
	foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
	$fields_string = substr($fields_string,0,strlen($fields_string)-1);

	//echo ($url).'<br/>';
	//echo ($fields_string).'<br/>';
	//open connection
	$ch = curl_init();

	//set the url, number of POST vars, POST data
	curl_setopt($ch,CURLOPT_URL, $url);
	curl_setopt($ch,CURLOPT_POST, count($fields));
	curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 

	//execute post
	$result = curl_exec($ch);
	
	//print_r(curl_getinfo($ch));

	//close connection
	curl_close($ch);
	return $result;
}

function CheckAssetExists($name)
{
	global $db;
	
	$query = $db->query("SELECT id FROM assets WHERE name='".$name."'");

	$id = -1;
	$already = false;
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($already == false)
		{
			$already = true;
			$id = $row['id'];
		}
		else
		{
			echo 'Excessive Results!';
			$id = -1;
			return false;
		}
	}	
	
	return $id;
}

function CheckDirectRelationship($assetid, $toid)
{
	return true;
}

function CheckClosureTable($assetid, $list)
{
	return true;
}

class TestAssetCreationFunctions extends UnitTestCase
{	
	private $relno = 0;
	private $prop = 0;
	
	function testAddProperty() {    
	   
	   echo 'Properties - Addition<br/>';
	   
	   //Call the local administrative interface...
	   $_SESSION['userid'] = 1;
	   $_SESSION['useradmin'] = true;
	   $_SESSION['useredit'] = true;
	   session_write_close();
	   
	   $rs = PostForm('/admin/properties/update','name=Flowing^type=STATUS^ontext=Yes&offtext=No^flowsdown='.$this->relno.'^override=true');
	   //echo 'Output: '.$rs;
	   
	   global $db;
	   
		$any = false;
		$query = $db->query("SELECT * FROM properties WHERE name=".$db->quote('Flowing'));
		if ($query !== FALSE)
		{
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$any = true;
				$this->prop = $row['id'];
			}
		}
		
		$this->assertEqual($any,true);
		
	}
	
	function testAssignProperty() {    
	   
		global $db; 
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
		
		echo 'Properties - Add Property to Asset<br/>';
        
		$upper = CheckAssetExists('First Asset');
		$this->assertNotEqual($upper,-1);
		
		$ast = new Asset($upper);
		$ast->SetProperty($this->prop,'0|No|Yes');
		$ast->UpdateCache();
		
		$props = $ast->GetProperties();
		$ast->GetValues($props);
		
		$this->assertEqual(count($props),2);
		print_r($props);
		$this->assertEqual($props[1]->value['state'],'0');
		$this->assertEqual($props[1]->value['on'],'Yes');
		$this->assertEqual($props[1]->value['off'],'No');
		
	}
}

?>