<?php

include($installfolder.'/include/simpletest/autorun.php');
include($installfolder.'/model/asset.php');
require_once($installfolder.'/include/creator.php');
require_once($installfolder.'/include/deletor.php');

function PostForm($url,$params)
{
	global $siteroot;
	
	$fields_string = "";
	$fields = array();
	$bits = explode('^',$params);
	foreach($bits as $b)
	{
		$p = explode('=',$b);
		$fields[$p[0]] = $p[1];
	}
	$url = 'http://localhost'.$siteroot.$url;

	//url-ify the data for the POST
	foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
	$fields_string = substr($fields_string,0,strlen($fields_string)-1);

	//echo ($url).'<br/>';
	//echo ($fields_string).'<br/>';
	//open connection
	$ch = curl_init();

	//set the url, number of POST vars, POST data
	curl_setopt($ch,CURLOPT_URL, $url);
	curl_setopt($ch,CURLOPT_POST, count($fields));
	curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 

	//execute post
	$result = curl_exec($ch);
	
	//print_r(curl_getinfo($ch));

	//close connection
	curl_close($ch);
	return $result;
}

function CheckAssetExists($name)
{
	global $db;
	
	$query = $db->query("SELECT id FROM assets WHERE name='".$name."'");

	$id = -1;
	$already = false;
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($already == false)
		{
			$already = true;
			$id = $row['id'];
		}
		else
		{
			echo 'Excessive Results!';
			$id = -1;
			return false;
		}
	}	
	
	return $id;
}

function CheckDirectRelationship($assetid, $toid)
{
	return true;
}

function CheckClosureTable($assetid, $list)
{
	return true;
}

class TestAssetCreationFunctions extends UnitTestCase
{	
	private $relno = 0;

	function testAddRelationship() {    
	   
	   echo 'Relationships - Addition<br/>';
	   
	   //Call the local administrative interface...
	   $_SESSION['userid'] = 1;
	   $_SESSION['useradmin'] = true;
	   $_SESSION['useredit'] = true;
	   session_write_close();
	   
	   $rs = PostForm('/admin/relationships/update','name=Water Supply^usname=Supplied By^dsname=Supplies^type=0^colour=0^override=true');
	   //echo 'Output: '.$rs;
	   
	   global $db;
	   
		$any = false;
		$query = $db->query("SELECT * FROM relationships WHERE name=".$db->quote('Water Supply'));
		if ($query !== FALSE)
		{
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$this->relno = $row['id'];
				$any = true;
			}
		}
		
		$this->assertEqual($any,true);
		
	}
	
	function testAddProperty() {    
	   
	   echo 'Properties - Addition<br/>';
	   
	   //Call the local administrative interface...
	   $_SESSION['userid'] = 1;
	   $_SESSION['useradmin'] = true;
	   $_SESSION['useredit'] = true;
	   session_write_close();
	   
	   $rs = PostForm('/admin/properties/update','name=Temperature - Water^type=MEASUREMENT^flowsdown=7^units=Deg C^minrange=0^maxrange=100^dp=0^display=ZeroBased^flowsdown='.$this->relno.'^override=true');
	   //echo 'Output: '.$rs;
	   
	   global $db;
	   
		$any = false;
		$query = $db->query("SELECT * FROM properties WHERE name=".$db->quote('Temperature - Water'));
		if ($query !== FALSE)
		{
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$any = true;
				$this->prop = $row['id'];
			}
		}
		
		$this->assertEqual($any,true);
		
	}

	function testAssignProperty() {    
	   
		global $db; 
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
		
		echo 'Properties - Add Property to Asset<br/>';
        
		$upper = CheckAssetExists('First Asset');
		$this->assertNotEqual($upper,-1);
		
		$ast = new Asset($upper);
		$ast->SetProperty($this->prop,'0| Deg C|0|100|1');
		$ast->UpdateCache();
		
		$props = $ast->GetProperties();
		$ast->GetValues($props);
		
		$this->assertEqual(count($props),1);
		$this->assertEqual($props[0]->value['units'],' Deg C');
		$this->assertEqual($props[0]->value['min'],'0');
		$this->assertEqual($props[0]->value['max'],'100');
		$this->assertEqual($props[0]->value['measurement'],'0');
		
	}
	
	function testPropertyNotFlowing() {    
	   
		global $db; 
		require_once($_SERVER['DOCUMENT_ROOT'].'/include/creator.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
		
		echo 'Properties - Add Property to Asset<br/>';
        
		$upper = CheckAssetExists('Second Asset');
		$this->assertNotEqual($upper,-1);
		
		$ast = new Asset($upper);
		$props = $ast->GetProperties();
		$ast->GetValues($props);
		
		$this->assertEqual(count($props),0);
		
		
	}
	
	function testAddRelBetweenAssets() {    
	   
	   echo 'Relationships - Adding Physical Relationships<br/>';
	   
	   require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
	   
	   //Call the local administrative interface...
	   $_SESSION['userid'] = 1;
	   $_SESSION['useradmin'] = true;
	   $_SESSION['useredit'] = true;
	   session_write_close();
	   
	   $upper = CheckAssetExists('First Asset');
	   $lower = CheckAssetExists('Second Asset');
	   
	   global $db;
	   
		$any = false;
		$query = $db->query("SELECT * FROM relationships WHERE name=".$db->quote('Water Supply'));
		if ($query !== FALSE)
		{
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$this->relno = $row['id'];
				$any = true;
			}
		}
		
		Relationships::Add($upper,$lower,$this->relno);
		//echo 'Added Relationship - '.$this->relno.'<br/>';
	   
		$ast = new Asset($lower);
		//$ast->UpdateCache();
		$rels = $ast->GetRelationships();
		   
		//print_r($rels);
			
		$this->assertEqual(count($rels),2);
		
	}
	
	function testFlowing() {    
	   
		echo 'Relationships - Check Flow Between Assets<br/>';
		global $sitefolder;
		global $relationships;
		   
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
		   
		$lower = CheckAssetExists('Second Asset');
		   
		include($sitefolder.'/cache/relationships/all.inc');
		   
		$ast = new Asset($lower);
		$props = $ast->GetProperties();
		$ast->GetValues($props);
		
	    $this->assertEqual(count($props),1);
		$this->assertEqual($props[0]->value['units'],' Deg C');
		$this->assertEqual($props[0]->value['min'],'0');
		$this->assertEqual($props[0]->value['max'],'100');
		$this->assertEqual($props[0]->value['measurement'],'0');
		$this->assertEqual($props[0]->value['places'],'1');
		$this->assertEqual($props[0]->origin,7);
		$this->assertEqual($props[0]->origintype,'secondary');
		
	}
	
	function testMultiFlowing() {    
	   
		echo 'Relationships - Check Flow Between Multiple Assets<br/>';
		global $sitefolder;
		global $relationships;
		   
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
		   
		$lower = CheckAssetExists('Third Asset');
		$upper = CheckAssetExists('Second Asset');
		
		global $db;
	   
		$query = $db->query("SELECT * FROM relationships WHERE name=".$db->quote('Water Supply'));
		if ($query !== FALSE)
		{
			if($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$this->relno = $row['id'];
			}
		}
		
		Relationships::Add($upper,$lower,$this->relno);
		   
		include($sitefolder.'/cache/relationships/all.inc');
		   
		$ast = new Asset($lower);
		$props = $ast->GetProperties();
		$ast->GetValues($props);
		
	    $this->assertEqual(count($props),1);
		$this->assertEqual($props[0]->value['units'],' Deg C');
		$this->assertEqual($props[0]->value['min'],'0');
		$this->assertEqual($props[0]->value['max'],'100');
		$this->assertEqual($props[0]->value['measurement'],'0');
		$this->assertEqual($props[0]->value['places'],'1');
		$this->assertEqual($props[0]->origin,7);
		$this->assertEqual($props[0]->origintype,'secondary');
		
	}
	
	function testMonitors() {    
	   
		echo 'Relationships - Check Monitors Relationship<br/>';
		global $sitefolder;
		global $relationships;
		   
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/asset.php');
		require_once($_SERVER['DOCUMENT_ROOT'].'/model/relationship.php');
		
		$lower = CheckAssetExists('Third Asset');
		//$upper = CheckAssetExists('Second Asset');
		
		$newitem = CreateAssetAfter('Tertiary Asset','An Outlier Asset',$lower,2);
		$ass = new Asset($newitem);
		
		$ass->SetProperty($this->prop,'25| Deg C|0|100|1');
		Relationships::Add($newitem,$lower,6);
		   
		$ast = new Asset($lower);
		$props = $ast->GetProperties();
		$ast->GetValues($props);
		
		print_r($props);
		
	    $this->assertEqual(count($props),1);
		$this->assertEqual($props[0]->value['units'],' Deg C');
		$this->assertEqual($props[0]->value['min'],'0');
		$this->assertEqual($props[0]->value['max'],'100');
		$this->assertEqual($props[0]->value['measurement'],'25');
		$this->assertEqual($props[0]->value['places'],'1');
		$this->assertEqual($props[0]->origin,$newitem);
		$this->assertEqual($props[0]->origintype,'monitors');
		
	}
	
	
}

?>